-------------------------------------------------
Changes in release mega-20260720 (since mega-20260125)
-------------------------------------------------

Release date: ma 20 jul 2026 13:16:21 CEST

Gijs Noorlander (9):
      [MFRC522] Speedup reading tag
      [network] Fix wifi#connected and wifi#disconnected events
      [network] Fix typo in event
      [Network] Add AT command write to PPP modem
      [Network] Add connected/disconnected event handling for all interfaces
      [network] Reduce CPU load + fix init NW interface event names
      [MQTT] Fix merge issues
      [Build] Change ESP8266 normal and collection builds to core 3.1.2
      [Build] Enable BUILD_NO_DEBUG for 2nd heap ESP8266 normal builds

TD-er (611):
      [WiFi] Split WiFi code specific for ESP8266 and ESP32
      [Cleanup] Get rid of ESP32-IDF code for IDF3.x or older
      [Cleanup] Fix spelling error in filename
      [WiFi] First part of moving code around to restructure WiFi code
      [WiFi] Start using simplified state machine for WiFi
      [WiFi] Restructure ESP32/ESP8266 code
      [WiFi] Allow connecting to hidden SSID network
      [WiFi] Fix build issue due to enum naming conflict
      [IPv6] Disable IPv6 for ESP32-C2
      [PSRAM] Free GPIO-16 and -17 on ESP32-classic when no PSRAM present
      [PSRAM] Fix build on ESP-IDF 5.1 + add special case of ESP32-picoD4
      [PSRAM] Cleanup code
      [PSRAM] Fix solo1 builds
      [WiFi] Add some debug log to track GotIP event
      [WiFi] Fix not showing /setup page
      [WiFi] Update to latest ESP-IDF SDK + handle gotIP event on ESP8266
      [WiFi] Fix event handling for WiFi on ESP32
      [WiFi] Fix start AP for setup
      [WiFi] Call WiFi_AP_Candidates.force_reload() on saving security setting
      [PSRAM] Use PSRAM for logs, events and controller queues
      [Memory] Fix freeing of allocated strings
      [Memory] Add small optimization in free_string() to prevent copying
      [ESP-IDF] Update to latest Arduino 3.1.2 for LittleFS builds
      [ESP-SDK] Update to ESP32/Arduino 3.1.3
      [ESPEasy p2p] Add node-IDs for new Espressif SoC models
      [WiFi] Fix processing connected event
      [ESP8266] Fix crash on processing log with weblog enabled.
      [Cleanup] Simplify generating sysinfo page
      [ESP8266] Fix crash on ESP8266 SDK 2.7.4
      [ESP8266] Balance more what should be allocated on 2nd heap
      [Build] Fix build issues on ESP32-xx
      [Memory] Make memory allocation on ESP8266 2nd heap more stable
      [Memory] Move C001 and C002 queue elements to 2nd heap (ESP8266)
      [Memory] Move other controller queue elements to 2nd heap (ESP8266)
      [ESP32S3] Fix bootloop on ESP32S3 with OPI PSRAM
      [WiFi] Fix not setting wifi as initialized too often
      [Memory] Improve memory usage on Strings and task data
      [Memory] Fix crashes on ESP32-S2 with 8M PSRAM
      [WiFi] Fix setting dynamic WiFi TX power
      [Cleanup] Optimize parsing system variables
      [Rules] Fix broken math parsing
      [WiFi] Fix (re-)connecting after WiFi connection lost
      [WiFi] Fix build error on ESP8266
      [Cleanup] Uncrustify WiFi/Network code
      [WiFi] Fix reconnecting + WiFi scan
      [ESP-IDF5.4] Prepare for ESP-IDF5.4 with Arduino 3.2.0
      [Eastron] Speed up parsing Modbus RTU messages
      [Serial] Add setXxBufferSize functions
      [ESP-IDF5.3] Update to latest Arduino/ESP-IDF5.3 version
      [timing stats] Simplify and speedup collecting timing stats
      [1-wire] Fix ESP8266 builds not fitting in IRAM
      [ESP32-C5] Add preliminary support for ESP32-C5 with dual band WiFi
      [ESP32-C5] Minor tweaks formatting used WiFi protocol
      [ESP32-C5] Fix file name error for platformio_esp32c5_envs.ini
      [ESP-IDF] Update to latest SDK/IDF
      [ESPtool] Prepare use of esptool v5.0.0
      [ESP32-S2] Change ADC for ESP32-S2 back to 13 bit
      [ESP-IDF] Revert to older build due to broken UART support
      [ESP32-C5] Add hardware specific info about ESP32-C5
      [Build] Get rid of all ESP32-SPIFFS builds
      [Build] Fix display ESP32 build
      [build] Change ESP32 IRExt builds to LIMIT_BUILD_SIZE
      [ESP32-C61] Start adding support for new SoC & generalize WiFi features
      [ADC] Fix not setting attenuation on internal ADC
      [ESP-IDF] Update to latest IDF/Arduino code for IDF 5.5
      [MFRC522] Speed-up detecting cards + make error recovery more stable
      [MFRC522] Improve range of reader
      Add HTML_Print and PrintToString helpers
      [MFRC522] Simplify board reset during init
      [MFRC522] Allow to dump card info to debug logs
      [MFRC522] Do proper timing for communicating with card
      [Rules] Fix processing variables with index > 2^31
      [Log] Add PrintToLog helper
      [Build] Add ESP32C5 to release.yml build script
      [ESP-IDF] Update to latest SDK version
      [MFRC522] Speedup reading by acting on interrupt pin
      [PWM motor] Speedup acting on limit switch interrupt
      [Web flasher] Update esp web tools to 8.1.10 to support ESP32-C5
      [PubSubClient] Update to new fork PubSubClient3
      [PubSubClient3] Speedup publish large messages using buffer
      [Build] Fix failed build due to missing include
      [ESP32-C5] Add option to force WiFi band 2.4/5 GHz
      [PubSubClient3] Add check for nullptr in CHECK_STRING_LENGTH
      [Controller] Fix crashes on MQTT callback calls
      [Network] Start adding Network config page
      [Network] Continue adding network config page
      [Network] Rename NetworkAdapter to NetworkDriver
      [Network] Start on initial first WiFi STA/AP drivers
      [Network] Add webform load/save for WiFi STA and AP
      [Network] Fix looping over CONTROLLER_MAX instead of NETWORK_MAX
      [ESP32P4] Add preliminary support for ESP32P4
      [ESP32P4] Fix crashes when trying to connect to WiFi
      [ESP32P4] Add more warnings for specific GPIO pins
      [Cleanup] Fix JS issues
      [Network] Add ETH config page + tweak Network Page
      [ESP32-P4] Add OTA update command for ESP32C6 WiFi firmware
      Merge branch 'mega' into bugfix/WiFi_state_machine
      [Network] Split ESP32P4 code from other MCUs
      [Network] Fix Ethernet on ESP32P4 + allow multiple active interfaces
      [Network] List all IP-addresses per network interface
      [Network] Process info based on NetworkInterface baseclass when possible
      [Network] Show Network Interface flags
      [PPP Modem] Add framework for new PPP Modem network interface
      [ESP32P4] Add extra HW serial ports supported by ESP32P4
      [Network] Split ETH into RMII and SPI + add template for PPP modem
      [Storage] Add generic key/value store to simplify data storage
      [Storage] Add load function for new key/value store
      [Storage] Add save function for new key/value store
      [Network] Add NetworkSettings type to store network interface settings
      [Network] Fix build issues
      [Network] Uncrustify new code
      [Storage] Add NWPluginData_base & optimize key/value store
      [Storage] Add tests for key/value store
      [Storage] Fix issues storing/loading from key/value store
      [Storage] Remove 0-termination for strings from raw stored data
      [Storage] Use key value store for storing network interfaces
      [PPP Modem] Add modem parameters to NW005 + fix compile issues
      [PPP modem] Add more settings + simplify key/value/store use
      [PPP modem] Add APN/Pin settings + show modem status
      [PPP Modem] Show more cell info + correct reported RSSI/BER values
      [Storage] Fix build on ESP8266 builds
      [PPP modem] Remove PPP Modem plugin from ESP32-C3 as there isn't support
      [PPP Modem] Fix build on LIMIT_BUILD_SIZE ESP32 builds
      [PPP Modem] Add UE Cell info + fix ESP32C2 build
      [PPP Modem] Disable PPP Modem plugin for 4M flash builds due to size
      [Build] Fix ESP32C6 builds
      [Build] Remove "_CDC_" from all env names due to linker issues
      [ESP-IDF] Update IDF 5.5 builds (P4/S3) to latest version
      [Network] Allow crash detection to turn off network interfaces
      [ESP32P4] Set Ethernet as default on ESP32P4 builds
      [PubSubClient] Update to latest lib version
      [PubSubClient3] Speedup publish large messages using buffer
      [Storage] Fix storing bool types
      [Controller] Fix bug not being able to add controller
      [Cleanup] Rename CPlugin and NWPlugin calls to make clear where used
      [Network] Add WiFi/AP when not present in settings + limit options
      [Plugin] Rename PluginCall functions to use same convention as controllers
      [PPP Modem] Make PPP.begin() non-blocking by running in RTOS task
      [PPP Modem] Initialize C-code to NULL instead of nullptr
      [Network] Fix saving WiFi STA & WiFi AP settings
      [Network] Add route prio to network overview
      [Network] Move network plugin code to new ESPEasy::net namespace
      [Network] Move ESPEasy::net namespace code to new folder structure
      [Network] Move global runtime data to new ESPEasy::net namespace
      [Network] Move more WiFi related code into ESPEasy::net::wifi namespace
      [Network] Move Network code to ESPEasy::net namespace
      [Network] Disable ETH for ESP32-xx Display builds to make builds fit
      [Network] Fix ESP32-classic  display build with ETH disabled
      [Network] Move EthernetParameters to ESPEasy::net namespace
      [Network] Move MetworkMedium to new ESPEasy::net:: namespace
      [Network] Move WiFiAPcandidates files to ESPEasy::net::wifi namespace
      [Network] Fix setting up last network/controller entry
      [Network] Move WiFi init code to NW001_WiFi_STA plugin
      [MQTT AutoDiscovery] Fix merge issues
      [PPP modem] Make init of PPP modem more reliable
      [Network] Show connected duration in more readable format
      [Network] Add networkenable / -disable commands + fix for controllers
      [Controller] Fix proper checking when calling CPLUGIN_xxx functions
      [Network] Fix build on ESP8266
      [Controllers] Call [C/NW]PLUGIN_EXIT before _INIT when saving settings
      [Tasks] Fix scheduled Plugin Task Timer & proper task exit/init
      [Build] Fix failing ESP8266 custom build
      [Build] Reduce build size for ESP8266 builds
      [ESP-IDF] Update to latest ESP-IDF/Arduino for ESP32-xx
      [PPP Modem] Disable PPP Modem on platforms that don't support it
      [Network] Add mechanism to restore cached DNS servers
      [Network] Fix ESP8266 build + add log when DNS is restored from cache
      [Network] Fix mangled DNS servers when switching default route interface
      [Network] Trigger checking for DNS server on default NW-IF after event
      [Network] Make connected info more consistent among network interfaces
      [Network] Move common code to collect connection stats to base class
      [Network] Add test to see if we can track interface traffic count
      [Build] Fix ESP32 build due to missing include
      [Network] Show connection info for each interface
      [Network] Reduce code duplication showing connection info
      [Build] Fix ESP-IDF 5.5 platform to specific one before pip -> uv change
      [WiFi] Show WiFi Auth mode in connection info
      [Network] Start removing connected checks from WiFi/Eth EventData
      [Network] Clean up code duplication handling network events
      [Controller] Make connection timeout dynamic per host & networkinterface
      [Network] Remove more legacy WiFiEventData code
      [Network] Cleanup + add charts for RSSI/TX-pwr, traffic, etc.
      [Network] Fix ESP8266 build issues
      [Network] Fix build on ESP8266 1M build
      [Build] Reduce build size on ESP8266 builds
      [Build] Fix copy/paste error on ESP32 builds
      [Network] Fix corrupting settings on ESP8266
      [Network] Add Route Prio setting for each network interface (ESP32-xx)
      [Network] Fix access control check for accessing web config
      [Network] Add column with interface number to Network overview page
      [Network] Fix NAPT forwarding when client connects/disconnects
      [Network] Show connected clients to AP + cleanup charts/stats
      [cleanup] Remove duplicate code in xPlugin tables
      [network] Fix 'Enable' checkbox consistency & bootloop  with AP disabled
      [Network] Fix crashes when toggling WiFi/AP on/off
      [network] Show detailed received IPv6 info in the logs
      [Network] Fix ESP8266 build
      [Network] Fix merge-conflict on ESP32-build
      [ESP-IDF] Move to IDF5.5 for all ESP32-xx builds
      [Build] Fix missing include
      [Build] Define BUILD_NO_DEBUG for Collection_E builds
      [ESP-IDF] update to latest ESP-IDF5.5
      [Build] Define BUILD_NO_DEBUG for all collection builds
      [USBCDC] Fix USB-CDC for ESP32S2 builds
      [Build] Define BUILD_NO_DEBUG for ESP32 Collection A builds
      [Network] Fix collecting RX/TX traffic data
      [Network] Add FEATURE_NETWORK_TRAFFIC_COUNT to toggle tracking traffic
      [Network] Add FEATURE_NETWORK_STATS to toggle collecting network stats
      [Network] Fix reported traffic RX/TX Bytes
      [USBCDC] Properly fix USB CDC issues on ESP32-S2
      [Build] Define BUILD_NO_DEBUG for Display builds
      [Network] Fix xxx#Connected / #Disconnected events
      [Build] Fix merge issues
      [WiFi] Fix WiFi reconnect issues
      [RC522] Add support for 7-byte NFC UIDs
      [webUI] Move Hardware tab before Network tab
      [Build] Fix merge issue
      [SysVars] Fix showing variables with hex number as index
      [MFRC522] Add immediate event on tag removal
      [LAN867x] Add support for LAN867x Ethernet controller (RMII)
      [Network] Exit all networks before reboot
      [WiFi] Fix scanning WiFi returns no networks found
      [Network] Fix showing stats and connection info
      [WiFi] Fix reported WiFi enc. mode on ESP8266
      [WiFi] Clear uses of WiFiEventData for ESP8266 builds
      [Eth] Clear uses of EthEventData for ESP32 builds
      [Build] Fix ESP8266 build
      [WiFi] Fix wifi reconnect (on ESP32)
      [WiFi] Fix internal WiFi state matching real connected state.
      [Network] Log got IP events
      [Network] Add checks to see if _netif is a valid pointer
      [Network] Make logging gotIPv6 events not do memory allocation
      [NeoPixel] Make NeoPixelSendStatus use less memory allocations
      [MQTTDiscovery] Reduce mem alloc MQTT_DiscoveryPublishWithStatusAndSet
      [Network] Remove unused base_class check for NWPluginData structs
      [Network] Add ESPEasy event when network is enabled/disabled
      [Log] Only process log to serial when in "Arduino RTOS task"
      [WiFi] Make sure WiFi actually is disconnected when trying to reconnect
      [MQTT] Only try to run background MQTT connect when connected to network
      [CSS] Tweaks for newly added Network tab
      [web UI] Change tab icons to be more uniform and working on Apple
      [WiFi] Fix automatic redirect on Captive Portal
      [MQTT] Reduce work/memory in background task, use xTaskDelay as required
      [WiFi AP] Fix switching between NAPT and Captive Portal
      [Build] Reduce bin size for ESP32 collection builds
      [Provision] Fix not able to provision files
      [PPP modem] Fix crash when PPP modem is enabled but not present
      [Docs] Add stubs for documenting new Network design
      [TaskValueSet] Fix setting 64-bit int values to a dummy task
      [CacheReader] Fix reading cache files from CacheController
      [CacheReader] Add support for 64bit ints + output as events
      [CacheReader] Fix continue reading after crash/reboot
      [CacheReader] Fix incorrect settings array index
      [CacheReader] Fix incorrect settings array index
      [CacheReader] Fix incorrect settings array index
      [Cleanup] Only show MQTT connected stats on enabled controller
      [CacheReader] Fix reading cache files when files are missing
      [PPP modem] Add DTR pin option to regain access to modem in CMUX mode
      [Cleanup] Simplify managing key-value representation in web UI / JSON
      [JSON] Simplify writing JSON page
      [JSON] Fine-tune + speedup generating JSON
      [Log] Use new streaming JSON writer to generate web log
      [Cache Controller] Use new JSON functions to generate cache_json
      [JSON] Fine tune new JSON generation functions
      [Cleanup] Wrap #ifdef WEBSERVER_NEW_UI.. around functions only used then
      [JSON] Change handle_sysinfo_json() to use new JSON formatting functions
      [JSON] Fix pretty-print generated JSON + add createChild() option
      [JSON] Use new createChild function
      [JSON] Simplify code + reduce build size due to less dependencies
      [JSON] Add option to print JSON to String + convert Domoticz JSON
      [Build] Set ESP8266 IR builds to esp8266/Arduino 3.1.2
      [Build] Fix custom_IR_ESP8266_4M1M build
      [C009 FHEM] Use new JSON code to generate response
      [Cleanup] Remove no longer used to_json_object_value functions
      [Cleanup] Reduce bin size: unsigned long to uint32_t and long to int32_t
      [JSON] Move KeyValueWriter_JSON to src/Helpers/
      [Network] Use new WebForm writer for gathering network adapter info
      [Network] Cleanup code + generate more network info using new K/V writer
      [JSON] Add same info on network adapters & sysinfo & JSON page
      [Build] Fix ESP8266 build fail due to variable type mismatch
      [Build] Reduce bin size by disabling logs in BUILD_NO_DEBUG builds
      [Build] Fix failed custom ESP8266 build, disable CustomProvisioning
      [Build] Disable C014 (Homie) and C017 (Zabbix) for ESP8266 Collections
      [Build] Disable more logs with BUILD_NO_DEBUG on ESP8266
      [Build] Fix failing build hard_SONOFF_POW_4M1M
      [Build] Fix build errors on RISC-V like ESP32-C2/C3/C5/C6
      [Build] Fix build error on safeboot builds
      [Build] Set BUILD_NO_DEBUG for all NeoPixel builds to make builds fit
      [Build] Fix failing max_ESP32c5_8M1M_LittleFS_ETH builds
      [Cleanup] Reduce bin size & simplify ValueStruct
      [ESP-IDF] Update to latest Arduino/ESP-IDF
      [Log] Simplify web log buffering
      [Log] Speedup finding 'next' log element to process
      [Build] Fix ESP8266 build fail as std::make_unique is not (yet) known
      [WebLog] Send many log messages in chunks of 200 msec.
      [TLS] Update TLS to be able to use ECDHE_ECDSA_AES_128_GCM_SHA256 cipher
      [TimingStats] Add stat to measure time spent processing MQTT messages
      [TLS-MQTT] Automatic switch to ECDSA when error is 296 (TLS handshake)
      [Provision] Add option to store (WiFi) credentials to separate file
      [Build] Fix build issues on ESP8266
      [WiFi Setup] Store credentials via setup page to separate file
      [TAR] Fix creating unusable TAR files when backup all
      [WiFi AP] Fix generating correct events when WiFi AP turns on/off
      [WiFi] Fix starting AP when no credentials present or known APs found
      [Log] Convert all ESPEasy console output to LOG_LEVEL_NONE log entry
      [Log] Serial Console pulls logitems when UART buffer is ready + colorize
      [Log] Fix log output to webflasher console + colorize LogEntry output
      [Log] Clearly mark commands in log + source of the command
      [Log] Cleanup and simplify log level code
      [Log] Make syslog to use the new log queue + fix syslog crashes
      [Log] Fix build on ESP8266 + log level label in console + syslog format
      [ChartJS] Use new JSON key-value-writer + cleanup ChartJS code
      [Cleanup] Rename Sp_KeyValueWriter to Up_KeyValueWriter
      [ChartJS] Cleanup forcing "null" on NaN values in JSON
      [Cleanup] Simplify use of LabelType
      [ESP8266] Fix build issues due to older compiler for ESP8266 2.7.4
      [Cleanup] Make nearly all of sysinfo page use new KeyValueStruct writers
      [Cleanup] Make ESP8266 builds fit again + tweak reducing generated HTML
      [Climate] Remove P169 (AS3935 lightning Detector) from ESP8266 builds
      [Build] Revert ESP-IDF/Arduino to make Solo1 and ESP32-P4 build again
      [Cleanup] Simplify ValueStruct to reduce bin size + speed up processing
      [ESPEasy] Increase nr of ints in EventStruct
      [PPP modem] Show mobile provider name from SIM card
      [ValueStruct] Reduce memory allocations on short strings
      [LogEntry] Reduce LogEntry struct to 16 bytes per log item in memory
      [ValueStruct] Fix order initialization members
      [KeyValueStruct] Add standard Unit-of-Measure units
      [WebForm] Show bool types from key/value struct as checkmark
      [ValueStruct] Fix edge case crash copying values.
      [Build] Wrap calls to setUnit in #if FEATURE_TASKVALUE_UNIT_OF_MEASURE
      [ChartJS] Make charts appear on the full width and responsive
      [Charts] Remove no longer needed chart height/width & cleanup code
      [ESPEasy p2p] Cleanup use of std::unique_ptr + p2p data structs
      [Ethernet] Set hostname when Ethernet device is started
      [Build] Reduce build size by disabling GitHub copy button for ESP8266
      [ESP32-P4] Fix WiFi/Eth issues on ESP32-P4 + optimize memory allocations
      [Units Of Measure] fix merge issues PR #5419
      [ESP32P4] Disable USB HWCDC to fix ESPEasy console for ESP32P4
      [ESP-Hosted] Show more info on ESP-Hosted-MCU WiFi (ESP32-P4)
      [ESP-Hosted] Make sure hostname is set on ESP-Hosted-MCU before DHCP
      [IPv6] Add option to enable/disable IPv6 per network adapter
      [JSON] Write empty "Sensors" array when no tasks defined
      [Eth] Move duplicate code to shared functions to display info
      [ETH] Remove left-over code duplication after split RMII/SPI adapters
      [ESPEasy Console] Fix console on both HWCDC and Serial0
      [Network] Make connected check more direct when  starting connection
      [Build] Fix flush() vs. clear() as it differs between ESP8266 and ESP32
      [Build] Make normal_ESP8266_1M_VCC not fail building (still too big)
      [Build] Fix build issue due to missing forward decl. of enum
      [Sysinfo] Add missing Unit-of-measure on file system size
      [Ethernet] Add already setup Ethernet when upgrading ESPEasy
      [Sysinfo] Hide WiFi info when no WiFi is enabled
      [Network] Start adding JSON import/export Network settings per adapter
      [Build] Disable Framed OLED on 1M ESP8266 Normal builds due to size
      [Network] Add networkexportconfig command to export to JSON
      [Network] Add NetworkImportConfig command
      [Eth] Store settings for RMII and SPI Ethernet to KV-store
      [Ethernet] Allocate unused ETH interface support multiple ETH instances
      [Ethernet] Fix saving settings to KVS
      [Network] Restart services (e.g. ESPEasy p2p) when default route changes
      [ESP-IDF] Update to latest Arduino/IDF code with fix for SPI Eth MAC
      [ESP8266] Fix failing ESP8266 build
      [Build] Remove _LittleFS and _ETH from build names due to linker issues
      [Build] Fix build fail with builds without Ethernet support
      [ESP32-P4] Disable OTA update for ESP-HOSTED-MCU on ESP32P4 for now
      [Build] Enable `custom_remove_include` to not build ignored libs
      [Web Flasher] Update script to generate webflasher for new build names
      [Network] Simplify ETH Event handling + update ESP-IDF/Arduino 3.3.3
      [Build] Limit package building to use Python 3.13
      [Build] Fix Solo1 builds
      [Ethernet] Fix loading RMII Eth settings from KVS
      [Ethernet] Fix loading SPI Ethernet settings from KVS
      [Ethernet] Cleanup showing GPIO conflicts/usage
      [Ethernet] Remove no longer needed commands to setup ETH
      [Ethernet] Make Periman reported conflicts the reported conflicts
      [Network] Remove obsolete code from Config and Tools->Advanced page
      [ESP32-C61] Add initial support for ESP32-C61
      [Collection] Remove P038 and P095 from ESP32 Collection builds
      [ESP32-solo1] Add flags to fix IDF5.5 issues for 'esp32-solo1' boards
      [ESP32-P4] Add chip-variant option to support P4 rev 1 and rev 3
      [Build] Speed up builds, add not used libs to lib_ignore
      [WebFlasher] Add support for ESP32-C5/C61 for the webflasher
      [ESPEasy p2p] Add IDs of not yet supported ESP MCUs
      [ESP32-P4/-C61] Update Arduino/IDF to support ESP32-C61 & ESP32-P4 preV3
      [ColorCode] Add NetworkEnable/Disable commands to ColorCode JavaScript
      [WiFi] Fix check for available credentials only in device specific file
      [Network] Fix processing network events on disconnect + simplify check
      [webflasher] Add 'chipVariant' to distinguish ESP32-P4 variants
      [Hardware Info] Show differences between ESP32-C6H4 and ESP32-C6H8
      [Cleanup] Mark unused members in SettingsStruct
      [WiFi] Cleanup WiFi/AP settings + simplify when to start AP mode
      [Build] Fix failed minimal ESP8266 build
      [Build] Fix solo1 builds due to wrongly set LTO flags
      [WebUI] Simplify adding HTML form fields
      [WiFi] Simplify WiFi AP fallback scenarios
      [Build] Fix failing ESP8266 builds
      [P180] BusCmd_Helper processing I2C commands via cmd subcommand was locked out
      [C023] Clone C018 code to C023
      [C023] Remove links to RN2483 code
      [C023] Add initial support for Dragino LA66 LoRaWAN module
      [C023] Add querying LA66 + receive downlink messages
      [C023] Add option to trigger events via downlink messages + code cleanup
      [C023] Fix timeout reading from LoRa + set ClassC after joined
      [C023] Cleanup LoRa AT-command controller + fix parse responses
      [WiFi] Add link to ESP-Hosted-MCU firmware builds
      [C023] Add initial support for RAK3172 LoRaWAN (m5stack AtomDTU)
      [C023] Cleanup AT-command LoRaWAN
      [C023] Add support for RAK3172 LoRaWAN (m5stack AtomDTU)
      [ESP-IDF] Update to latest ESP-IDF/Arduino
      [USBCDC] Simplify code defining USBCDC(TinyUSB) vs. HWCDC
      [C023] Remove debug log
      [Bug] Fix formatToHex_wordarray
      [Network] Enable Network Stats when plugin stats are also enabled
      [WiFi] Fix reconnecting when connection gets interrupted
      [Network] Fix enable/disable IPv6 per network interface
      [Build] Make syslog optional to reduce build size
      [Build] Add flags to disable webserver JSON or syslog to reduce bin size
      [OLED] Fix: 128×64 shows only left half in display_A builds (#5469)
      [Web Flasher] Fix generated web flasher manifest JSON
      [Serial Console] Fix outputting data to USBCDC port for ESP32S2
      [TimingStats] Tweak timing stats for console output
      [Domoticz] Fix Domoticz MQTT outputting svalue wrapped in quotes
      Update README.md
      [Build] Fix failing custom build (#5485)
      [Build] Fix failing custom build (#5485)
      [ESP-IDF] Update to latest 1901-1318-5.5 platform build
      [Build] Fix compile issues
      Revert "[ESP-IDF] Update to latest 1901-1318-5.5 platform build"
      [Sysinfo] Show free space on file system
      [ESP-IDF] Update to latest IDF/Arduino code to test if P4 builds work
      [Build] Fix non-ESP32P4 builds with latest ESP-IDF/Arduino
      [Build] Set BUILD_NO_DEBUG for Climate-A builds to make them fit again
      [SPI] Fix returning 'other' SPI bus for user defined SPI
      [Interfaces] Split SPI and I2C config into new Interfaces page
      [WebUI] Add some icon to Interfaces tab + minor tweaks
      [ESP-IDF] Update to latest ESP-IDF/Arduino SDK
      [Web UI] Change icon for Interfaces
      [Build] Try to reduce build size for ESP8266 minimal, disable I2C/SPI
      [Build] Fix failing neopixel_ESP8266_1M_Domoticz  build
      [Build] Fix failing minimal_IRext_ESP8266_4M1M
      [Build] Fix failing build safeboot_ESP32c2_4M_LittleFS
      Update generate_web_flasher_manifest.py fix showing C6 in list
      [Network] Add 'Fallback Network Interface' concept.
      [Network] Fix failing build on ESP8266
      [Network] Start documenting Fallback Network Interface
      [WiFi] Make WiFi AP act as fallback device when set as such.
      [USB-CDC] Fix USB disconnect on reboot for USB-JTAG/CDC boards
      [USB-CDC] Fix USB disconnect on reboot for USB-JTAG/CDC boards
      [TM1637] Fix timing issues for ESP32-builds for P073 TM1637
      [TM1637] Fix timing issues for ESP32-builds for P073 TM1637
      [Direct GPIO] Add missing function decl. for ESP8266
      [Direct GPIO] Add missing function decl. for ESP8266
      [ESP8266 build] Fix failing custom ESP8266 build using Custom.h
      [ESP8266 build] Fix failing custom ESP8266 build using Custom.h
      [WiFi] Fix setting hostname before starting WiFi on ESP8266
      [WiFi] Fix build on ESP8266 SDK 2.7.4
      [WiFi] Set ESP8266 hostname each time before starting WiFi.begin()
      [TM1637] Fine tune signal timing
      [TM1637] Fine tune signal timing
      [TM1637] Make clock timing more constant + fix end of transmission mark
      [TM1637] Make clock timing more constant + fix end of transmission mark
      [TM1637] Pull DIO pin low before switching to input for ACK
      [TM1637] Pull DIO pin low before switching to input for ACK
      [TM1637] Change init procedure not calling directGPIO at init
      [TM1637] Change GPIO toggling to toggle input/output + enable pull-up
      [TM1637] Fix proper timings for start/end sequence
      [TM1637] Change init procedure not calling directGPIO at init
      [TM1637] Change GPIO toggling to toggle input/output + enable pull-up
      [TM1637] Fix proper timings for start/end sequence
      [ESP-IDF] Switch to latest ESP-IDF / Arduino SDK & GCC 15.2
      [Build] Fix failing build for minimal_core_274_ESP8266_1M_OTA_FHEM_HA
      [Build] Fix failing build for minimal_core_274_ESP8266_1M_OTA_FHEM_HA
      [Build] Reduce build size by tweaking compile flags
      [Build] Fix mDNS builds + failing FEATURE_MQTT_TLS=0 & HTTP_TLS=1
      [ESP32-P4] Fix failing ESP32-P4 build due to upstream ESP-IDF changes
      [mDNS] Fix mDNS on ESP8266
      [ESPEasyP2P] Add ESP32-S31 as node ID to be recognized as ESP type
      [Serial Console] Fix showing console output in VScode
      [Console] Fix sluggish reply on console input + allow disable color logs
      [Git] Add sdkconfig.* to .gitignore
      [GPIO] Fix GPIO re-assign on ESP32 previously used by serial
      [Build] Add missing changes for disable colorize logs
      [ESP-IDF6.0] Add support for latest IDF6.0
      [mDNS] Properly destruct MDNS objects when updating
      [SPI Eth] Fix SPI Ethernet using correct SPI bus
      [ESP-IDF] Revert to IDF 5.5.3
      [SPI] Fix build on ESP32C3
      [SPI] Simplify SPI code + fix SPI bus selection
      [Build] Fix build missing #if FEATURE_SD
      [Web UI] Fix selected disabled item not getting saved
      [SPI] Fix potential uninitialized spi gpio pins
      [WiFi-AP] Extend WiFiAPmode command to toggle WiFi-AP without disable it
      [P169] AS3935 Lightning Detector was missing from Climate B builds
      [Network] Fix starting fallback interfaces if all are fallback on ESP32
      [mDNS] Add mDNS for ESP32 builds
      [mDNS] Update ESP32 mDNS lib + improve handling fallback AP on ESP8266
      [Docs] Update links to datasheets + TR of supported ESP chips
      [Docs] Fix frequency of ESP32-S31 + ESPEasy supported since
      [Docs] Fix rendering supported CPUs table
      [mDNS] Add flag to toggle mDNS
      [Network] Reduce includes in network code
      [Network] Fix failing custom_beta_2ndheap_ESP8266_4M1M
      [Network] Reduce number of includes in WiFi/Network code
      [Build] Fix hard_SONOFF_POW_4M1M  build
      [Cleanup] Reduce number of includes
      [Build] Fix failing build collection_C_ESP32_IRExt_4M316k
      [WiFi] Fix odd WiFi behavior on ESP8266
      [Build] Reduce size of custom ESP8266 build
      [ESP8266] Simplify device info functions on ESP8266
      [ESP8266] Define more bus specifics for ESP8266 in esp8266_soc_caps.h
      [Cleanup] Add 'override' to virtual controller queue functions
      [Cleanup] Add 'override' to virtual functions libs changed for ESPEasy
      [Cleanup] Fix failing builds due to different virtual function sigs
      [Network] Cleanup code + show connection info on ESP8266 adapter page
      [Cleanup] Comment unused NWPluigin functions
      [mDNS] Disable mDNS in builds as it is considered unstable
      [WiFi] Fix initial WiFi setup via soft-AP
      [Build] Fix missing include for ESP32 builds
      [WiFi] Fix uncrustify messing up wifiChannels table
      [WiFi] Fix captive portal and initial setup for ESP32-S2
      [WiFi] Fix crash on saving WiFi settings with active network connections
      [WiFi] Add OTA update for ESP-Hosted-MCU on ESP32-P4
      [sendToHttp] Fix  SendToHttp HTTPS command using HTTPClientLight
      [Build] Fix include for ESP8266 builds
      [sendToHTTP] Fix sendToHTTP using the new lib for https. (revuew by Ton)
      [ESP-IDF] Update to latest ESP-IDF/Arduino
      [RMII Eth] Fix setting clock mode + document NW config import/export
      [Docs] Update ESP-Chips table
      [ESP32P4r3] Add support for ESP32-P4 rev3
      [Eth] Fix static IP for Ethernet
      [Build] Fix missing include on minimal_core_312_ESP8266_1M_OTA_Domoticz
      [Build] Fix missing include for collection_H_ESP32_IRExt_4M316k build
      [WiFi] Fix slowdown issues using Eth on ESP32-P4 with WiFi off
      [WiFi] Make Captive Portal more intuitive and only act when connected to AP
      [WiFi] Fix continuous logs flood + fix check for no credentials
      [Build] Fix ESP8266 build
      Fix syslog packets contain only a prefix (#5538)
      [ETH] Fix setting static IP for Ethernet network interfaces
      [Build] Remove normal_beta_ESP8266_16M_LittleFS
      [Build] Fix missing include
      [WiFi] Fix static IP for WiFi
      [WiFi] Fix static IP for ESP8266
      [ESP32S2] Add MAX 8M1M build for ESP32-S2
      [ESP-IDF] Update to latest IDF/Arduino code
      [Sysinfo] Fix reporting used sketch size on sysinfo page
      [Console] Fix setting correct TX buffer size + add checks + cleanup
      [WiFi] Fix setting init/exit/gotIP flags on Network interfaces
      [ESP32S2] Fix using UART/USBCDC on ESP32S2
      [WiFi] Fix some minor WiFi issues when saving settings (still 5min wait)
      [WiFi] Fix WiFi reconnect + event duplicates on ESP8266
      [ESP32P4] Fix crashes on older ESP-HOSTED-MCU fw & detection 32M flash
      [32M flash] Fix including all 'MAX' plugins for 32M flash builds
      [ESP-Hosted-MCU] Fix OTA URL + speedup log output to serial
      [ESP32-P4] Enable WiFi STA interface on factory reset
      [Webflasher] Add 32M builds to the page generator script
      [Webflasher] Use flash size detection to simplify MAX build selection
      [webflasher] Cleanup Python script to generate page + set to 460800 baud
      [DirectGPIO] Use low-level HAL commands from ESP-IDF for ESP32-xx
      [PubSubClient3] Update to latest MQTT Client PubSubClient3
      [Network] Improve response time on network disconnect for MQTT client
      [Network] Add setting whether to collect network stats (ESP32-only)
      [ESP32S2] Improve free RAM on ESP32S2
      [Network] Fix crash saving network interface settings with p2p active
      [TM1637] Fix ESP8266 not working with TM1637 (#5541)
      [ESP32S3] Fix random crashes on ESP32S3 with PSRAM
      [WiFi] Fix using all set WiFi credentials
      [AccessControl] Fix checking for allowed IP range
      [ESP8266] Fix ESP8266 builds missing include
      [WiFi AP] Fix really stupid error setting WiFi AP static IP
      [ESP-IDF] Update Arduino/ESP-IDF to latest version
      [WebFlasher] Update webflasher to 12.2.4
      [Network] Fix route setting priority (ESP32-only)
      [Network] Fix properly clearing runtime data when starting nw interface
      [Arduino 3.3.9] Update to latest espressif32/Arduino 3.3.9
      [Docs] Add link to Supported Features and Peripherals on ESP32-xx
      [AccessControl] Fix checking for allowed IP access of webinterface
      [Build] Fix custom build missing an include for Metrics.cpp
      [Build] Fix sort custom vars on ESP8266
      [SysVarSort] Only sort system variables on ESP32 due to build size
      [WiFi] Fix stack overflow crash when no credentials set
      [WiFi] Simplify state machine for WiFi STA
      [WiFi] Update WiFi state diagrams
      [WiFi] Simplify WiFi STA state machine
      [WiFi] Cleanup STA state machine code
      [WiFi] Add state diagrams to WiFi documentation
      [Network] Simplify connected/disconnected and enabled/disabled events
      [PWM] Disable fade for ESP32 PWM for now.
      [SendToHttps] Fix crash and actually working + connect timeout
      [Build] Fix failing ESP32C2 Safeboot build.
      [SendToHttps] Log HTTP return code even on BUILD_NO_DEBUG
      [Forms] Add optional changed bool to simplify checking for changes
      [Webserver] Remove code duplication send start of page
      [Webserver] Remove & simplify duplicate code send end of page
      [PPP] Show info even when no connection to provider is active
      [PPP Docs] Add documentation on NW005 PPP Modem
      [PPP Docs] Add description and some tips regarding power
      [Docs] Add documentation for WiFi STA/AP + reformat other network docs
      [Docs] Describe WiFi modes and Passive/Active scan
      [WiFi] Simplify passive/active scan note
      [Docs] Describe rest of WiFi settings
      [Docs] Fix section/subsection marking on PPP page.
      [Docs] Remove empty 'Description' subsection from NW001 page
      [Docs] Add missing documentation for WiFi AP + cleanup network docs
      [Network] Add option to append NW interface name to hostname
      [Docs] Add link of ESP32-Arduino supported features per ESP32-variant
      [Cleanup] Set development/debug log as LOG_LEVEL_DEBUG
      [Network] Add "Append Name to Hostname" to import/export
      [Network] Fix import/export for WiFi STA and AP
      [Docs] Document the Network overview tab
      [Docs] Document the devsecurity.dat file
      [Docs] Add missing network overview tab screenshot

Ton Huisman (166):
      [SPI] Add support for multiple SPI buses
      [P095] Enable support for configurable SPI bus
      [P104] Enable support for configurable SPI bus
      [P116] Enable support for configurable SPI bus
      [P141] Enable support for configurable SPI bus
      [P172] Enable support for configurable SPI bus
      [P162] Enable support for configurable SPI bus
      [P162] Fix compilation for ESP8266
      [P125] Enable support for configurable SPI bus
      [P118] Enable support for configurable SPI bus
      [P111] Enable support for configurable SPI bus (and reformat source)
      [P099] Enable support for configurable SPI bus
      [P096] Enable support for configurable SPI bus
      [P039] Move (nearly) all code to PluginStrucs files
      [P039] Enable support for configurable SPI bus
      [SPI] Show SPI Bus selector also if only second bus enabled
      [SPI] Fix initialization for standard FSPI bus
      [SPI] Improvements in cross-bus GPIO config validation
      [Storage] Add settings for External EEPROM
      [SPI] Rename SPI1 object to SPIe to avoid conflict for ESP32-Classic builds
      [SPI] Code improvements, separate SPI functions, re-init SPI when saving Hardware page
      [P039] Fix compiler warning (nested comments)
      [MQTT] Reconnect on unexpected network interruptions
      [SPI] Disconnect SPI GPIO pins also when not using them
      [P116] Fix GPIO display on Devices page, no default GPIO pins for ESP32
      [P095] Fix GPIO display on Devices page, fix typos, no default GPIO pins for ESP32
      [SPI] Rename settings variable for better usage indication (review comment)
      [MQTT] Cancel background connection request after 2 minutes when still not connected
      [MQTT] Fix reconnect on unexpected network interruptions
      [Discovery] Avoid setting the timeout more than once
      [MQTT] Use client timeout for delay between connection attempts
      [Build] Fix missing FEATURE_SD check
      [P132] Additional support for INA226, INA228, INA230, INA231 and INA260
      [P132] Fix some typos
      [P132] Fix some more typos
      [P132] Fix one more typo and clean up code
      [P132] Add INA231 to plugin name
      [P132] Update documentation
      [P132] Fix conversion rate settings for INA228
      [P132] Fix defaults for INA228
      [P132] Update documentation for INA228 conversion rates
      [P132] Refactor Shunt settings and add more high-current options
      [P132] Update documentation for extended Shunt setting
      [P132] Fix rounding for 400A shunt
      [P132] Better selector-descriptions for shunt values
      Merge branch 'mega' of https://github.com/letscontrolit/ESPEasy into feature/SPI-add-support-for-multiple-buses, fix conflicts
      [P135] Bugfix: Correct Discovery VTypes
      [SPI] Add SPI bus selector to SPI Ethernet plugin
      [MQTT] Bugfix: Import wasn't initiated and handled correctly
      [Cleanup] Remove Provisioningxxx fall-back commands and other fixes
      [Docs] Fix some small typos
      [Log] Restore EVENT: (some event) in logging for BUILD_NO_DEBUG builds
      [Log] Restore ACT  : (rules action) in logging for BUILD_NO_DEBUG builds
      [P073] Bugfix: Display stays blank after upgrade without settings-save (#5475)
      [P132] Improve calculation accuracy determining shunt microVolt factor
      [P132] Only read measurement when conversion is ready
      [P132] Enable extended features for Energy build ESP8266 for now
      [Build] Fix compilation with Custom.h and TLS on ESP32
      [Fixes] Various fixes and improvements Feb 2026
      [CI] Fix github yaml syntax issues
      [P132] Fix MQTT Discovery for Power setting
      [Docs] Fix warnings and doc-build errors, remove deprecated plugin from conf.py
      [P104] Add font with Cyrillic characters in high-ASCII area
      [P104] Updated documentation for Cyrillic font
      [P104] Updated Cyrillic ext. font with more elaborate character set
      [P104] Updated Cyrillic ext. font with a more visually pleasing character set
      [SPI] Add support (check) for ESP32-C61 in getSPIBusCount()
      [P180] Set Cache-name field by default when empty for better performance, docs updated
      [Docs] Use pioarduino plugin instead of PlatformIO for VSCode
      [Docs] Fix error in internal commands list so it is visible again
      [Build] Disable unneeded 'page will reload' messages
      [Docs] Fix typo
      [Feature] Split Interfaces page into separate tab per interface
      [Build] Remove unneeded ifdef check
      [UI] Add support for collapsible sections on web pages
      [Interfaces] Add collapsible sections for I2C and SPI configuration
      [Build] Fix compiler warnings
      [UI] Fix minor display issue
      [UI] Add support for collapsible sections on web pages
      [Docs] Move Interfaces and Network docs to more appropriate locations
      [Docs] A few textual updates
      [P104] Improved Cyrillic font
      [UI] Improved css when used on small screens
      [UI] Improved css when used on small screens, more updates
      [UI] Improved css when used on small screens, more updates
      [P104] Update Cyrillic font doc screenshot
      [P104] Improved Ë and ë in the Cyrillic set to align with the other Cyrillic characters, and updated screenshot
      [UI] Improved css to have a pointer cursor and some spacing around the Details... label
      [UI] Fine-tune css for nicer menu tabs in dark mode
      [UI] Revert: Fine-tune css for nicer menu tabs in dark mode
      [UI] Fine-tune css for nicer menu sub-tabs (Interfaces)
      [UI] Fine-tune css fixes by @chromoxdor
      [UI] Compatibility css fix by @chromoxdor
      [Docs] Separate ESP32 and ESP8266 status
      [Docs] Separate status for ESP32 and ESP8266 on each page
      [Docs] Small update on excluded plugins
      [Docs] Small updates for supported chips
      [Docs] Small updates for supported chips
      [UI] Disable the Interfaces/Modbus subtab for now, as it's still TODO
      [Docs] Update documentation
      [Build] - Ignore clangd configuration file
      [Build] Add P047 (Moisture sensors) to Climate B, as mentioned in the docs
      [Advanced] Remove I2C ClockStretchLimit note
      [Network] Fix missing reload-indicator for Network Driver selector
      [Docs] Corrections for some recent changes
      [Docs] Expand description for creating a Custom build
      [Docs] Expand description for creating a Custom build, small typo fixes
      [Bugfix] [I2C] Connection-check failure didn't correctly disable the plugin
      [P180] [BusCmd] Allow rules variables in get/read and put/write (bus) commands
      [Build] Use pioarduino also on Github builds
      [Build][GH] Bump github-scripts plugin from v8 to v9
      [Build] Rename library.json for HeatpumpIR to avoid constant re-installs of (outdated version) IRremoteESP8266
      [P180] [BusCmd] Allow rules variables in read and put/write (bus) commands
      [P180] Process I2C commands synchronous when called from rules and other internal sources
      [P180] Update documentation
      [P180] [BusCmd] Allow rules variables in read and put/write (bus) commands
      [P180] Update documentation
      [Build] Create separate ESP32P4 binaries zip in release script
      [Fixes] %iswifi% report status value instead of boolean
      [Metrics] Add network traffic data TX/RX bytes and frames (Prometheus)
      [Docs] Fix typo
      [Ni]otifications] Add usesTLS flag to attributes and show in PluginList
      [Ni]otifications] Add usesTLS flag to attributes and show in PluginList
      [Network] Add define to select factory-default network adapter
      [Custom] Add some missing #define variables to Custom-sample.h
      [Network] Fix struct initialization
      [Settings] Fix waring for VariousBits_2
      [Network] Add size-check for NetworkDriverStruct
      [Custom] Add secure Cloudflare DNS entries
      [Docs] Fix missing column for LoopTimerSetAndRun
      [Build] Add C5 4MB Custom, 16MB MAX and 32 MB MAX32 and P4 32MB MAX32 builds
      [Build] Fix a few typos in 32MB board definitions
      [Build] Missed a typo in 16MB board definition
      [Dist] Update Espressif Flash Download tool to v3.9.10
      [Build] Update documentation
      [Network] Allow network interfaces to be enabled on factory reset
      [Network] Fix small typo
      [P180] Add documentation for TCA9554 I/O extender to control relays
      [P073] Fix build with P073_DEBUG and BUILD_NO_DEBUG enabled
      [Build] uv: Activate the PENV, then install missing requirements there
      [C016] Remove Experimental label, clean up initialization
      [Network] Initially collapse the Statistics section of the page
      [Metrics] Only export metrics when stats enabled
      [Build] Fix comment
      [Network] Allow to not default-enable WiFi interface
      Revert: [Metrics] Only export metrics when stats enabled
      [Docs] Fix link to I2C Bus settings
      [Console] Accept all valid ASCII characters for input
      [Build] Fix install-requirements script on Windows
      [UI] Update icon for Tools tab
      [P039] Fix for initialization error
      [SysVars] List variables numerically sorted
      [SysVars] Sort alphabetic values too (though they come in already sorted)
      [Docs] Suggest VSCode plugin TODO Highlight as Todo Tree doesn't work anymore without an external tool
      [Docs] Update VSCode plugin list
      [C005] Add note MQTT Auto Discovery not enabled in ESP8266 builds
      [Bugfix] Improve initialization of Task Interval
      [Bugfix] Partial revert for saving Task Interval
      [Bugfix] Include PLUGIN_FORMAT_USERVAR values for json updates
      [PLUGIN_FORMAT_USERVAR] Allow optional value display formatting by setting ParN[idx] to 1
      [P126][P129] Code optimization by moving ul2stringFixed to StringConverter_Numerical
      [P126][P129] Code optimization using ceilf instead of ceil, fix conditional compile error
      [Docs] Small typo P124
      [Bugfix] Limit humidity to 100% after applying temperature compensation
      [UI] DevicesPage: Hide Controllers if no values to send
      [Docs] Clarification about Collection builds including Normal plugin set, mention 32MB flash units

andbad (18):
      Update _P036_FrameOLED.ino
      Add new display configuration for 72x40 resolution
      Add case for pix72x40 resolution handling
      Update p036_resolution enum values
      Add new display option '72x40' to OLed_helper
      Fix enum values for p036_resolution
      Reorder resolution options in OLED frame
      Fix formatting of optionValues array in FrameOLED
      Reorder display size options in OLed_helper.cpp
      Remove and re-add 72x40 resolution configuration
      Update OLedFormSizes call to include element count
      Update OLedFormSizes to use optionsSize parameter
      Add default parameters to OLedFormSizes function
      Refactor FormSelectorOptions initialization
      Fix formatting of enum value for p036_resolution
      Fix formatting in P036_data_struct.h
      Add 72x40 OLED size to changelog
      Add 72x40 size

chromoxdor (35):
      Update for the HTTP Response Parser
      minor changes
      Update HTTPResponseParser.h
      Update HTTPResponseParser.h
      HttpResponseParser fix:prevent race condition
      [ESP8266] Enable CORS globally
      [CSS] Future CSS for Wi-Fi & Interfaces tab
      no need here
      [CSS] small update
      Update HTTPResponseParser.cpp
      Update HTTPResponseParser.cpp
      update colorcode files
      Update HTTPResponseParser.cpp
      FIX json?showpluginstats
      Update espeasy.min.js
      [ESP8266] Enable CORS globally (Update)
      [LOG] add filter
      [LOG] refining the filter
      [LOG] revert changes for plugin_sets
      [LOG] add filter field for older builds
      [LOG] reverting accidents
      [LOG] autoscroll fix, code reduction
      [LOG] Removed unnecessary code.
      [LOG+DevicePage_JS] refining the device page JS
      [JS] update WebStaticData.h
      [LOG] Fix for the minified JS
      Delete fetch_and_parse_log.min.js
      [PWM] Fix led flickering
      [PWM] undoing 16-bit changes
      Update Hardware_PWM.cpp
      [PWM] add ledcReadFreq(pin) for comparison
      [PWM] multipin state tracking
      Update Hardware_PWM.cpp
      [PWM] using ledcRead()
      [PWM] reduce function

dependabot[bot] (3):
      Bump actions/download-artifact from 7 to 8
      Bump actions/upload-artifact from 6 to 7
      Bump actions/checkout from 6 to 7

yosinn1-blip (2):
      docs: fix received spelling in docs
      docs: fix occurrence spelling in docs


-------------------------------------------------
Changes in release mega-20260108 (since mega-20260107)
-------------------------------------------------

Release date: Thu Jan  8 08:33:12 AM CET 2026

TD-er (1):
      Add Python version for prepare-dist in release.yml


-------------------------------------------------
Changes in release mega-20260107 (since mega-20250430)
-------------------------------------------------

Release date: Wed Jan  7 11:00:02 PM CET 2026

Bartłomiej Zimoń (4):
      Update Flashing.rst
      Update Flashing.rst
      Update Flashing.rst
      Update Flashing.rst

Fabio Ancona (2):
      Update LD2410 doc adding info of false positive
      Update P159.rst

Jason2866 (8):
      remove cache use uv
      Update build.yml
      Update post_esp32.py
      Update post_esp32.py
      add forgotten function
      missing import os
      Update post_esp32.py
      remove cache use uv

TD-er (55):
      [Favicon] Serve favicon.ico as inline SVG
      [settings] Reduce initial default config.dat to 96k on ESP32
      [JSON] Tweak generating JSON via web requests
      [Favicon] Tweak blue color in SVG ESPEasy favicon
      [Time] Speedup printing date/time string
      [Build] Remove TAR support from LIMIT_BUILD_SIZE builds (saves 5+ kB)
      [OLED display] Reduce build size for P023
      [SysVarPage] Fix table layout on builds with excludes features
      [SysVarPage] Make more clear separation for "Standard Conversions"
      [Sysvar] Enable %c_random% for all builds
      [ESP32-S2] Change ADC for ESP32-S2 back to 13 bit
      [ESPtool] Prepare use of esptool v5.0.0
      [Build] Get rid of all ESP32-SPIFFS builds
      [ESPtool] Prepare use of esptool v5.0.0
      [ESPEasy p2p] Add node-IDs for new Espressif SoC models
      [ADC] Fix not setting attenuation on internal ADC
      [Build] Update to latest IDF5.4 build + add C6 builds
      [ESP32-S3] Revert changes in board defines for ESP32-S3 with OPI PSRAM
      [Build] Speed up ESP32 builds via CompiletimeDefines_generated.h
      [WebFlasher] Add missing ESP32-xx MCUs to manifest script
      [Build] Speed up ESP32 builds via CompiletimeDefines_generated.h
      [WebFlasher] Add missing ESP32-xx MCUs to manifest script
      [Rules] Fix processing variables with index > 2^31
      [MFRC522] Speed-up detecting cards + make error recovery more stable
      [MFRC522] Improve range of reader
      [MFRC522] Simplify board reset during init
      [MFRC522] Allow to dump card info to debug logs
      [MFRC522] Do proper timing for communicating with card
      [MFRC522] Speedup reading by acting on interrupt pin
      Add HTML_Print and PrintToString helpers
      [Log] Add PrintToLog helper
      [PWM motor] Speedup acting on limit switch interrupt
      [ESP-IDF] Update to latest SDK version
      [WebFlasher] Add more info on migrate to LittleFS on web flasher page
      [WebFlasher] Update LittleFS migration guide in webflasher page
      [PWM motor] Fix limit switch invert (again)
      [PubSubClient] Update to new fork PubSubClient3
      [PubSubClient3] Speedup publish large messages using buffer
      [PubSubClient3] Add check for nullptr in CHECK_STRING_LENGTH
      [Controller] Fix crashes on MQTT callback calls
      [WebServer] Properly close chunked transfer
      [Cleanup] Fix JS issues + correctly end chunked transfer
      [Build] Try fixing failing solo1 build
      [ESP32-U4WDH] Fix bootloop on non-Solo1 builds
      Fix missing #ifdef USES_P056
      [Build] Fix missing #ifndef LIMIT_BUILD_SIZE
      [SysVars] Fix showing variables with hex number as index
      [MQTTDiscovery] Reduce mem alloc MQTT_DiscoveryPublishWithStatusAndSet
      Reduce ESP32 Display build size (BUILD_NO_DEBUG)
      [CacheReader] Fix continue reading after crash/reboot
      [CacheReader] Fix reading cache files from CacheController
      [CacheReader] Add support for 64bit ints + output as events
      [CacheReader] Fix incorrect settings array index
      [Build] Limit package building to use Python 3.13
      [Collection] Remove P038 and P095 from ESP32 Collection builds

Ton Huisman (369):
      [P073] Add support for 74HC595 displays
      [P073] Disable debug log
      [P073] Make build fit again (part 1)
      [P073] Make build fit again (part 2)
      [P094] Remove from Collection D for ESP8266 buildsize
      [P073] Move most code to PluginStruct files, explicit compile-time defines
      [P073] Make 7-segment font functions publicly available
      [P073] Separate 74HC595 multiplexed displays, code improvements
      [P073] Update documentation
      [P073] Disable 74HC595 displays for now
      [P073] Add double-buffering for 74HC595 displays
      [P073] Make some functions available externally, fix 74HC595 matrix display (sort-of, still some flickering)
      [P073] Fine-tuning and allow to include 74HC595 in ESP8266 Custom builds
      [P073] Make P073_revert7bits() available for global use
      [P073] Fix copy/paste error
      [P073] Use more efficient bit-revert algorithm, as suggested
      [P073] Add option for time-blinking the second dot instead of the colon
      [P073] Use DIRECT_PIN_IO for TM1637 displays for better timing accuracy
      [P073] Update documentation
      [P073] Should use the public function
      [P165] Fix compiler warning
      [MQTT] (Auto)Discovery implementation
      [P052] Add MQTT Discovery data for supported Values
      [Source] Fix CR/LF vs LF
      [MQTT] Add support for more VTypes, implement more VTypes, small improvements
      [MQTT] Move TaskValue VType Discovery to each plugin where needed. Some other code improvements
      [P105] Fix Uncrustify formatting
      [P164] Add fixme for currently unsupported AQI Discovery value
      [Discovery] Add VType for Reactive Power
      [Discovery] Implement VType for Reactive Power
      [P076] Implement Discovery support (for user-selected values)
      [P077] Implement Discovery support (for user-selected values)
      [P078] Implement Discovery support (for user-selected values)
      [P085] Implement Discovery support (for user-selected values)
      [P102] Implement Discovery support (for user-selected values)
      [P108] Implement Discovery support (for user-selected values)
      [P115] Implement Discovery support (for user-selected values)
      [P132] Implement Discovery support (for user-selected values)
      [P142] Implement Discovery support (for user-selected values)
      [Discovery] Refactor getting VType per plugin, add some more plugins for AutoDiscovery
      [Discovery] Add support for some more VTypes, add AQI and NOx
      [P147] Implement MQTT Discovery support
      [P164] Update MQTT Discovery support
      [EasyColorCode] Updates April 2025
      [P020] Update documentation
      [P116] Fix typo in docs
      [P180] Add plugin Generic I2C
      [P180] Add also to Display, Energy and Neopixel collection builds (ESP32 only)
      [P180] No defaults for I2C address or number of values
      [P180] Cleanup memory after use, fix ESP8266 compilation
      [P180] Cleanup memory after use, fix ESP8266 compilation
      [Rules] Fix parsing bracketed expressions from position 0
      [P180] Add conditionally cancelling a command sequence (if)
      [Rules] Add support for crc8 and crc32 functions
      [P180] Optimize hex formatting, add preprocessed calculation to logging
      [Rules] Add optional validation of crc to crc8 and crc32 functions
      [EasyColorCode] Add more plugin commands
      [P180] Correct regular value handling, improved hex formatting
      [P180] Add documentation and usage examples
      [P180] Add exec subcommand, add valuename support, fix issue updating command-cache
      [P180] Add handling 1/sec, 10/sec and 50/sec event processing, add log subcommand
      [P180] Update documentation and usage examples
      [P180] Update documentation and usage examples
      [EasyColorCode] Update commands for P180
      [Docs] Add examples for substring for translation of day/month names
      [P180] Add let I2C Command, limit delay to max 10ms for 1ps/10ps/50ps
      [P180] Add to Custom-sample.h
      Bugfix [P075] Typo in check for RxD GPIO pin
      [P180] Refactor into BusCmd, phase 1
      [P021] Bugfix: Make Invert work without a GPIO pin selected
      [P180] Refactor into BusCmd_Handler interface, phase 2, Add String support
      [P180] Remove previously added but unused I2C functions
      [P061] Resolve I2C related FIXMEs, gaining ~120 bytes
      [P180] Update documentation
      [P011] Optimize I2C calls, gaining ~110 bytes
      [Discovery] Add /config and Retain Discovery settings to MQTT Controller with AutoDiscovery
      [Discovery] Fix Switch auto-discovery [Discovery] Add support for Inverted Switch [Discovery] Add support for Switch Device Class configuration
      [P001] Implement Switch MQTT Device Class setting and Inverted Switch discovery
      [P009] Implement Switch MQTT Device Class setting and Inverted Switch discovery
      [P001][P009] Correct typo
      [P019] Implement Switch MQTT Device Class setting and Inverted Switch discovery
      [P021] Implement Switch MQTT Device Class setting and Inverted Switch discovery
      [Discovery] Add support for different Switch device class per value
      [Rules] Add support for String type variables
      [StringVars] Fix variable typo
      [StringVars] Remove unneeded UnaryOperator::IsNum
      [StringVars] Fix new introduced template parser bug
      [StringVars] Make string comparisons work with `if`
      Add new commands and functions for String variables support
      [SysVars] Make second argument for 2-argument conversions optional
      [StringVars] Add documentation
      [StringVars] Add documentation for [length#var]
      [Bugfix] String commands parser fix off-by-one issue
      [Rules] Add string function Lookup with docs
      [Rules] Add conversion function %c_strf%() with docs
      [Rules] Fix typo in docs
      [StringVars] Add TaskValueSetDerived, TaskValueSetPresentation commands and handling
      [StringVars] Add TaskValueSetDerived, TaskValueSetPresentation docs
      [Docs] Move Data Acquisition to separate include file
      [StringVars] Avoid calculation of formula with presentation prefix ($)
      [StringVars] Improved handling of calculated values for Derived values
      [SysVars, Conversions] Add %localunixtime%, %systzoffset_s% sysvars and %c_ts2date%() conversion + docs
      [SysVars] Exclude %localunixtime% from Limited builds
      [SysVars] Rename %localunixtime% to %unixtime_lcl%
      [DerivedValues] Add Event & Log option and generate events and logging for Derived values, update docs
      [SysVars] Add %c_ts2wday%(timestamp) (dow) conversion and docs
      [EasyColorCode] Add more new commands and functions for String variables support
      [P180] Add GET_CONFIG_VAR support
      [Discovery] Fix typo in BinarySensorInverted helper
      [Docs] Update WSL2 USB Serial configuration since Linux 6.x core update
      [Feature] Add Unit of Measure for all taskvalues and present on Devices overview page
      [UoM] Add Unit of measure value to /json endpoint
      [UoM] Add Unit of measure value Devices overview page update script (also uses Presentation if available)
      [Build] Reduce size of included Github clipboard script
      [Build] Include reboot.js script in readable form
      [Build] Reduce size of included Fetch and parse logs script
      [UoM] Add Unit of measure value Devices overview page update script (also uses Presentation if available)
      [JSON] Add Presentation as separate value instead of replacing Value (using updated .js scrip)
      [UoM] Make .js script more fault tolerant when no global UoM enable setting is available
      [DerivedValues] Don't determine max decimals for display but use default
      [DerivedValues] Add optional Unit of Measure and include in /json output
      [UoM] Make .js script more fault tolerant when no global UoM enable setting is available
      [UoM] Optional default when fetching Unit of Measure
      [Discovery] Implement UoM per taskValue when available
      [I2C] Show I2C Bus nr in Not enabled message of i2cscanner
      [I2C] Add a few missing I2C device addresses for INA219
      [UoM] Add Feature TaskValue-attributes with support for .uom, .decimals, .hasformula and .statsenabled
      [DerivedValues] Move parsing derived variables to correct code-location
      [DerivedValues] Add TaskValue attribute support for DerivedValues (empty is not valid)
      [Discovery] Add default empty option for Device Class selector (all values shift 1 index up!)
      [P116] Add support for ST7735/ST7789 170x320 displays
      [SysVarPage] Exclude c_random from list for limited builds
      [UoM] Add documentation
      [UoM] Update documentation
      [UoM] Update documentation
      [VTypes] Refactor SensorValueType selector so it can be used separately
      [VTypes] Refactor SensorValueType selector so it can be used separately (cherry picked)
      [ValueTypes] Add Custom VType selection
      [Plugins] Add CustomVTypeVar option for plugins that need custom Value Type selection
      [DerivedValues] Add support for Value Type argument
      [AutoDiscovery] Add support for Derived values, UoM and Value Type, some code optimizations
      [C006] Add support for sending derived values
      [C014] Add Unit of Measure to AutoDiscovery, add Send Derived values support
      [Docs] Updates and improvements, Summer '25
      [Docs] Update docs for Value Type setting for selected plugins
      [Docs] Move Send derived values as a per controller setting for tasks
      [Derived Values] Move enable sending per task-controller, Code optimization
      [C014] Docs: Update UoM feature
      [P027] Docs: Fix a few typos
      [P180] Improvements and fixes in handling of signed values
      [Docs] Update/extend the SPIFFS to LittleFS migration procedure
      [Docs] Update/extend the SPIFFS to LittleFS migration procedure
      [Docs] Extract SPIFFS to LittleFS migration guide for accessability
      [Docs] Expand SPIFFS to LittleFS migration guide, add troubleshooting section
      [AutoDiscovery] Add support for Wind direction and Wind speed
      [Plugins] Minor code improvement
      [UoM] Restructure UoM selector into categories, add more uom options
      [UoM] Fix UoM selector empty value
      [Docs] Update Unit of Measure documentation and screenshots
      [AutoDiscovery] Embed setting for `online` message in `/config` setting
      [Docs] Update documentation for C005
      [AutoDiscovery] Update PluginTemplate
      [AutoDiscovery] Embed setting for `online` message in `/config` setting
      [Docs] P165 Fix a few typos
      [AutoDiscovery] Remove unused code
      [AutoDiscovery] Make start delay compiletime configurable, and extend max delay from 10 to 30 sec.
      [Docs] Update documentation for C005
      [AutoDiscover] Add Duration, Date and Timestamp device classes, fix some irregularities
      [AutoDiscover] Add Data rate, Data size, Sound pressure and Signal strength
      [AutoDiscover] Refactor discovery message composition to reduce binary size by nearly 4k
      [AutoDiscover] Set Unit of Measure and Value Type when adding a device (when possible/available)
      [P095] Add ILI9342 display variants
      [P095] ILI9342 added configurations, set resolution correctly
      [P095] Update documentation
      [UoM] Correct a few Value Type UoM defaults
      [P026] Set default Value Type and UoM when changing a task value setting
      [Converters] Add `%c_ts2isodate%()` Timestamp to ISO date conversion
      [Converters] Add `%c_ts2isodate%()` Timestamp to ISO date conversion
      [AutoDiscover] Clean names sent to HA by replacing unsupported characters by `_`
      [Converters] Include system time-zone in `%c_ts2isodate%()` to have HA accept the `Timestamp` value type
      [Converters] Make system time-zone optional in `%c_ts2isodate%()` (second argument != 0)
      [Converters] Make system time-zone optional in `%c_ts2isodate%()` (second argument != 0)
      [AutoDiscover] Add `Date/Time` (`datetime`) Device class
      [AutoDiscover] Fix handling of BARO_ONLY values, and allow multiple BARO_ONLY values
      [AutoDiscover] Remove non-working `Date/Time` (`datetime`) Device class :-(
      [ValueTypes] Add categorized selector for Value Type per Value
      [P176] Set default Value Types when adding the plugin
      [ValueTypes] Fix optional None value
      [P180] Remove unneeded code
      [AutoDiscover] Try to get switch trigger working
      [ValueTypes] Reorder value types somewhat, use categorized selector where applicable
      [ValueTypes] Update documentation
      [P014] Fix MQTT Discovery value types
      [Build] Remove "_CDC_" from all env names due to linker issues
      [MQTT] Fix command handling for /set and /cmd topic endpoints, add support for P001 in /set
      [AutoDiscover] Mark some MQTT Device classes as 2-way to have on/off devices (Light)
      [CustomVtype, UoM] Fix compilation for ESP8266 when not all enabled
      [AutoDiscover] Better array index checks
      [Backup] Add backup without credentials included (security.dat)
      [Metrics] Add internal CPU temperature
      [Backup] Use term credentials instead of username/password
      [Backup] Update documentation
      [Metrics] Update documentation
      [AutoDiscover] Add support for P009 and P019, only send discovery for plugins that actually send data
      [AutoDiscover] Fix flippin bit-flip issue
      [AutoDiscover] Fix P021 not to be handled as a Switch
      [Backup] Fix typo in variable name for ESP8266
      [AutoDiscover] Fix Group configuration
      [Backup] Compile error when TAR support disabled
      [Libs] MFRC522 remove unused variable
      [Libs] PubSubClient signed/unsigned comnparison warning
      [AutoDiscover] Set default Auto Discovery topics when adding HA Controller
      [P009][P019] Fix logging alignment
      [AutoDiscover] Fix a few comments
      [AutoDiscover] Docs improvement for Group feature
      [TaskValueSetDerived] Improved parsing of Unit of Measure value
      [AutoDiscover] Fix conditional compilation issue
      [Rules] Enable rules by default on a clean install
      [AutoDiscover] Add state_class support and some Value Types
      [AutoDiscover] Enable state_class support for plugins and correct a few Value Types
      [AutoDiscover] Update documentation
      [AutoDiscover] Fix compilation when state_class support not enabled
      [AutoDiscover] Small code improvement
      [P078] Improved value descriptions and register appended, small code improvements
      [Caches] Formatting (minor)
      [P056] Add multi-instance use
      [P078] Fix docs parser warning
      [P056] Update documentation
      [P102] Add support for PZEM-017v1
      [P102] UI updates and corrections
      [P102] Add documentation
      [Build] Fix compiler warning for unused variable
      [BusCmd I2C] Add support for handling > 128 bytes on I2C read/write (ESP32)
      [BusCmd Helper] Add support for variable length string and buffers (Byte/Word), and some bugfixes
      [P180] Update documentation
      [BusCmd Helper] Send data & event when updating value.N from other than PLUGIN_READ action
      [BusCmd Helper] Add LetStr I2C command, analogue to the `LetStr` Rules command, updated documentation
      [P102] Small typo in documentation
      [AutoDiscover] Use %sysname% instead of group_nr if Controller Group = UnitNr
      [AutoDiscover] Update documentation for Group setting
      [AutoDiscover] Add 15 more Value types and 7 UoM values, fix some default UoM
      [AutoDiscover] Update Value type and UoM documentation
      [MQTT] Add Retain option per task
      [MQTT] Update documentation for Retained setting per task
      [MQTT] Some documentation improvements
      [Build] Add [P105] AHT2x to Collection G so it can be used with [P164] ENS160
      [P089] Add support for ESP32
      [P089] Remove unneeded attribute
      [P089] Create separate Ping Service to handle single-instance Ping function sequentially
      [P180] Add Tiny Code Reader example to documentation
      [P180] Add optional skip argument to IF I2C command, update docs
      [P021] Emphasize warning to prevent saving settings too often
      [P039] Update SPI and GPIO documentation
      [P037] Use configured decimals when generating events
      [P037] Update documentation for: use configured decimals when generating events
      [P168] Disable blocking Lux Read-Method options
      [P168] Update documentation
      [P102] Don't check non-available values for NaN
      [P102] Correct documentation small typos
      [MQTT] Handle connecting to broker as a background process
      [Tools] Update documentation for MQTT Connect in background
      [MQTT] Move Settings attribute to next available bit
      [MQTT] Reconnect on unexpected network interruptions
      [P089] Update documentation
      [MQTT] Cancel background connection request after 2 minutes when still not connected
      [MQTT] Fix reconnect on unexpected network interruptions
      [Discovery] Avoid setting the timeout more than once
      [MQTT] Use client timeout for delay between connection attempts
      [Build] Fix missing include
      [MQTT] Refactor background connection process to avoid logging from background task
      [AutoDiscover] Fix small typos in default UoM list
      [AutoDiscover] Fix spelling error in precipitation
      [AutoDiscover] Fix spelling error in precipitation
      [MQTT] Fix compilation on ESP8266 (Retain per task)
      [P089] Bugfix: Putt include in scope
      [P102] Use added setModel() method when needed
      [P033] Enable formula field
      [P033] Update documentation
      [P102] Use defined constants
      [P102] Add Submit instruction after use of 'Reset energy' mode
      [P102] Update documentation
      [Info] Emphasize the number of flash writes count since cold boot #3116
      [C011] HTTP Advanced - Don't URL-encode header
      [HTTP] Add support for TLS
      [HTTP] Enable TLS support for Controllers using HTTP
      [P002] Fix docs layout issue
      [HTTP] Defensive programming in test for https url
      [HTTP] Enable TLS support also for Controller C007 Emoncms
      [Devices] Limit displaying of (old) Wiki Help button to P056 and below
      [Devices] Limit displaying of (old) Wiki Help button to P079 and below
      [MQTT] Reduce work/memory in background task, use xTaskDelay as required
      [Docs] Correct some layout inconsistencies
      [Docs] Update overview generator, include Notify and Network plugins
      [Build] Fix compiler warning
      [Tools] Add Plugin list overview page
      [Tools] Update documentation for Plugin list
      [Build] Split Display into Display A and Display B
      [Build] Display A/B split: Update documentation
      [Tools] Add documentation-button to Plugin list overview page
      [Tools] Add preliminary support for Network plugins
      [Docs] Add MQTT Device class documentation for plugins where available
      [MQTT] Minor corrections
      [TLS] Update TLS to be able to use ECDHE_ECDSA_AES_128_GCM_SHA256 cipher
      [Docs] ESP8266 is Feature Complete!
      [TLS-MQTT] Automatic switch to ECDSA when error is 296 (TLS handshake)
      [MQTT AutoDiscovery] Add support for Switch Device Class
      [MQTT AutoDiscovery] Update documentation for Device Class
      [P026] Fix Value Type for TXpower to use dBm
      [HTTP] Fix build and feature-enable for non-MAX builds
      [HTTP] Update documentation for TLS options
      [UoM] Refactoring to reduce page-load time and size
      [Build] Add Collection H and split Climate into Climate A and Climate B
      [Build] Fix build errors for Collection H and Climate B
      [Build] Remove obsolete comments
      [Build] Move more plugins from Collection G to H to make Collection G fit
      [Build] Reduce build-size for all Collection builds using BUILD_NO_DEBUG
      [Build] Reduce build-size for Collection C build
      [P169] Fix DEBUG log
      [Build] Avoid build-reduction for MAX builds
      [Build] Avoid build-reduction for MAX builds
      [P021] Code optimizations
      [Build] Remove _LittleFS and _ETH from build names due to linker issues
      [Build] Enable `custom_remove_include` to not build ignored libs
      [Build] Limit package building to use Python 3.13
      [UI] Update addTaskSelector() to use FormSelectorOptions
      [Docs] P180 Add example for reading Sensirion SDP-8xx
      [Docs] P180 Small corrections
      [Docs] P180 Sensirion SDP-8xx add description for Single-shot measurement
      [Bugfix] Don't use Flash-string parameter default as ESP8266 compiler doesn't support that
      [Bugfix] PluginList add missing includes needed in some builds
      [PluginList] Update for HTTPS TLS support
      [Build] Fix SafeBoot build
      [Bugfix] Derived values avoid parsing invalid values causing crashes
      [Bugfix] Derived values avoid parsing invalid values causing crashes, more global fix
      [Bugfix] Revert previous change as that didn't really fix the issue
      [AutoDiscovery] Show Auto Discovery for Controllers that have this enabled (Task configuration)
      [Bugfix] Calculation missed value when returning from multiple brackets
      [Bugfix] MQTT StateClass selector stored wrong index
      [P003] Enable MQTT State Class option so pulse-counter can be used for energy measurement (in HA)
      [P180] BusCmd_Helper processing I2C commands via cmd subcommand was locked out
      [SysVars] Add %latitude% and %longitude% vars and Latitude and Longitude commands
      [SysVars] Documentation for %latitude% and %longitude% vars and Latitude and Longitude commands
      [P180] Enable CustomVTypeVar and MQTTStateClass device flags
      [P180] Fix typo in parameter for log subcommand
      [P180] Add documentation for TF-Luna laser distance sensor
      [P180] Small updates in documentation of TF-Luna laser distance sensor
      [P180] Add documentation for QMC6310 3-axis magnetic sensor, add example-index to docs page
      [Bugfix] Calculation of functions discarded the next operator
      [Bugfix] Calculation of functions remove unneeded value duplication, small debug-code optimization
      [Rules] Add some functions, conversions and constants
      [Rules] Add some functions, conversions and constants, fix docs typo
      [Docs] Updates and improvements (2025 Q4/2026-01)
      [Stats] Add minp/maxp stats values and change min/max stats values for running min/max value, update docs
      [Bugfix] Compilation error fix for custom IR build
      [Bugfix] Metrix: Export 0 for empty values
      [Bugfix] Metrix: Export 0 for empty values, fix for ESP8266
      [AdaGFX] Fix `tpm` subcommand argument check
      [Docs] Update copyright notice to show 2026
      [AdaGFX] Fix space-height issue for some fonts
      [P116] Add ST77xx resolutions 240x320 and 240x280
      [P116] Allow for > 16 hardware types in selection
      [P116] Update documentation with new resolutions
      [P087] Add support for receiving binary data, fixed length data, and event as hex string
      [P087] Update documentation
      [P087] Add to `ENERGY` build (ESP32 only)
      [Converters] Bugfix formatToHex_wordarray()
      [P087] Use PCONFIG_ULONG to store new config flags
      [P004] Change name to include DS18xxx/MAX31xxx for better recognizability
      [P057] Add documentation as it wasn't included yet

chromoxdor (63):
      Update Networking.cpp
      a tiny bit better formatting
      changes for OPENMETEO_EVENT and THINGSPEAK_EVENT
      Update Networking.cpp
      combining two functions
      wrong use of concat times two :)
      update
      Update Networking.cpp
      put thingspeak and openmeteo events into extra file
      added inverter event
      fix for not building on minimal_core_274_esp8266...
      #ifdef to #if. m(
      more universal json event approach
      Update HTTPResponseParser.h
      added variable decimals for floating point numbers
      some changes to the json-event
      made the eventQueue even more complex :P
      minor changes
      moved variable to cpp file
      updates
      Update HTTPResponseParser.cpp
      Update define_plugin_sets.h
      Update HTTPResponseParser.cpp
      Update HTTPResponseParser.cpp
      documentation and slight reduction of code
      Update define_plugin_sets.h
      corrected json examples
      Docs: Formatting and linking
      fixed typo
      [P164 ] Adding a sleep mode
      Update P164_data_struct.cpp
      Update define_plugin_sets.h
      Changes as requested
      Update HTTPResponseParser.rst
      Update HTTPResponseParser.cpp
      ColorCode Additions
      Update espeasy.js
      forgot the "f" and the minified version
      some unessecary commas removed
      no indentation for comments....
      added a format button if on mobile device
      format even without colorcode enabled
      more robust block checks
      jump to line of first error and keep history
      make it work for android non color rules again
      Readded search bar and enhanced it.
      fixed broken replace function
      forgot someting to change
      find while typing
      fix replace
      more robust live search handling
      removed unnecessary function
      scroll to top when found
      Update codemirror.min.css
      replace: scroll to top too
      as good as it gets :)
      minor corrections help text
      rephrasing of the confirm dialog
      fix: jump back to cursor position after formatting
      ..and remove an old dialog before opening a new one
      disable shortcuts
      disable shortcut: forgot to add the corresponding function
      Update espeasy.min.js

dependabot[bot] (10):
      Bump cryptography from 43.0.1 to 44.0.1
      Bump actions/download-artifact from 4 to 5
      Bump actions/checkout from 4 to 5
      Bump actions/setup-python from 5 to 6
      Bump actions/github-script from 7 to 8
      Bump actions/download-artifact from 5 to 6
      Bump actions/upload-artifact from 4 to 5
      Bump actions/checkout from 5 to 6
      Bump actions/upload-artifact from 5 to 6
      Bump actions/download-artifact from 6 to 7

jfmennedy (1):
      Fix horizantal vane not working

repa6 (7):
      added TAC2100 support to _P078_Eastron plugin
      Update _P078_Eastron.ino with changelog info
      Update P078_data_struct.h: added comma after TAC2100=7
      extended TAC2100 registers list and added TAC2100 to docimentation
      fixed redister nature of load
      Update P078_data_struct.cpp - added nat:load to SDM_UOMtoString strings
      Update P078_data_struct.cpp - updated register addresses for the last 5 registers of TAC2100


-------------------------------------------------
Changes in release mega-20250430 (since mega-20241222)
-------------------------------------------------

Release date: wo 30 apr 2025 21:42:35 CEST

Daniel Siegmanski (20):
      Added a missing comma so that the plugin can also be built with activated PLUGIN_076_DEBUG.
      Added the ability to read reactive power, apparent power and energy.
      Fixed typo in reset command.
      Changed the PCONIFG values from 1,2,3,4 to 8,9,10,11
      Set default querys in PLUGIN_INIT if not already set.
      Change the PCONFIG values from 8, 9, 10, 11 to 0, 1, 2, 3
      Changed init value from P076_QUERY1_CONFIG_POS
      Changed single = to a double ==
      Set default quersy only if no one is set.
      Update the values only if valid.
      Check if the pointer is valid.
      Replaced spaces through underlines.
      The old meassurement values (voltage, current, active power & power factor) are now defaults again. For compatibility with old setups.
      Added changelog
      Uncrustify
      Added different strings for output selector and value description.
      Resored the old value names for backward compatibility.
      Added an option to set the measured values to 0 if they are not valid. This is necessary if the sensor is behind a relay.
      Added defines for the indices of the differend readed values.
      Fixed typo.

Nikolay (1):
      chore: fix wrong url

TD-er (153):
      [Flash] Fix availability of flash pins on ESP32C3
      [GPIO info] Split ESP8266/ESP32 implementation
      [GPIO info] Split platform specific implementation to separate cpp files
      [CPU info] Split getChipModel over separate .cpp files per platform
      [GPIO] Add "Boot Strapping" as conflict reason for bootstrap pins
      [GPIO] Simplify isSerialConsolePin()
      [Hardware] Simplify checks for DAC and Touch support
      [Touch] Simplify device specific touch capabilities
      [Build] Fix compile error in ESP32-C2 builds
      [DeviceInfo] Prepare for new ESP32-C5/C61/H2/P4
      [Docs] Add info on new ESP32-C5/C61/P4
      [Hardware] Add initial GPIO definitions for ESP32-P4
      [ESP32P4] ESP32-P4 does not use GPIO pins to access flash/PSRAM
      [Build] Fix building ESP-IDF5.3 builds (pioarduino-build.py)
      [LU9685] Add P178_LU9685  (#5216)
      [LU9685] Forgot to enable a pin when setting angle
      [LU9685] Split command into subcommand structure
      [LU9685] Fix typo in parsing subcommand
      [LU9685] Add subcommands enable, disable, setrange
      [LU9685] Add documentation + fix crash
      [BUG] GPIO 10 and 11 not available (#5220)
      [GPIO] update hardware defines for flash connected GPIO pins
      [BME3xx] Lower SPI frequency to 100 kHz
      [P076] Fix initialization + merge issues + cleanup
      [HLW8012] Fix stability of reading + proper pwr/cur/VA/pf measurement
      [HLW8012] Cleanup + simplify code
      [HLW8012] Further cleanup + stabilize reading
      [HLW8012] Fix 'oscillating' measurements at some intervals
      [HLW8012] Cleanup library.properties + fix crash on low power usage
      [HLW8012] Uncrustify .ino file
      [HLW8012] Limit Apparent power to power factor of 25%
      [HWL8012] Fix stability issues on ESP8266 with high current load
      [Build] Fix pre_custom_xxx.py files to work with pioarduino
      [Build] Change generate-compiletime-defines.py to not match .cpp.o
      [Build] Revert platform build to before shorten path commit
      [Build] Also revert the platform link for solo1 builds
      [Build] Add build ignore middleware filter for .cpp.o files
      [JSON] Fix valid JSON for pluginstats
      [Build] Do not use build middleware for compiletime defines
      [Build] Fix missing lib_ignore defines in .ini files
      [Build] Fix merge conflict
      [P139] Add capturing ADC inputs
      [P139] Add charger settings
      [P139] Split AXP2101_settings to separate file
      [P139] Add charger settings to webform load/save
      [P139] Move webform_load and _save to P139_data_struct class
      [P139] Add functions to apply settings to AXP2101
      [P139] Apply setttings to device
      [P139] Fix build ESP8266
      [P139] Fix setting defaults for charger settings
      [Cleanup] Add FormSelector class to simplify P139 charge options
      [Cleanup] Convert other charging related settings to use FormSelector
      [P139] Fix ESP8266 build + show device state
      [P139] Clarify charging state
      [Cleanup] Simplify addSelector calls
      [Cleanup] Change addFormSelector calls to use new class
      [Cleanup] Show reload icon next to selection box triggering page reload
      [Cleanup] Move more code to use new FormSelectorOptions class
      [Cleanup] Convert more code to use new FormSelectorOptions class
      [Cleanup] Move more plugin code to use FormSelectorOptions class
      [P139] Remove PMIC plugins from IRext builds
      [Cleanup] Fix build issue on ESP8266
      [Cleanup] Use new addSelector function of FormSelectorOptions class
      [Cleanup] Remove no longer used markup functions
      [Cleanup] Add "reloadOnChange" icon for all occasions change will reload
      [Cleanup] Move duplicate 'tooltip' code to separate function
      [Cleanup] Add tooltip about ReloadOnChange icon
      [Cleanup] Reduce build size when using empty class name on FormSelector
      [Cleanup] Reduce bin size using FormSelectOptions class
      [Build] Reduce bin size by reducing nr. arguments in addTextBox
      [Build] Fix build errors on ESP8266
      [PSRAM] Use PSRAM for logs, events and controller queues
      [Memory] Fix freeing of allocated strings
      [Memory] Add small optimization in free_string() to prevent copying
      [P123] Fix crashes when using P123, Touch Handler
      [Memory] Tweak some memory allocations
      [Crash] Fix failed init on special String to store in PSRAM
      Fix loading I2C Tourchscreens webpage
      [TouchHandler] Fix ESP8266 build
      [DeviceStruct] Properly initialize DeviceStruct class
      [I2C] Fix build failure on ESP8266
      [I2C] Show conflicting I2C bus when using multiple I2C busses
      [I2C] Fix saving 2nd I2C bus GPIOs
      [I2C] Rename "I2C Interface" to "I2C Bus"
      [NeoPixel] Fix issue running addressable LEDs on ESP32S3 with OPI PSRAM
      [ESP32-S3] Fix max. 63 addressable LEDs on ESP32-S3 with OPI PSRAM
      [Build] Delete ESP8266 concatenated temp file
      [ESP8266] Fix crash on processing log with weblog enabled.
      [Cleanup] Simplify generating sysinfo page
      [ESP8266] Fix crash on ESP8266 SDK 2.7.4
      [ESP8266] Balance more what should be allocated on 2nd heap
      [Memory] Make memory allocation on ESP8266 2nd heap more stable
      [Memory] Move C001 and C002 queue elements to 2nd heap (ESP8266)
      [Memory] Move other controller queue elements to 2nd heap (ESP8266)
      [Memory] Improve memory usage on Strings and task data
      Fix missing include in NodeStruct.cpp
      [Memory] Fix crashes on ESP32-S2 with 8M PSRAM
      [Build] Fix build errors
      [ESP32S3] Disable custom SDK settings on ESP32S3 with OPI PSRAM
      [CDN] Enable custom CDN for all ESP32-builds
      [Build] Change copy_tree import due to Python 3.13
      [Rules] Fix broken math parsing
      [Cleanup] Optimize parsing system variables
      [WiFi] Fix loading credentials after WiFi scan
      [Console] Reduce CPU load on ESP32-S3 sending logs to serial
      [ESP-IDF5.4] Prepare for ESP-IDF5.4 with Arduino 3.2.0
      [Serial] Add setXxBufferSize functions
      [ESP-IDF] Update to latest ESP-IDF5.4
      [1wire] Pull up data pin  after reading a bit to support parasitic power
      [1wire] Make sure to also set the GPIO to output
      [1wire] Simplify code & set data pin high when not used
      [1-wire] Make timing more strict according to datasheet + strong pull-up
      [1-wire] Make 'high' time depending on RC-time of bus
      [1-wire] Fix reading single sensor powered via parasitic power
      [Bug] Fix printing NaN/Inf values
      [1-wire] Fix reading single sensor using parasitic power
      [1-wire] Compensate for measured RC rise time
      [Build] Fix build issue on ESP8266
      [1-wire] Fix set GPIO to output via direct GPIO access
      [1-wire] Cleanup timing critical code
      [1-wire] Reduce jitter on reading short 'low'
      [1-wire] Make timing measurement more strict
      [1-wire] Add more read failure stats, like CRC, power loss, etc
      [Build] Fix build issues on ESP32
      [timing stats] Simplify and speedup collecting timing stats
      [ESP-IDF5.3] Update to latest Arduino/ESP-IDF5.3 version
      [1-wire] Fix ESP8266 builds not fitting in IRAM
      [Build] Reduce build size excluding 1-wire stats for LIMIT_BUILD_SIZE
      [Console] Revert limiting write chunks to 64 bytes for non-USB serial
      [ESP-IDF5.4] Update to latest IDF5.4 code
      [WiFi] Fix setup WiFi scan from web flasher
      [I2C] Fix issues with GPIO 21 & 22 when no I2C is configured
      [Build] Fix ESP8266 build which does not have Wire.end()
      [PinStates] Add ESP32 Periman peripheral bus assignment table
      [Build] Set requirements.txt platformio to 6.1.18
      [PinStates] Add table (ESP-IDF5.5 only) for showing actual GPIO config
      [ADC/DAC] Only include ADC/DAC/Touch on devices supporting those
      [GPIO] Fix checking for correct flash pins IDF5.4/5.5
      [Act LED] Fix disabling WiFi act. LED when changing pin config
      [ESPEasy p2p] Only show remote feed when p2p controller enabled
      [PinStates] Clean up new GPIO states table (IDF5.5 only)
      [Build] Reduce bin  size on ESP8266 disabling some speedup optimizations
      [WiFi RF cal] Always erase WiFi RF calibration on format file system
      [ESPEasy p2p] Prevent node syncing from p2p node with poor time source
      [Minimal OTA] Reduce bin size for minimal OTA build
      [RF Calibration] Automatically re-calibrate when changing ESP-IDF ver.
      [ESP-IDF] Update to latest ESP-IDF5.4
      [RF Calibration] Do not erase rf calibration when formatting file system
      [WiFi RF cal] Disable automatic clear of RF calibration
      [ESP-IDF 5.4] Update to latest ESP-IDF5.4
      [SysVar] Add %c_random%(L,H) system variable
      [SysVar] Do not include new %c_random% in LIMIT_BUILD_SIZE builds
      [Build] Add normal_ESP32s3_4M316k_LittleFS_CDC_ETH

Ton Huisman (228):
      [MQTT] Controller improvements
      [P086] Format source using uncrustify
      [MQTT] Add support for P086 events to all MQTT Controllers
      [MQTT] Only handle plugin if plugin included
      [C014] Use getHostname() for %sysname%, some code optimization
      [P139] Add support for AXP2101 Powermanagement
      [P139] Exclude AXP2101 from ESP8266 builds
      Cherry pick: [IPv6] Reduce events to keep webserver alive [Memory] Flush buffer after sending web page to reduce memory used (code by @TD-er)
      [P139] Add AXP2101 to I2C Scanner
      [P139] Add chargeled and batcharge options, Code cleanup
      [P139] Add generate events option, chargestate and battery detect, fix issues
      [P139] Add chipid and chargingdetail support
      [String] Add `FsP` macro to convert Flash string to String.c_str() pointer
      [P139] Add I2C-enabled check, implement FsP macro
      [C014] Process %sysname% via parseSystemVariables(), logging improvements
      [Controllers] Minor improvements and corrections
      [C004] Some string optimization
      [C004] Add documentation and examples
      [C007] Emoncms: add configurable url (Controller Publish)
      [Coo4] Fix merge conflict issue
      [MQTT] Restore improvement lost at merge conflict
      fix merge conflicts
      [P096] Add default font setting
      [Functions] Add 'map' function
      [Functions] Fix quoting in rules documentation
      [Functions] Rewording argument names in documentation
      [ColorCode] Add map function
      [Functions] Use colon as the argument separator instead of a comma
      [Functions] Switch to using existing fruntion mapADCtoFloat() to enable using float values
      [Docs] Updates for 2025, minor improvements and  corrections
      [P144] Docs update as plugin is also available in Climate build
      [Build] Add plugins in check for enabling ESPEasySerial library
      [Commands] Add commands LoopTimerSetAndRun (_ms)
      [Commands] Update documentation for LoopTimerSetAndRun (_ms)
      [Commands] Fix a bug and a few typos
      [Hardware] Add `double` implementation for `mapADCtoFloat()`
      [Math] Fix double estimation of epsilon in compare functions
      [Math] Fix float estimation of epsilon in compare functions
      [Hardware] De-duplicate implementation for `mapADCtoFloat()`
      [Math] Fix compilation for concatenated sources
      [Commands] Add new commands to Easy ColorCode
      [Build] Update Custom-sample.h
      [SysVars] Add variable `islimited_build`
      [ColorCode] Add variable `%islimited_build%`
      [Docs] Updates for the Tools page documentation
      [ColorCode] Add Provision (sub)commands and events
      [SysVars] Add variable `isvar_double`
      [ColorCode] Add variable `%isvar_double%`
      [ColorCode] Add commands for [P169] and [P175]
      [ColorCode] Combined updates for 2025-01
      [ColorCode] Revert and move updates to separate PR
      [ColorCode] Revert and move updates to separate PR
      [ColorCode] Revert and move updates to separate PR
      [ColorCode] Revert and move updates to separate PR (LF fix)
      [ColorCode] Revert and move updates to separate PR
      [P076] Add preset for Shelly Plus PLUG-S (ESP32)
      [ColorCode] Revert and move updates to separate PR (LF fix)
      [ColorCode] P175 shares commands with P053: Remove duplicates
      [CustomDashboard] Serve .esp pages streaming to avoid HTTP/0.9 response
      [Docs] Fix some typos in Serial Server rules example
      [Math] Guard logging statements with level check
      [Build] Use default nr of elements for stats in Custom builds, unless manually set
      Revert prematurely committed code fragment
      [Math] Rename argument to have less confusing name
      Revert [Math] Rename argument to have less confusing name
      [Math] Rename argument to have less confusing name
      [Math] Move `mapADCtoFloat()` from Hardware to ESPEasy_math helper
      [MQTT] Add setting for Keep Alive Time
      [Custom] Fix code comments for PlatformIO Custom builds
      [Bugfix] Parsing of negative numbers got confused by (multiple) arguments
      [Bugfix] Improve parsing of negative numbers, RPN stack processing revisited, debug logging commented out
      [Build] Small code size reductions to optimize ESP8266 builds
      [Build] Reduce code size to allow for some bugfixes in limited builds
      [Build] Fix typo
      [Bugfix] RTTTL feature was not enabled for ESP32 Collection builds
      [Build] More code reductions in .ino files [P054] .. [P091]
      [Build] More code reductions in .ino files [P092] .. [P110]
      [Build] More code reductions in .ino files: Cleanup PLUGIN_DEVICE_ADD
      [Build] Small code reductions in .ino files [P111] .. [P122]
      [Bugfix] AdaGFX helper [<tft>#length."<text>"] and #textheight didn't support period separator
      [Build] Small code reductions in .ino files [P123] .. [P176]
      [Info] Show sketch size and remaining space
      [RTTTL] Fix typo
      [Build] Enable RTTTL feature for Solo1, C2 and C6 builds
      [Build] Revert unneeded COLLECTION_RTTTL feature for Solo1, C2 and C6 builds
      [LIB] AnyRtttl cherry-picked latest updates, disable unused function that causes a compiler warning
      [PWM] Use defined constant instead of bare value
      [RTTTL] Adjust to work with ESP32 IDF 5.x
      [RTTTL] Fix a typo, explicitly connect GPIO to Tone channel
      [RTTTL] Fix playing the sound properly by not messing up the frequency setting
      [P097] Fix compiler warning
      [P097] Fix some typos
      [P139] Apply some code optimizations
      [P139] Fix silly typos
      [P137] Add predefined settings for M5StickC Plus
      [P137] String deduplication improvement
      [Libs] AXP2101 corrections
      [P139] Enable writing to AXP2101 chip
      [P137] Update documentation
      [P139] Add documentation
      [Docs] Priority task updated layout
      [P139] Documentation updates, updated TTGO T-Pcie configuration defaults
      [P139] Fix configuration constructor typo
      [P137] Bugfix: commands axp,ldo2,x .. axp,dcdc3,x weren't working as intended
      [Console] Support Backspace to correct typos
      [P139] Uncrustify formatting
      [P139] Fix saving settings & predefined, also when task is not enabled
      [P139] Updated TTGO T-Pcie configuration defaults
      [I2C] Add support for multiple I2C interfaces
      [I2C] Re-order I2C variables for better alignment, add (Custom) defaults
      [I2C] Add conversion to adjust defaults if all zeroes
      [I2C] Add more getters to SettingsStruct to simplify code
      [I2C] Fix compilation for ESP8266
      [N001] Use a non-TLS client for SMTP on port 25
      [MQTT] Don't subscribe to empty topics
      [N001] Allso apply to port 2525
      [N001] And clean up object after use
      [N001] Documentation update about port 25 and 2525 (ESP32 with TLS)
      [P139] Update predefined settings for LilyGO T-Beam S3
      [N001] Add pointer null-checks, close client also when connection fails
      [N001] Only delect object if created via new
      [I2C] Code improvements and UI issues fixed
      [I2C] Code improvements and UI issues fixed
      [I2C] Make I2C Interface selector reload page when needed (multiplexer enabled)
      [I2C] I2C Scan layout improvements
      [I2C] Update documentation
      [Build] Add Powermanagement plugins to ESP32 Climate builds
      [P140] Add CardKB I2C Keyboard
      [P140] Switch to VType DUAL from STRING so events are sent as intended
      [P140] Update description
      [P140] Change category, add options and commands, show current buffer, add to I2C scanner
      [P140] Add documentation
      [Dist] Upgrade Espressif Flash Download Tool 3.9.8
      [Libs] Avoid using Wire.begin()
      [Device] Initialization and alignment improvements on struct
      [I2C] GPIO (de)coupling improvements
      [I2C] Clean up unneeded logging
      [FormSelector] Use INT_MAX as default to avoid -1 -none- value being shown as default
      [I2C] Update screenshot without (default)
      [GPIO Selector] Show Wifi Status LED and Reset Pin when configured
      [I2C] Switch to correct bus for PCF/MCP GPIO monitoring
      [I2C] Docs: Use I2C Bus instead of I2C Interface
      [SD-card] Bugfix: Reading a bmp file from SD-Card didn't work as expected
      [SD-card] Remove unneeded logging
      [SD-card] Code corrections
      [Build] Use build-runners on Ubuntu-latest
      [Build] Add some missing plugins to Custom-sample.h
      [P116] Add support for ST7735 172x320px display
      [P177] Add plugin Environment - XDB401 I2C Pressure
      [GPIO] pinSelectors and hardware page show overlapping PSRAM and other conflicting uses
      [P177] Corrections in data initialization, handling and calculation, add settings to generate events or use raw data
      [P177] Corrections in calculation, add setting to ignore negative values
      [P177] Revert modified temperature calculation
      [P177] Improved calculations, without bit-manipulation
      [P116] Enable alternative configurations for ST7789 135x240px displays, ESP32 DISPLAY and MAX builds
      [P177] Fix typos in calculations, avoid a division
      [P177] Swapped Temperature and Pressure values, re-order task settings page
      [Build] Reduce number of ESP32 builds by removing non-Ethernet builds
      [P095] Bugfix: backlight subcommand not working as intended
      [Build] Add ESP32-C3 MAX 16M8M configuration
      [Docs] Update README.md
      [Pinstates] Change infobutton link to RTD Plugin list
      [P177] Ignore status bit for data-ready, add some extra development logging
      [UI] Change more infobutton links to RTD links
      [P116] Small UI improvements
      [P116] Update documentation, refresh some screenshots
      [P177] Disable development logging
      [P177] Change Sensor_VType to SENSOR_TYPE_TEMP_BARO (Domoticz)
      [P036] Add setting to hide the startup logo
      [Build] Upgrade setuptools package to avoid build issues
      [Build] Only pio pkg update for current environment
      [Build] Upgrade to platform_packages build 3427
      [Build] Upgrade to Solo1 platform_packages build 3428
      [Build] Temporary disable most envs for testing
      [Build] Add logging to see current dir data
      [Build] Temporary revert to pio 6.1.16
      [Build] Make extra_scripts explicit
      [Build] Swap script-append order
      [Build] execute copy_files.py explicitly post: build
      [Build] Remove logging to see current dir data
      [Build] execute copy_files.py explicitly pre: build to not mis installing the handler
      [Build] Restore envs, minor env config improvements for Solo1 builds
      [P100] Retrieve CountTotal value
      [Docs] Add SPIFFS to LittleFS migration guide
      [P177] Add documentation
      [Build] Script copy_files.py tweaked to start in the correct order
      [Build] Temporarily disable most builds for testing
      [Build][CI] Explicity call bin_elf_copy in CI script
      [Build] Process copy_files in post_esp32 script
      [Build] Process post scripts in different order
      [Build] Re-enable builds after testing
      [Build] Re-enable builds after testing
      [Commands] I2CScanner command show bus that's being scanned
      [Review] Improvements and typos fixed
      [Boards] Fix typo in ESP32-S3 16M definition
      [P177] Add missing class access specifier
      [P100] Add documentation
      [P100] Add option to show CountTotal value, enable Plugin Stats
      [P100] Update documentation
      [Build] Add ESP32 Climate LittleFS build
      [I2C] Move Clock Stretch setting to Hardware page, move I2C enabled check global
      [Rules] Add optional use of named variables
      [Rules] Reject invalid variable names
      [Rules] Update documentation
      [Rules] Update documentation, add some examples using named variables
      [Rules] Update documentation
      [AdaGFX Helper] Docs for adding a custom font
      [AdaGFX Helper] Docs extended and some typos fixed.
      [Rules] Change example to use named variables
      [I2C] De-duplicate code
      [AdaGFX Helper] Docs extended based on review
      [P104] Bugfix: Apply fontspacing correctly on double-height fonts
      [P104] Enable double-height numeric font for ESP32 builds, minor code improvements
      [P104] Zone order setting was missing the reload-on-change flag
      [P020] Improve data handling send unaltered via network client generate hex event data apply RX buffer size
      [P020] Add support for UDP -> Serial receiver
      [P020] Fix compiler warning
      [Commands] Add command SendToUDPMix
      [P020] Update documentation
      [Rules] Allow eventname and eventpar processing for explicit string events (!serial)
      [Rules] Enable substring function to return the remainder of a string (with docs update)
      [P020] Start UDP-listener once the network is available
      [Rules] Small documentation update for events starting with !
      [P104] Fix increasing character spacing when changing double-height fonts
      [Bugfix] Rules fix handling for nested shorthand vars
      [Bugfix] Build: Adjust processing order for gzip-firmware script
      [Bugfix] MQTT Controller: Keep Alive Time reset to/use default (60 sec) when 0
      [I2C] Renumber buses starting from 0 instead of 1

chromoxdor (31):
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Update _P097_Esp32Touch.ino
      Udated code + added documentation
      Update P097.rst
      Update P097.rst
      [P164] add aqi to taskvalues
      Updates
      update: changelog
      [P038] Fix HSV values in documentation
      Update _P097_Esp32Touch.ino
      adding mapc to constrain values
      Update Rules.rst
      using constrain instead of std::clamp
      Update Rules.rst
      Update Rules_calculate.cpp
      add cheatcode, fix one typo
      Update UDP.cpp
      Update StringParser.cpp
      Update StringParser.cpp


-------------------------------------------------
Changes in release mega-20241222 (since mega-20240822)
-------------------------------------------------

Release date: Sun Dec 22 11:08:22 PM CET 2024

Bartłomiej Zimoń (2):
      if we wait for data from SMTP - do not flush received data
      EMail - correct response checking

Hans-Rune Bue (4):
      Initial ESPeasy tools add
      ESPeasy tools readme
      Missing $ in
      Document enhancements on requirements, security + linting

TD-er (204):
      [MQTT TLS] Add TLS support for MQTT
      [MQTT TLS] Add cert.py to extract certificate info
      [MQTT TLS] Allow to load CA root cert from file
      [Web] Allow to stream from file system (e.g. CSS inline)
      [MQTT TLS] Patch CA root cert to match strict layout
      [MQTT TLS] Work-around for memory leak in MbedTLS (not finished)
      [MQTT TLS] Fix memory leak... finally
      [MQTT TLS] Clear CA certificate when starting a new connection
      [Cleanup] Fix lots of missing delete calls to free memory
      [Webserver] Fix serving CSS
      [TLS] Add ALPN protocol
      [TLS] Add fix for WiFiClientSecure connection timeout
      [MQTT TLS]Display connection info on controller page
      [Cleanup] Use .clear() on strings instead of assigning empty string
      [TLS] Making proper datastructure init
      [MQTT TLS] Improve controller setup page show peer certificate
      [MQTT TLS] Add certificate fingerprint validation
      [MQTT TLS] Add view of certificates + option to store
      [MQTT TLS] Add TLS support for MQTT
      [MQTT TLS] Add cert.py to extract certificate info
      [MQTT TLS] Allow to load CA root cert from file
      [Web] Allow to stream from file system (e.g. CSS inline)
      [MQTT TLS] Patch CA root cert to match strict layout
      [MQTT TLS] Work-around for memory leak in MbedTLS (not finished)
      [MQTT TLS] Fix memory leak... finally
      [MQTT TLS] Clear CA certificate when starting a new connection
      [Cleanup] Fix lots of missing delete calls to free memory
      [Webserver] Fix serving CSS
      [TLS] Add ALPN protocol
      [TLS] Add fix for WiFiClientSecure connection timeout
      [MQTT TLS]Display connection info on controller page
      [Cleanup] Use .clear() on strings instead of assigning empty string
      [TLS] Making proper datastructure init
      [MQTT TLS] Improve controller setup page show peer certificate
      [MQTT TLS] Add certificate fingerprint validation
      [MQTT TLS] Add view of certificates + option to store
      [Webserver] Fix merge issue (MQTT TLS)
      [Merge Fix] Restore P095 and P096 from mega branch
      [MQTT TLS] Fix missing include mbedtls/oid.h
      [MQTT TLS] Fix missing include <vector>
      [Build] Fix merge issue.
      [MQTT TLS] Fix build issues
      [MQTT TLS] Disable fingerprint verify on ESP8266 as not implemented
      [MQTT TLS] Disable USE_MQTT_TLS for LIMIT_BUILD_SIZE and 1M builds
      [MQTT TLS] Disable TLS for ESP8266 completely
      [MQTT TLS] Rename USE_MQTT_TLS to FEATURE_MQTT_TLS
      [MQTT TLS] Resize certificate info textareas
      [MQTT TLS] Fix layout controller page
      [MQTT TLS] Cleanup, reducing build size when no MQTT TLS is set
      [Build] Disable ext. RTC on limited build size builds
      [Build] Reduce bin size by excluding libs from 1M builds
      [GPS] Fix set system time via GPS
      [MQTT TLS] Add MQTT TLS feature to ESP32 MAX builds
      [GPS] Use custom GPS view of plugin stats data
      [MQTT TLS] Fix crashes due to null pointer dereference.
      [Controller] Allow system variables in controller username
      [Cache Reader] Add intended nr of 'samples' per bulk message
      [Cache Reader] Cleanup Export dump to CSV & fix separator
      [Cache Reader] Allow bulk dump CSV to MQTT
      [Cache Reader] Fix serving 'last line' of stored data
      [Cache Reader] Send bulk taskinfo in either CSV or JSON, using settings
      [TaskRun] Reschedule task to set Interval
      [TaskRun] Cleanup code
      [Build] Cleanup code + reduce build size
      [TaskRun] Fix new command ScheduleTaskRun
      [Cleanup] Simplify generating task events
      [Cleanup] Reduce build size by omitting some conversions
      [ADC] Add config commands to set calibration
      [ADC] Document new ADC set calibration commands
      [SenseAir] Fix reading error state from sensor
      [Provisioning] Fix setting allowed file types to download via rules
      Revert accidentally committed pre_custom_esp32.py
      [Provisioning] Fix cache and mDNS updates after provisioning
      [SenseAir] Add more sensor info + begin implementing setting ABC
      [Provisioning] Only allow downloading firmware update from set host
      [Cache Reader] Add option to delete files after upload
      [SenseAir] Temperature is 2-complement signed value
      [SenseAir] Fix reading temperature on non-S8 sensors
      [SenseAir] Keep SenseAir code in sync with PR #4550
      [ESP32 IDF] Update to IDF 4.4.5 (2023-06-14)
      [Build] Fix merge issues
      [Build] Fix merge issues MQTT TLS
      [MQTT TLS] Add MQTT import to Custom ESP32
      [MQTT TLS] Fix merge issues
      [MQTT TLS] Fix static_assert check after update with 'mega' branch
      [Math] Improve intuitively matching & printing floating point values
      [Build] Reduce bin size on ESP8266 Collection D
      [Build] Reduce build size, disabling float print optimization on ESP8266
      [MQTT-TLS] Fix merge issue
      [MQTT-TLS] Fix merge issues
      [Build] Remove CUL reader from ESP8266 collection D build due to size
      [P001] Reduse build size
      [P001] Fix Uncrustify formatting
      [P001] Change runtime counters from PCONFIG to datastruct members
      [P001] Cleanup code using less macro code
      [P001] Cleanup code
      [P001] Cleanup code & add comments
      [P009] Apply same code restructure as for P001
      [P019] Apply same code restructure as for P009
      [P009] Remove temp files
      [P001] Use aliases for PCONFIG to access settings
      [GPIO] Move duplicate code for init P001/009/019 to shared function
      [GPIO] Create generic handler for GPIO plugins
      [GPIO] Deduplicate code in PCF and MCP code for P019 and P009.
      [GPIO] Try to match P009 and P019 code to be the same as P001 code
      [GPIO] Make P001/P009/P019 share the same code
      [GPIO] Fix missing check to recover from offline mode
      [ESP-IDF5.3] Add support for ESP-IDF5.3 and SPIFFS builds for IDF5.1
      [ESP-IDF5.3] Fix crashes on sysinfo page
      [ESP-IDF5.1] Add LTO to reduce bin size for ESP-IDF5.1 SPIFFS build
      [ESP-IDF5.3] Fix usable UART ports on ESP32-C6
      [Build] Fix build error on ESP32 Minimal OTA builds (debug/test builds)
      [ESP-IDF5.3] Add 5 GHz WiFi modes for upcoming ESP32-C5
      [HeatpumpIR] Update lib to latest code
      [Sysinfo] Add used ESP-IDF version to sysinfo page
      [HeatpumpIR] make the library compile again in ESP-IDF5.3
      [ESP-IDF] Make ESP32-S2 build again
      [Arduino] Add define as workaround for Arduino change flush() to clear()
      [Uncrustify] Cleanup _P091_SerSwitch.ino
      [ESP-IDF5.3] Fix building on Windows
      [ESP-IDF 5.x] Fix detection of ESP32-rev3
      [EDP-IDF] Update to latest IDF5.1 (SPIFFS) & IDF5.3(LittleFS) Arduino304
      [ESP-IDF] Simplify eco mode power management
      [ESP-IDF5.3] Update to latest IDF5.3/Arduino3.0.5
      [ESP-IDF] Revert IDF5.3 to IDF5.1 due to WiFi scan issues
      [WiFi] Add copy constructor to WiFi_AP_Candidate
      [Cleanup] simplify ExtraTaskSettings constructor
      [ESP-IDF5.3] Switch back to IDF5.3 for LittleFS builds
      [N001_Email] Increase parse buffer size + cleanup
      [ESP-IDF5.3] Fix build solo1 builds
      [Email] Set timeout on the connection itself
      Do not apply nr. of decimals before calculating formula (#5123)
      [GPIO] Revert some changes regarding send bootstate on P001
      Add .platformio to gitignore
      [GPIO] Revert some changes regarding send bootstate on P001
      Fix formatting nr. decimals with formula (#5123)
      [Email] Early exit on failing Auth calls + some cleanup
      [ESP-IDF5.3] Move to latest Arduino 3.1 / ESP-IDF 5.3.1 (LittleFS build)
      [ESP-IDF5.3] Move to latest Arduino/IDF code
      [Email] Fix issues with different mail server versions
      [Email] Add missing define
      [Email] Fix ESP8266 2.7.4 builds
      [Email] Add missing changes in NotificationPage.cpp
      [Rules] Fix saving rules on ESP-IDF5.3
      [Cleanup] Reduce SaveRules.js
      Fix saving task names when rules are enabled
      Add work-around for changes in File::position()
      [Build] Fix copy/paste error
      [Cleanup] Remove duplicate define from platformio ini file
      [Build] Fix max builds
      [Uncrustify] Update config for latest version of Uncrustify
      [uncrustify] Apply new uncrustify version on some recently changed code
      [ESP-IDF5.3] Update to SDK IDF5.3.1/Arduino3.0.5 20240924
      [ESP-IDF5.3] Update to 20240926
      [GPIO] Fix build warnings on ESP8266 for GPIO direction
      [ESPEasy p2p] Fix sending task value data on ESP8266
      [LibSSL] Add LightBearSSL lib made by Tasmota
      [MQTT-TLS] Switch to Tasmota's Light-Weight BearSSL lib
      [MQTT TLS] Fix build hidden write(uint8_t)
      [MQTT-TLS] Enable TLS for MQTT on all ESP32-xx Custom builds
      [MQTT TLS] Disable PSK option
      [MQTT TLS] Uncrustify controller source files
      [MQTT-TLS] Improve stability of MQTT connection while serving JSON pages
      [PVS-Studio] Add fixes suggested by PVS-Studio
      [MQTT-TLS] Make connection to broker more stable
      [MQTT TLS] Disable certificate validation options for now
      [MQTT TLS] Add some documentation about using TLS for MQTT
      [Controller] Fix really strange merge issue (return statement got lost)
      [HeatpumpIR] Rename lib folder to make it compile on Windows
      [HeatpumpIR] Make IRext builds fit again on ESP8266
      [Build] Add already a shorter folder name for core_dir for future builds
      [Email] Split N001_Email.ino into N001_data_struct
      [Email] Add SSL support for email
      [Email] Fix builds + include N001 in all ESP32-xx custom builds
      [Build] Fix builds which do not have DEBUG log level included
      [Email] Clean-up code
      [BearSSL] Update to latest BearSSL code
      [Email] Enable SSL for email and MQTT on all ESP32-xx builds
      [Email] Fix failed builds
      [Email] Fix silly mistake
      [Email] Add documentation describing SSL port 465
      [CSS] Add retry to load CSS when first attempt failed
      [Docs] Add info how to use USB serial with WSL2
      [WSL2] Add simple script to set permissions for USB to serial in WSL2
      [ESP-IDF] Switch to latest ESP-IDF/ESP32-Arduino 3.0.7
      Fix custom build with <2 included plugins (#5150)
      [P176] Simplify handling temporary values before checksum checked
      [GPS] Add course (bearing) as output option
      [PSRAM] Free GPIO-16 and -17 on ESP32-classic when no PSRAM present
      [PSRAM] Fix build on ESP-IDF 5.1 + add special case of ESP32-picoD4
      [PSRAM] Cleanup code
      [PSRAM] Fix solo1 builds
      [PSRAM] Fix solo1 builds
      [GPIO] Allow to select GPIO-10 on ESP32-U4WDH
      [GPIO] Fix missing check on ESP32-classic for GPIO-10 with emb. flash
      [ESP32C3] Allow GPIO 11, 12, 13 to be used on specific boards
      [ESP-IDF] Update to latest ESP-IDF5.3 for ESP32-xx LittleFS builds
      [ESP32-solo1] Update to latest ESP-IDF5.3 for solo1
      [ESP-IDF5.3] Fix build platform for Solo1
      [Webserver] Fix stalled web requests and not saving rules via Ethernet
      [ESP32] Update to latest Arduino 3.1.0 release
      [Build] Fix building ESP8266 builds
      [Build] Fix merge issues in platformio.ini
      [ESP32-solo1] Fix bootloop on Solo1 boards

Ton Huisman (113):
      [P103] Add support for EZO-HUM sensor
      [P103] Fix some issues, add logging for analysis
      [P103] Fix more issues, add/apply settings for EZO-HUM
      [P103] Handle EZO-HUM firmware issue of unexpected 'Dew' in output
      [P103] Fix to apply new `UserVar` usage
      [P113] Add Region of Interest configuration
      [Devices] Update/Add help links for Stats
      [P113] Check invalid ROI settings after in-place update
      [P163] Add plugin Counter - RadSens I2C radiation counter
      [DevicesPage] Fix clearing the Low I2C speed setting when reusing a task
      [P163] Enable plugin in ESP32 Collection G builds
      [P163] Prevent protential memory leak
      [P163] Add to Custom-sample.h
      [P163] Use Count-average when available, change to Environment category
      [P163] Add documentation
      [P163] Fix missing nullptr check if Count stats not enabled but other stats is
      [Lib] RadSens: Add non-incremental pulses reading and reset of incremental counter
      [P163] Add optional non-incremental counting and reset command/option
      [P163] Update documentation
      [P165] Add plugin Display - NeoPixel (7-segment)
      [P165] Add code from #4977
      [P165] Add code from #5091
      [AdaGFX] Add rgb565/rgb888 color conversions
      [P165] Add Clear display on exit, add manual g-segment split, rework UI for better Extra pixel display, many bugfixes
      [P165] Breaking Settings change! (delete & re-add) Allow 7 pixels/segment for w/h/dot, add 7dbefore command
      [P173] Add plugin Environment - SHTC3
      [I2C] Add functions I2C_write16() and I2C_write16_LE()
      [P165] Add digitmapping for having all RTL groups, UI improvements and fixes
      [P173] Add to I2C scanner
      [P165] Add counter-clockwise numbering, enable digit/group color commands for all builds
      [P173] Add documentation, include in standard C6 Custom build
      [DeviceStruct] Add PinDirection flag for PIN1..PIN3
      [DeviceStruct] Add PinDirection flag for PIN1..PIN3
      [P165] Apply PinXDirection feature
      [P165] Add new commands to EasyColorCode (some are defined for P073)
      [P165] Add documentation and a few configuration examples
      [DeviceStruct] Apply PinXDirection flags for all plugins where appropriate, cleanup unneeded Device flags, reformatted some plugin sources
      [P173] Add to Custom-sample.h
      [EasyColorCode] Command Reset is renamed to FactoryReset
      [P165] Add more code from #5091
      [P165] Fix some bugs found during testing
      [EasyColorCode] Also update minified js file
      [P165] Add more code from #5091
      [P165] Disable periods handling if no decimal dot pixels defined
      [P165] Small bugfix
      [P113] Add UI selection of ROI area (single area selection only)
      [Build] Possible fix for unstable builds
      [Build] Possible fix, part 2, for unstable builds
      [P165] Bugfixes and javascript optimizations
      [P165] Bugfixes and javascript optimizations
      [P113] Improve UI selection of ROI area for touch devices, code improvements
      [P113] Update documentation
      [P113] Improve UI selection of ROI area for touch devices, code improvements
      [UI] Fix disabled-checked Checkbox styling, and allow to enable/disable from js
      [P165] Add option to start numbering at g-segment
      [P165] Add option to use decimal dot for blinking time indicator
      [P165] Fix initialization of output mode
      [Scripts] Fix some issues and upgrade to external changes
      [P054] Allow GPIO configuration for ESP32 units
      [P054] Use Direct-GPIO and implement ESPEasySerial
      [P113] Further minify embedded js
      [P165] Small bugfix
      [P165] Update documentation
      [P054] Add documentation, small UI improvement
      [N001] Email password should use a password input field
      [P159] Extend max threshold
      [P175] Add Dust - PMSx003i (I2C) Sensor
      [P175]/[P053] Check for useable variables
      [P175] Fix reading checksum and data frame correctly
      [P175]/[P053] Optimize re-use of code, add sensor to I2C Scanner
      [P175] Add documentation (partially shared with P053)
      [P175] Show GPIO config on Devices page
      [P103] Javascript fixes, code improvements
      [Build] Fix: Use package with Solo1 'autodetect' (Solo1 specific packaged removed)
      [Build] Fix: Use package with Solo1 'autodetect' (Solo1 specific packaged removed)
      [P176] Add plugin Communication - Victron VE.Direct
      [P176] Add some features and code improvements
      [P176] Fix ESP8266 build issue
      [P176] Update taskvalues at receiving data, other improvements
      [P176] Fix use of plugin compiletime feature flags
      [P176] Move Led initialization to DataStruct initialization function
      [P176] Add documentation
      [P176] Refactorings to optimize performance (lower load), remove RX Timeout setting
      [P176] Update documentation
      [P176] Avoid calling serial->available() too often, uncrustify some recent changes
      [P176] Update changelog (and GH Actions failed)
      [P176] Handle ON and OFF values as 1 and 0
      [P176] Fix checksum validation, was ignoring the first line after receiving a valid checksum
      [P045] Add optional data collection for all axis
      [P045] Update documentation
      [P045] Set correct Sensor_VType for 3 values
      [Build] Enable Servo support for most builds
      [P176] Add variables `successcount`, `errorcount` and `ischanged`
      [Docs] Updates and fixes, November 2024
      [Docs] Rewording a few phrases
      [P176] Rename variable `ischanged` to `updated`
      [P103] Add documentation
      [P103] Fix cast issue
      [EasyColorCode] P020/P044/P087 serial commands
      [P020] Fix docs typo
      [P176] Add Events only when updated option and docs
      [P176] Fix bug in screenshot :-)
      [P009]/[P061] Add note about possible non-working input for MCP23017 PA7/PB7 pins
      [C002] Bugfix: Use correct GPIO pin for controlling P001
      [P105] Add Alternative initialization option for AHT10 clones
      [P041][P042] Update documentation (no longer in Normal builds)
      [P159] Allow max threshold of 101, to resolve an off-by-one error
      [P159] Update documentation
      [P021] Move ifdef to .h file to avoid compiler warnings
      [P057] Fix mprint command to skip the colon segment
      [Controllers] Process % variables before functions
      [Controllers] Change variable replacement order so string functions can be used
      [FactoryReset, ESP8266] Use settings from Custom.h on clean install

chromoxdor (8):
      Update Misc.cpp
      Update Misc.cpp
      Update Misc.cpp
      [P049] added commands
      Update P049_commands.repl
      Update P049.rst
      Update P049.rst
      Update Command.rst

dependabot[bot] (1):
      Bump cryptography from 38.0.3 to 43.0.1

flashmark (18):
      Added state extension
      Fix backwards compatibility issue and tidy up
      Reworked after pull request
      Rework after review
      Cleanup, fix init issue
      Update documentation
      Minor fixes
      P021 Optimize memory footprint
      P021 fixed issue in control algoritm
      P021 Squeeze out some flash usage
      P021 timer initialization
      P021 another set of shaving flash memory consumption
      P021 fixed an oops and reworked review comments
      [P021] disable new feaures for low memory builds. Fix issues.
      [p021] fixed unused variable
      [P021] Documentataion update to refect limited build versions
      [P021] Bugfix
      Minor style change

uwekaditz (13):
      Changes for PR5097
      Code uncrustified
      Function ReplaceTokenDelimiters() to be used for user defined headers and line content
      Changes requested by tonhuisman
      Documentation formatted
      NEW: functions stripEscapeCharacters() and hasEscapeCharacters()
      More advanced parsing as requested by @tonhuisman
      Reuse of 0x11/0x12 also for the \( and \)  changed to 0x05/0x06
      Documentation updated
      Documentation updated for functions
      Removed unneeded string init, code simplified
      BUG: simplified stripEscapeCharacters() did not work
      Disable P040 (RFID - ID12LA/RDM6300) for PLUGIN_BUILD_IR_EXTENDED_NO_RX  due to limited size


-------------------------------------------------
Changes in release mega-20240822 (since mega-20240414)
-------------------------------------------------

Release date: Thu Aug 22 10:35:20 PM CEST 2024

Gijs Noorlander (11):
      [Cleanup] Revert accidentally changed line endings
      [PluginStats] Show average rate and total duration of collected stats
      [PluginStats] Add nr of samples to chart legend
      [PluginStats] Uncrustify/cleanup code
      [Build] Fix build due to static var with too generic name
      [Docs] Remove unused files for P169
      [Docs] Document getconfig and commands for P169 AS3935
      [AS3935] Fix restart measurement after running calibration command
      [PluginStats] Fix patching timestamps from before system time was set
      [AS3935] Enable auto gain and reduce number of events
      [Sonoff POR] Move Sonoff POW R1/R2 ESP8266 build back to core 2.7.4

TD-er (139):
      [IPv6] Add option to enable/disable IPv6
      [AdaGFX Helper] Make "1" in TomThumb font as wide as all other numbers
      [NeoPixel] Add AHT20 support to ESP32 NeoPixel build.
      [NeoPixel Matrix] Fix trailing pixels on scrolling text
      [Hidden SSID] Fix ESP32 connecting to hidden SSID with channel > 11
      [ESP-IDF5.1] Update to latest SDK code + fix HWCDC
      [ESP32 WiFi] Add info about found AP from scan
      [ESPEasy p2p] Add p2pNode#Connected and #Disconnected events
      [Build] Fix build on ESP-IDF4.4 builds
      [C018] Reduce build size
      [Build] Reduce ESP8266 build size by concat all in single __tmpfile.cpp
      [Build] Reduce ESP8266 bin size disable LittleFS lib + OTA on 1M builds
      [AS3935] Add P169 Lightning Detector plugin
      [AS3935] Improve calibration accuracy
      [AS3935] Implement P169 code
      [AS3935] Add option to measure all calibrated oscillators
      [AS3935] Improve frequency measurement accuracy
      [AS3935] Improve stability and calibration success rate
      [AS3935] Make it compile for ESP8266 and clarify logs
      [AS3935] Fix build on ESP32 IDF4.4
      [AS3935MI] Get in sync with pending PR to original lib
      [AS3935MI] Move frequency count code to original library code
      [AS3935MI] Make frequency count "vanilla Arduino" for non-ESP SoC
      [AS3935MI] Add selection for nr Samples, division, etc
      [AS3935MI] Add '2nd best' check to calibration to retest
      [AS3935MI] Add event on lightning strike and count strikes per interval
      [AS3935MI] Add total strikes counter, sensor stats and cleanup plugin
      [AS3935MI] Cleanup settings & add chart to help tuning
      [AS3935MI] Speedup LCO calibration + simplify configuration
      [AS3935MI] Add timestamp to PluginStats
      [AS3935] Fix compile issue
      [ESP-IDF5.1] Update ESP-IDF SDK to fix HWCDC
      [AS3935MI] Change lib function names to use camelCase
      [ESP-IDF5.1] Fix crashes on LittleFS after factory reset
      [ESP-IDF5.1] Fix crashes on LittleFS after factory reset
      [ESP-IDF5.1] Update to latest ESP-IDF SDK code
      [ESP-IDF 5.1] Exclude some OPI PSRAM speed improvements due to stability
      [Json] Fix showing JSON including pluginstats data
      [PluginStats] Compute average taking timestamps into account.
      [PluginStats] Move stats to PSRAM when available
      [AS3935MI] Rename interrupt enum to match style of other enums in lib
      [Controller] Fail gracefully when almost out of memory
      [Controller] Fail gracefully when almost out of memory
      [ESP-IDF5.1] Fix WiFi issues on ESP32-C6
      [AS3935] Minor clean-up in code and user-interface
      [P169] Start documenting AS3935 plugin
      [ESP-IDF5.1] Fix WiFi issues on ESP32-C6
      [AS3935MI] Get rid of 'magic' values in lib code
      [AS3935] Fix "indoor/outdoor" setting + no longer disable on fail calib
      [AS3935] Document calibration for P169 Lightning sensor
      [AS3935] Add commands to P169 Lightning Detector
      [AS3935] Set task values to output distance Far/Near and remove "energy"
      [ESP-IDF5.1] update to latest ESP-IDF SDK & Arduino 3.0.0
      [mDNS] Enable FEATURE_MDNS again for ESP-IDF5.1 builds
      [AS3935MI] Add validation check for computeCalibratedFrequency
      [AS3935MI] Make ISR attributes like IRAM_ATTR platform dependant.
      [AS3935MI] Add auto gain algorithm to adapt to changes in noise envs.
      [PluginStats] Update recorded timestamps when time is first set
      [AS3935] Improve auto tuning
      [mDNS] Disable mDNS again as it causes major stalls
      [Charts] Add option to zoom/pan for PluginStats charts
      [ESP-IDF5.x] Fix recent change of flush() to clear() in Arduino SDK
      Revert "[ESP-IDF5.x] Fix recent change of flush() to clear() in Arduino SDK"
      [ESP-IDF5.1] Revert Arduino PR 9453 WiFiClient - rename flush() to clear()
      [ESP-IDF5.1] Update to latest platform build
      [AS3935] Disable auto gain for now
      [ESP-IDF5.1] Revert Arduino PR 9453 WiFiClient - rename flush() to clear()
      [Build] Fix merge issues.
      [AS3935MI] Update to 1.3.5 with PRs from ESPEasy changes merged to lib
      [System Load] Reduce system load running background tasks
      [Cleanup] Speedup converting task values to String
      [Cleanup] Speedup converting task values to String
      [Cleanup] Further reduction of load
      [Cleanup] Further reduction of load
      [Cleanup] Revert line ending to CRLF again (.h files)
      [Cleanup] Revert changed line-ending back to CRLF (.cpp)
      [Cleanup] Revert line endings from LF to CRLF
      [Cleanup] Revert line endings from LF to CRLF
      [Cleanup] Revert line ending to CRLF for PlatformIO ini files
      [AS3935MI] Update increase/decrease functions return values in lib
      [PluginStats] Decimate samples by not storing unchanged values
      [AS3935] Add selectable range for auto gain algorithm
      [Build] Remove previously created __tmpfile.cpp files on ESP8266 build
      [AS3935] Add check to see if RCO is still active on IRQ pin
      [ESP-IDF5.x] Update to latest code incl. possible fix for WiFi issues
      [Controller] Fix sending to controller
      [Controller] Fix sending to controller
      [Cleanup] Speedup all calls where task value name was used
      [Build] Fix build error on LIMIT_BUILD_SIZE builds
      [ESP-IDF5.x] Update ESP-IDF/ESP32-Arduino  to latest commits
      [ESPEasy p2p] Improve sharing tasks via p2p + add checksum to UDP packet
      [ESPEasy p2p] Add timestamp to taskvalue data to counter network delays
      [ESPEasy p2p] Fix sending taskinfo packet rejected by  wrong size check
      [ESPEasy p2p] Make taskinfo length more flexible, remove trailing zeroes
      [ESPEasy p2p] Add "Data Source" selection to request remote data feed
      [Cleanup] Remove unused code
      [MQTT] Fix some extreme timeouts when broker is unresponsive (#5075)
      [MQTT] Send keep-alive ping at 2/3rd of MQTT_KEEPALIVE
      [MQTT] Set timeout also for connecting to the MQTT broker
      [Memory] Make special memory allocations more robust
      [Controller] Add time spent in connecting to host to timing stats
      [Cleanup] Rename ambiguously controller_number in controller code
      [Controller] Add note on typical timeout for local vs. online networks
      [PluginStats] Fix inconsistency with pluginstats for ADC plugin
      [MQTT] Fix disconnect when broker sends keepalive ping before client
      [ADC] Improve ADC curve fitting calibration accuracy
      [VL53L0X] Fix ignoring sensor error values
      [VL53L0X] Add async read option to library
      [ESP-IDF5.x] Update to latest ESP-IDF/Arduino SDK
      [WiFi] Add passive/active scan for ESP32
      [Cleanup] Always use the same unit/note for settings, regardless the page
      [ESP-IDF5.1] No longer support Ethernet on ESP32-C2
      [Sysinfo] Add internal temperature to sysinfo (when supported)
      [Build] Fix build due to missing #ifdef checks
      [ESP32 temp] Fix int. temperature sensor not changing range
      [WiFi] Fix WiFi not able to reconnect due to unprocessed disconnect
      [VL53L0x] Make reading sensor async
      [VL53L0X] Actually do read the sensor asynchronous.
      [WiFi] Fix (re)connect to WiFi on ESP32-xx builds
      [VL53L0X] Add filtering + make threshold more intuitive
      [AS3935] Do not set IRQ pin to input when not configured (e.g. p2p share)
      [Time] Simplify system time management + increase resolution to usec
      [Time] Cleanup ESPEasy internal system time management
      [VL53L0X] Cleanup code
      [VL53L0X] Add dynamic filtering, allowing fast response on quick change
      [Time] Improve NTP accuracy and prevent lockups on incorrect data
      [Cleanup] Fix wrong unit for TX power on web UI page
      [Time] Improve accuracy and precision of time sync
      [GPS] Fix filtering out occasional jitter in received GPS timestamp
      [ESP-IDF5.1] Fix hanging when OTA update fails.
      [GPS] Fix showing GPS received time on GPS task page
      [P2P] Fix crashes when processing UDP packets after WiFi disconnect
      [ADC] Change order of mV and ADC value as this is more intuitive
      [OTA] Fix crash/abort of larger OTA updates (e.g. Max builds)
      [GPS] Improve GPS time stability
      [Timesync] Tweak time wander penalty for time since last sync
      [CUL reader] Set nr. filters field to actual nr of used filters via cmd
      [CUL reader] Do not sort CUL filters
      [Readme] Added link to PVS-Studio as used SAST tool

Ton Huisman (280):
      [P123] Add FT6206 Capacitive touch screen
      [AdaGFX] Implement/activate generic 'adagfx_trigger' command-trigger
      [P123] Add arguments to Object events, allow initial events for On/Off button objects minor corrections
      [P123] Code improvements, increased button response
      [AdaGFX] Add support for `btn` subcommand to draw button-like objects
      [P123] Add support for button-simulation using AdaGFX btn subcommand
      [Build] Add -Wswitch compiler option for ESP32 (already active for ESP8266)
      [P123] Minor updates and improvements
      [P123] Limit code & bin size for LIMIT_BUILD_SIZE builds
      [AdaGFX] Improve btn subcommand, slim down bin size, other minor improvements
      [TouchHandler] Introduce ESPEasy_TouchHandler, refactored out of P123 touch support
      [P123] Refactor and implement ESPEasy_TouchHandler
      [TouchHandler] Fix conditional compilation issue
      [AdaGFX] Add support for confined windows to print/draw in [AdaGFX] Add support for getting config values
      [P095] [CP] Fix for displaying text on previous location was not overwriting old content Add Text print mode for centered text Extend txtfull subcommand to enable centered text
      [TouchHandler] Move PLUGIN_WRITE and _GET_CONFIG_VALUE to helper, add getters for state and enabled, add toggle subcommand, handle multiple objects for on, off and toggle
      [P123] Refactor PLUGIN_WRITE and _GET_CONFIG_VALUE to TouchHandler, minor improvements
      [AdaGFX] Remove unused variable
      [AdaGFX] Process like template for length and textheight values
      [AdaGFX] Add/update documentation for window commands and config values
      [AdaGFX] Code improvements, initialization, const, move window offset into printText()
      [AdaGFX] Code improvements as suggested by feedback
      [AdaGFX] Correct font include paths, add #ifndef filename checks to fonts
      [AdaGFX] Regression: Background-fill for text should fill entire line height
      [TouchHandler] Change method arguments to const-by-reference where possible
      [TouchHandler] Strip unneeded prefix from page variables
      [P123] Strip unneeded prefix from page variables
      [TouchHandler] Optimizations (as suggested and more)
      [P123] Fix some spelling issues, code optimizations
      [P123] Minor optimizations
      [AdaGFX] Reduce build some more for LIMIT_BUILD_SIZE
      [P123] Small size improvement
      [TouchHandler] Replace _ in captions and object names by a space, and reverse, might save some settings size
      [UI] Add class table.multi2row for alternating color per 2 rows
      [TouchHandler] Use 2-row alternating color, improvements
      [P123] Code improvements
      [AdaGFX] Add Slider/Gauge support (via btn subcommand), fixes
      [AdaGFX] Missed a conditional compile option
      [TouchHandler] Add support for sliders and swiping, many other improvements
      [P123] Implement Slider/Gauge support, other (size) improvements
      [AdaGFX] Improved drawing of Slider/Gauge control (also reverted)
      [TouchHandler] Enable use of reverted sliders/gauges, and improved handling of ranges that don't have 0 included
      [P123] Minor code improvements
      [TouchHandler] Add optional touchscreen disabling, code fixes and improvements
      [P123] Implement disabled-touchscreen feature
      [TouchHandler] Fix typo and conditional compilation issue
      [UI] Improvements for `multi2row` style
      [TouchHandler] Settings page layout adjusted, and some minor improvements
      [TouchHandler] Logging check improvements
      [P123] Logging check improvements
      [TouchHandler] Remove unneeded enum MAX values
      [AdaGFX] Remove unneeded enum MAX values, fix BMP conditional compilation issue
      [AdaGFX] Fix compilation error after merge from mega
      [TouchHandler] Fix compilation error after merge from mega, table improvements
      [P116] Add GetConfig feature, code improvements
      [I2C scanner] Enable plugin-scan for ESP32, updated sensors
      [TouchHandler] Fix touch-disabled option, code improvements
      [P123] Code improvements
      [TouchHandler] Conditional compilation fix
      [TouchHandler] Conditional compilation fix
      [Boards] Add BOARD_HAS_PSRAM flag for 16M8M config (avoids crashing when saving P123 settings)
      [TouchHandler] Logging and code optimizations
      [P123] Bugfixes and logging improvements
      [P123] Fix for disabled touchpanel setting
      [Lib FT6206] Add support for FT6336 touch panel (as used in M5Stack Core2)
      [P123] Correct merge error
      [P123] De-initialize on error during PLUGIN_INIT fixed
      [Core] Add extra storage space for Custom TaskSettings
      [Plugins] Adjust check for max. CustomTaskSettings
      [TouchHandler][P123] Implement Extended CustomTaskSettings feature
      [P104] Improve storing settings (speed and size)
      [TAR] Add support for downloading and uploading files via .tar archive
      [Core] ExtendedCustomTaskSettings code improvements based on feedback
      [Code] Add `NR_ELEMENTS` macro for getting the number of elements in an array
      [TAR] Code improvements from feedback, code de-duplication
      [Download] Only add `exrcfgNN.dat` files with feature enabled
      [TAR] Don't allow subdirectory files, check file before trying to delete
      [TAR] Add setting to disable download configuration as a .tar file
      [TAR] Add documentation
      [TAR] Minimal logging during file-download
      [TAR] Minimal logging during file-upload, code improvements
      [Core] Re-enable Flash-formatting for LittleFS
      [P123][TouchHandler] Fix merge issues, adjust log strings
      [TouchHandler] Fix typo
      [P123][TouchHandler] Fix valuecount issue, implement missing `GET_I2C_ADDRESS` function
      [TouchHandler] Remove unused variable assignment
      [P104] Disable new settings-version V3 for now
      [P104] Code improvements, re-enable new settings-version V3
      [AdaGFX_helper] Reduce build-size
      [AdaGFX_helper] Simplify font handling, add some better 7/14 segment fonts, enable 18pt fonts for ESP32
      Merge branch 'mega' of https://github.com/letscontrolit/ESPEasy into feature/TAR-archive-upload-and-download + fixes
      [AdaGFX_helper] Update Fonts documentation
      [TAR] Scrape off a few bytes to make the build fit
      [TouchHandler] Fix compilation errors since Core code changes
      [TouchHandler] Fix compilation errors since Core code changes
      [TouchHandler] Code optimization reducing .bin size
      [P123] Minor code optimiziations
      [Build] Reduce code size to make Collection F fit again
      [Build] Reduce code size to make Collection F fit again (Collection plugins)
      [TAR] Exclude feature from normal_IRext_no_rx build for size overflow
      [TAR] Exclude feature from normal_IRext_no_rx build for size overflow (commit correct file)
      [Build] Reduce code size to make Collection F fit again (Collection plugins)
      [Build] Reduce code size (Stable plugins)
      [P045] Don't use UserVar.setInt32() for Collection builds
      [Build] Reduce code size (Stable plugins)
      [Build] Reduce code size (Stable plugins)
      [Build] Reduce code size (Stable plugins)
      [Build] Reduce code size (Collection A plugins)
      [Build] Reduce code size (Collection B plugins)
      [Build] Reduce code size (Collection C plugins)
      [Build] Reduce code size (Collection D plugins)
      [TAR] Correctly handle a 0-byte file on download
      [TAR] Improve Tools/Save description, add Reboot button on Tools/Load, update documentation
      [Build] Reduce code size (Collection E plugins)
      [Core] String optimizations
      [Core] String optimizations
      [Core] String optimizations
      [Core] String optimizations
      [Lib] LD2410 Optimize code to reduce bin size
      [Build] Reduce code size (Collection G plugins)
      [Build] Reduce code size (Energy plugins)
      [Build] Reduce code size (Display plugins)
      [Build] Reduce code size (Controller helper)
      [AdaGFX_helper] Code improvements Partly based on this commit: https://github.com/letscontrolit/ESPEasy/pull/4932/commits/a95ad3bda183f0ecf4e41efff3e9cbe4fb3a2e16
      [Build] Reduce code size (avoid String(F("...")) conversions and concatenations)
      [Build] Revert modifications for Eth- and WiFi- event handlers (too timing critical)
      [TouchHandler] Also reverse the Left/Right navigation when Up/Down navigation is reversed
      [TouchHandler] Rename inc/dec subcommands to next/prev
      [P123] Refactor increment/decrement functions to next/prev in line with TouchHandler
      [P123][TouchHandler] Add documentation
      [Build] Code reductions to make Collection F build fit in .bin size again
      [P145] Revert moved include
      [P123] Docs minor corrections
      [P011] Add Input (switch) option, code improvements
      [P011] Add documentation
      [P064] Add Separate Gesture events option
      [P064] Updated documentation
      [TAR] Re-enable TAR support in ESP8266 Display build
      [Docs] Improvements and missing features
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [Storage] Use correct parameter-type for strformat()
      [P047] Add support for Adafruit I2C Capacitive Moisture sensor
      [P047] Update documentation for added sensor model
      [N001] Add support for optional Subject to notify command
      [P162] Add plugin for Digipot MCP42xxx/MCP41xxx
      [P162] Add required include
      [P011] Update documentation
      [P011] Add support for Get Config Values and update documentation
      [P011] Add plugin commands to EasyColorCode
      [P162] Fix some testfindings, add logging
      [P162] Add `Send data on change` option
      [P162] Add documentation
      [P162] Add EasyColorCode configuration
      [AdaGFX Helper] Add TomThumb 3x5 font
      [Build] Add ESP32-S3 4MB NeoPixel LittleFS build, including AHT2x (P105) for TinyTronics Smart Home display unit
      [Build] ESP32-S3 4MB NeoPixel LittleFS build, remove typo, no longer needed here
      [AdaGFX] Add Default font option and support functions
      [P131] Add default font selector
      [P131] Update documentation
      [Docs] Hide default enabled sidebar menu
      [P167] Enable use of SEN5x sensor, other improvements
      [SysVars] Add conversions to get remote-unit info
      [SysVars] Add more conversions to get remote-unit info
      [Build] Remove P039 from `normal_IR_no_rx_ESP8266` build to make it fit again
      [P167] Minor corrections and some cleanup
      [SysVars] Update EasyColorCode with new variables and some fixes
      [P167] Add to I2C Scanner
      [P167] Update EasyColorCode docs
      [P110] VL53L0x: Add Direction value, trigger only when changed, trigger delta
      [P113] VL53L1x: Add Direction value, code optimizations
      [P110] Update documentation
      [P113] Update documentation
      [Bugfix][P135] SCD4x fix reading sensor settings
      [P135] Only set sensor parameters if needed
      [P135] Only set sensor parameters if needed
      [P105] Update plugin name and documentation
      [Commands] Correctly handle `on`/`true`/`off`/`false` as enable/disable values for commands
      [P105] Update documentation
      [P034] Add documentation, remove unreachable documentation file
      [P012] Clear splash after 5 seconds if not yet overwritten (man. picked from #4884)
      [C018] Re-enable LoRa TTN controller for ESP32 Collection builds
      [P105] Add extra devices to I2C scanner
      [P167] Fix storing setting to enable tech. logging
      [Build] Update espeasy.min.js for multiple merged PRs
      [P167] Use fixed label for model and tech. logging
      [AdaGFX_Helper] Fix typo in `default` font definition
      [P116] Add Default font selection if AdafruitGFX_Helper fonts are included in build
      [Docs] Add plugin overview per build set (generated)
      [P167] Add command `sen5x,techlog,<0|1>`
      [P167] Add command `sen5x,techlog,<0|1>`
      [P167] Add documentation
      [C011] Documentation correction
      [AdaGFX_Helper] Fix typo in `default` font definition
      [AdaGFX_Helper] Fix merge conflict
      [AdaGFX_Helper] Fix font offset issues
      [P047] Add support for BeFlE v3.x moisture sensor
      [P080] Add Event with iButton address
      [DallasHelper] Reduce logging for Dallas_readiButton to on-change only
      [P080] Remove unneeded Dallas_startConversion calls, reduce logging for Dallas_readiButton call
      [P080] Improved documentation
      [P004] Add support for Get Config Value to retrieve sensor statistics
      [Commands] Add OWScan command to scan for 1-wire devices
      [P004] Correct typo
      [P004] Change argument separator to dot for Get Config Value
      [1WireHelper] Return Unknown for unrecognized devices
      [P168] Add VEML6030/VEML7700 Light/Lux sensor
      [AdaGFX Helper] Parse Get Config Values with period instead of comma, with fall-back
      [AdaGFX Helper] Update documentation
      [P011] Parse Get Config Values with period instead of comma, with fall-back
      [P087] Parse Get Config Values with period instead of comma, with fall-back
      [Build] Fix build error because of removed python package since 3.12
      [Build] Fix build error because of removed python package since 3.12
      [P168] Add documentation
      [P170] Add Seeed studio I2C Liquid Level sensor
      [Build] Set ETH enabled for all IDF 5.1 builds
      [P167] Correct interrupt function definitions
      [P170] Add documentation
      [P170] Add optional logging of received data
      [P123] Add support for GT911, CST820, CST226 and AXS15231 touch screens
      [P123] Update documentation
      [P123] Fix support for CST226 to return 0 when not touched
      [P123] Update documentation
      [P123] Add support for CHSC5816 and update documentation
      [Commands] i2cscanner: add debug and multiplexer support
      [P123] Save current device I2C address
      [P123] Docs: add warning about CST816 can't be found by I2C scan
      [P142] Add AS5600 Magnetic angle sensor
      [P168] Fix VEML6030 support
      [Build] Add P095 to Collection builds (ESP32 only) as documented
      [P047] Fix compiler warning
      [P095] Add support for ILI9488 Displays
      [StringConverter] Fix `parseHexTextData` unwanted increment during parsing
      [P123] Docs: add remark for untested touchscreen controllers
      [P172] Add BMP3xx using SPI interface
      [P142] Add documentation
      [P095] Combine support for ILI9486 Displays with ILI9488
      [P095] Combine support for ILI9486 Displays with ILI9488
      [P095] Update documentation
      [P095] Documentation note for ILI9486 added
      [Docs] Documentation updates, README.md updates
      [P172] Show ChipID when plugin is enabled
      [P172] Add/update documentation
      [P036] Add Header Time format options
      [P087] Add example to plugin documentation
      [P027] Add optional Powerdown mode
      [P027] Fix sending single values via Controller
      [P003] Countertype to determine the number of values
      [P003] Update documentation, apply some corrections
      [P003] Add extra Counter Type options (for selected builds)
      [P003] Add extra setting for Ignore Delta = 0
      [P003] Fix typo
      [Build] Remove P094 from ESP8266 Collection D for size reasons
      [Build] Remove P094 also from ESP32 Collection D builds
      [P003] Allow Interval = 0 and send first read 0 Count value
      [Commands] Rename `Reset` to `FactoryReset`
      [Console] Exclude Serial Console fall-back GPIOs only when fall-back enabled
      [P003] Improve handling and checking for new pulses when Interval = 0
      [P141] Add default font selection setting
      [P011] Exclude plugin from 1M builds
      [P036] Exclude preview from web-UI for 1M builds
      [P123] Missing parenthesis in macro
      [P164] Missing parenthesis in macros
      [TarStream] Add missing fall-through comment in switch
      [P038] Reduce build size
      [P135] Exclude factoryreset command by default
      [P008] Small code optimizations
      [P013] Log-string optimizations
      [P023] Disable Content-display in web-UI for limited builds (code size reductions)
      [P024] Fix issue with reporting/displaying the configured I2C address (offset via Port)
      [P104] Fix unused variable warnings
      [Docs] Corrections for P009 and P019 pin range commands
      [P038] Add commands neopixelfor and neopixelforhsv
      [P038] Add optional `<clear>` argument to neopixelfor commands
      [P038] Fix optional `<clear>` argument for neopixelforhsv command

andibaciu (2):
      Plugin P167 IKEA Vindstyrka
      Fix some bugs and add suport (only read parameters) for standalone sensirion sen54 and sen55

thomastech (10):
      Preliminary Notify Plugin Changes to restore operation after ISP email server upgrade
      Added more comments to file. No code change.
      Changed Notify SMTP email timeout values to mS (were secs), per TD-er's request.
      Cleanup Notify log text messages.
      (1) Reduced Notify Timeout Limit to 12000mS. (2) Fixed "Reply to" address when provided by Notify Command (via rules).
      Reverted Notify Max Timeout to 20000mS (was 12000). Notify Log msgs now employ loglevelActiveFor() wrapper.
      Created Docs (RTD) for updated Notifications Email plugin.
      Corrected Changelog dates in NotificationPage.cpp.
      (1) RTD text corrections, per discussions. (2) Updated RTD link, now use addRTDHelpButton() function.
      Minor edits to Notification Docs, per Github comments


-------------------------------------------------
Changes in release mega-20240414 (since mega-20240401)
-------------------------------------------------

Release date: Sun Apr 14 03:08:46 PM CEST 2024

TD-er (16):
      [HWCDC] Revert to older ESP-IDF/Arduino build
      [Time] Fix updating %sunrise% and %sunset% when no NTP available
      [HWCDC] Fix bootloop on ESP32-C3/C6
      [HWCDC] Cleanup unused test code
      [ESP-IDF5.1] Move to newly network refactored code
      [ESP-IDF5.x] Fix build issue
      [ESP-IDF5.x] Fix building ESP32-solo1 builds
      [Ethernet[ Fix crashes when using Ethernet + IPv6 on LittleFS builds
      [Ethernet] Fix getting DNS from DHCP switch from WiFi to Ethernet
      [ESP-IDF5.x] Fix LittleFS builds without Ethernet
      [IMPROV] Fix provisioning WiFi via web flasher
      [ESP-IDF5.1] Update to latest 2024.04.11 platform build
      [SPI ETH] Fix SPI selection to actual SPI bus for Ethernet
      [SPI Eth] Fix build on ESP32-C3
      [HWCDC] Tweak HWCDC to be more stable
      [Build] Revert unintended change of default PIO env.

Ton Huisman (2):
      [Dist] Update Espressif Flash Download tool 3.9.6
      [JSON] Add extra data in `/json` output


-------------------------------------------------
Changes in release mega-20240401 (since mega-20240331)
-------------------------------------------------

Release date: Mon Apr  1 12:13:54 AM CEST 2024

Ton Huisman (1):
      [Bugfix] Release script fixes and simplifications


-------------------------------------------------
Changes in release mega-20240331 (since mega-20240229)
-------------------------------------------------

Release date: Sun Mar 31 03:40:08 PM CEST 2024

Ernest (ErNis) (1):
      INA219 26V 8A range added

Jason2866 (1):
      small refactor

TD-er (13):
      [JL1101] Fix JL1101 Ethernet + update to latest ESP-IDF5.1 code
      [PlatformIO] Fix installing pygit2
      [ESP8266 WiFi] Initialize flags for AP capabilities
      [ESP8266] Get rid of several union structs which may cause weird issues
      [ESP8266] Remove use of union due to issues on ESP8266
      [ESP-IDF5.1] Revert to older SDK code due to issues with HWCDC
      [Build] Reduce build size regarding WiFi AP Candidate duplicate code
      [HWCDC] Test for ESP32-C3/C6/S3 HWCDC issues
      [CUL Reader] Cherry pick code from ESPEasy_NOW pull request
      [CUL Reader] Fix not being able to set flags
      [Save Settings] Fix issue where data may get corrupted saving task
      [Display] Reduce ESP8266 'display' build size
      [MQTT] Fix crash and disconnect sending to MQTT using formula

Ton Huisman (22):
      [P087] Add serialproxy_test command and Get the parsed data
      [P087] Fix typo
      [P087] Documentation clarification
      [P087] Apply log-string and code optimizations
      [P087] Always process Global Match so values can be retrieved
      [Bugfix] Release.yml shouldn't try to move a non-existing file
      [Build] Add ESP32-C6 MAX builds (preliminary)
      [Docs] Update ESP chip info
      [Docs] Update ESP chip info
      [P116] Add alternative model selections for ST7789
      [Bugfix] Remove duplicate define in Custom-sample.h
      [Build] Custom IR ESP32 configurations not using the pre_custom_esp32_IR.py Python script
      [P116] Add alternative model selection for ST7735
      [P029][C002] Add option Invert On/Off value
      [Docs] Update P029 documentation with new option
      [C002] Reduce .bin size (slightly)
      [P116] Fine-tuning the rotation column-offset for ST7735 135x240 display
      [P116] Documentation improvement.
      [P095] Documentation improvement.
      [P116] Update documentation for supported displays
      [Build] Disable Notifiers in full binaries
      [Build] Fix typo


-------------------------------------------------
Changes in release mega-20240229 (since mega-20231225)
-------------------------------------------------

Release date: Thu Feb 29 03:10:58 PM CET 2024

Fabio Ancona (1):
      Added missing P166

TD-er (104):
      [IPv6] Fix node with IPv6 not seen by other p2p nodes with only IPv4
      [PVS Studio] Fix "dangerous expression" macros.
      [PVS Studio] Fix missing 'break;' in switch statement
      [PVS Studio] Fix Not all members of a class are initialized inside the constructor
      [PluginStats] Add PluginStats chart data to /json
      [PluginStats] Fix pluginstats via JSON & improve speed
      [ESPEasy p2p] Fix Ethernet connected nodes not listed on other nodes
      [Build] Make ESP8266 Energy build fit again
      [Build] Fix duplicate extra_scripts declaration in some ESP8266 builds
      [HW CDC] Fix delay when no client connected to read serial logs
      [UDP] Only process UDP packets while connected
      [Factory Reset] Fix applying NVS stored settings only when these exist
      [ESP-IDF5.1] Add custom_ESP32s2_4M316k_LittleFS_CDC
      [Factory Reset] Add default flags for factory reset
      [ESP-IDF5.1] Fix starting DHCP on ESP AP during setup
      [Cleanup] Reduce bin size (NVS storage & P128 NeoPixelBus)
      [Cleanup] Reduce build size (P128 NeoPixelBus)
      [Cleanup] Reduce build size (P104/P128)
      [Cleanup] Reduce build size (P104 load/save functions)
      [Cleanup] Reduce build size
      [Cleanup] Reduce build size (AdaFruitGFX_Helper fonts)
      [ESP32] Disable PSRAM for ESP32 4M builds (WT32-ETH01 issues)
      [Docs] Add credits to origin of ESP32-S3 flash/PSRAM options
      [ESP-IDF5.1] Improve IPv6 for ESP32-xx
      [ESP-IDF5.1] Fix IPv6 for ESP32-S3
      [Build] Fix build due to typo in source code
      Fix "Enable SDK WiFi Auto Reconnect" state on sysinfo page (#4935)
      [build] Fix another build issue due to includes
      Revert "[Cleanup] Reduce build size (AdaFruitGFX_Helper fonts)"
      [Factory reset] Fix using factory reset defaults on new devices
      [ESP-IDF5.1] Update to latest ESP-IDF & Arduino fixes
      Fix crash in command arg parsing with nullptr string
      [IPv6] Allow `ip6` command from all command sources
      [P077] Add `cseclearpulses` command to reset CF pulses counter
      [Cleanup] Reduce build size by simplifying logs
      [Provisioning] Show error and event on failed firmware update (#4941)
      [Build] Fix build error on ESP8266
      [P077_CSE] Fix cseclearpulses command
      [P077 CSE7766]  Call PLUGIN_READ right after `cseclearpulses`
      [P016 IR] Reduce stack usage executing commands
      [P016 IR] Fix some build mistakes reducing stack usage
      [P016 IR] Reduce stack usage execute command
      [P016 IR] Add debug code to reproduce crashes Uwe
      [Cleanup] Reduce stack usage P036 OLED Framed
      [P036 Framed OLED] Apply cleanup from Ton's TAR pull request
      [P036 OLED Framed] Add bound checks when drawing fonts
      [Commands] Allow commands from external source to be queued (stack)
      [Cleanup] Reduce stack usage P036 OLED Framed
      [P036 Framed OLED] Apply cleanup from Ton's TAR pull request
      [P036 OLED Framed] Add bound checks when drawing fonts
      [ESP32 IPv6] Fix getting IPv6 address on ESP32 classic
      [Build] Add ESP8266 custom IR 1M build + IPv6 to custom ESP32 IR build
      [IPv6] Move log to more logical place
      [SPI Ethernet] Add support for SPI Ethernet modules
      [SPI Ethernet] Fix build for pre ESP-IDF5.1
      [SPI Ethernet] Fix build
      [SPI Ethernet] Use user configurable SPI bus for SPI Ethernet
      [SPI Ethernet] Fix build pre-ESP-IDF5.1
      [SPI Ethernet] Fix detect Link Up/Down + cleanup code
      [SPI Ethernet] Fix build on ESP-IDF < 5.x
      [Build] Fix building on ESP8266
      [SPI Ethernet] Document SPI Ethernet + Eth config for available boards
      [SPI Ethernet] Fix typo in docs
      [Cleanup] Fix crashes on ESP32 sending log from ISR callback functions
      [SPI Ethernet] Add "- None -" Ethernet type option on Hardware Page
      [ESP-IDF5.1] Update to latest SDK/Arduino commits
      [IPv6] Fix IPv6 on ESP32-S3
      [Build] Fix missing #endif
      [SPI Ethernet] Allow selecting RMII pins for SPI Ethernet
      [SPI Ethernet] Fix concurrency issue with shared SPI bus for ETH/display
      [Build] Fix build on ESP32-C3
      [PWM] Fix ESP32 LittleFS build PWM GPIO : port#2 is out of range (#4962)
      [SPI Ethernet] Make default Ethernet parameters more neutral
      [PWM] Fix deadlock on ESP32-classic with PWM fade
      [ESP32 PWM] Fix calling ledcAttach for Servo and PWM on ESP32 IDF5.1
      [ESP-IDF5.1] Update to latest Arduino and ESP-IDF commits
      [Email] Fix sending multiple lines in body (#4967)
      [ESP-IDF5.1] Fix build ESP32-C2
      [Build] Test ESP32-solo1 build on CI
      [ESP-IDF5.1] Update to latest platform build
      [SPI Eth] Add ESP32-S3 ETH builds
      [ESP32 WiFi] Fix slow connect after WiFi scan
      [SPI Eth] Allow SPI Ethernet W5500 to have not connected INT pin
      [Build] Fix missing include
      [ESP-IDF5.1] Update to latest IDF and Arduino commits
      [ESP-IDF5.1] Update platform package for ESP32-solo1
      [ESP-IDF5.1] Fix renamed platform zip file
      [ESP32 WiFi] Fix crashing on wifi disconnect
      [WiFi] Fix crash when calling disconnect or wifimode,off from remote src
      [WiFi] Fix crash when WiFi was turned off while data is sent
      [Docs] Add warning changing ECO mode when using SPI Ethernet
      [GPIO] Add form note setting pull-up on Hardware tab (#4800)
      [Rules] Remove warning for max size on Rules edit page
      [Eth] Show Ethernet adapter used in JSON/Sysinfo
      [ESP-IDF5.x] Add fix to ESP-IDF/Arduino for W5500 without RST (AtomPoE)
      [HW info] Add checks for properly identify embedded flash/PSRAM
      [ESP8266] Reduce memory usage by actively flushing webpage buffers
      [IPv6] Fix slowdown restarting services on receiving IPv6 address
      [ESP32-C3/C6] Fix web slowdown by reverting Arduino/IDF code
      [Build] Fix build issue on ESP-IDF4.4
      [Build] Fix build on non-ESP32-S3
      [Build] Fix typo in ESP32-S2 code
      [ESP32-C3/C6] Fix stalling on concurrent connections
      [Build] Add flag to help not compile/download unused libs

Ton Huisman (116):
      [P044] Uncrustify format source
      [P044] Make Led pin configurable
      [P044] Correct auto-complete typo
      [Plugins] Call PLUGIN_WEBFORM_PRE_SERIAL_PARAMS before serial settings are displayed to allow settings conversion
      [Plugins] Call PLUGIN_WEBFORM_PRE_SERIAL_PARAMS before serial settings are displayed to allow settings conversion
      [P020] Merge [P044] code into [P020], so P020 van emulate P044
      [P020/P044] Migrate settings also on plugin start without prior save from UI
      [P020] Code improvement
      [P020/P044] Add option for including P1 data in #data event
      [UI] Add Separator character input selector
      [P020/P044] Add feature to replace spaces and newlines in received data
      [P020] Add plugin documentation
      [P037] Implement replacement character input selector, update documentation
      [UI] Fix unsupported feature compilation error, fix signed/unsigned warning
      [P044] Only show usable settings
      [P044] Update plugin documentation (based on P020)
      [Build] Adjust Custom ESP8266 as already planned to fix build failure
      [P020/P044] Adjustments to complete the merge
      [P020] Add extra check before sending P1 data
      [P020] Revert extra check before sending P1 data, minor improvements
      [StringConverter] Add parseHexTextString()
      [P020] Add command `serialsendmix`
      [StringConverter] Improvements to parseHexTextString()
      [P020] Add command documentation
      [P020] Correct some typos in documentation
      [StringConverter] Add parseHexTextData() to handle 0x00
      [P020] Use parseHextTextData() to handle 0x00 in data
      [P020] Update documentation for 0x00..0xFF hex data support in serialsendmix
      [P020] Update changelog
      [P020] Unification of Ser2Net log messages
      [Build] Manually apply WiFi build fixes (missing includes)
      [ESPEasySerial] Add shortName option to be used as eventname
      [Helpers] Implement ESPEasySerial shortName option to be used as eventname
      [P020] Increase max. buffer size [P020] Add options for using Serial Port name as event and/or append the task number [P020/P044] Fix plugin initialization when USB (HW)CDC or I2C Serial is selected
      [P020] Update documentation for new options
      [P020] Fix receiving P1 data
      [P020] Fix merge conflict
      [P020] Allow some extra time-out while receiving P1 data, add missing CR/LF
      [P044/P020] Improved defaults for P1 WiFigateway
      [P020][P044] Minor improvements, update with latest mega changes
      [Docs] Hardware page: Add missing documentation for new I2C Slow default
      [P043] Add support for %sunrise% and %sunset% based time-values
      [Docs] Add missing %syssec_d% variable
      [P151] Add missing PLUGIN_I2C_GET_ADDRESS function
      [Docs] Update in Plugin-template embedded documentation
      [Docs] Add Rules example for registering daily working time
      [TimeCalc] Fix parse errors
      [Text input] Add `datalist` support, manually cherry picked from P123 PR
      [Text input] Implement `datalist` support
      [P043] Add selection list (datalist) support for input time string
      [P043] Rework Day,Time inputs, add configurable Day,Time count
      [P043] Change Value input layout to be on same line as the Day,Time input, code optimization
      [Docs] Update Commands and Events references
      [P043] Add option for On/Off value input
      [P043] Add 'config' command support and get config value support
      [P043] Add documentation
      [Build] Disable some failing build envs
      [Docs] Add P043 to commands and events reference pages
      [P043] Fix simple Yes/No behavior like GPIO mode
      [P043] Update documentation
      [Build] Fix buildscripts for v4 Actions `upload-artifact`, `download-artifact` and `delete-artifact`
      [Build] GH Actions v4 use unique upload-id
      [Build] GH Actions use setup-python v5, improved glob for delete-artifact
      [Build] GH Actions v4 try fix artifact download permissions issue
      [Docs] Update `README.md` with new builds/ESPs/options
      [Build] GH Actions v4 Sort builds by ESP, remove repackage step
      [Build] GH Actions v4 Fix build names vs dependencies, add all-binaries artifact
      [Build] GH Actions v4 Rename `repackage` job to `combine_package`
      [Build] GH Actions v4 Apply also to `release.yml`, add ESP32-C2 and ESP32-C6 artifact uploads
      [Lib] NeoPixelBus_Wrapper: Allow fall-back to Adafruit_NeoPixel lib for ESP8266
      [Lib] NeoPixelBus_Wrapper: Fix compilation for IR builds
      [Lib] NeoPixelBus_Wrapper: Correct includes attribute
      [Docs] Add Rules example for measuring daily used power/energy
      [Adafruit_NeoPixel] Fix compiler warning
      [NeoPixelBus_wrapper] Update README.md
      [NeoPixelBus_wrapper] Correct class inheritance error
      [Adafruit_NeoPixel] Exclude from ESP32 builds (unused)
      [Adafruit_NeoPixel] Correct function signature issues causing compiler warnings
      [P131] Fix compiler warning -Wreorder
      [SuperTinyCron] Remove unused commandline tool
      [P020] Replace WiFiServer->available() by accept() (for IDF >= 5)
      [Build] Combine_package use separate downloads to reduce chance of failure
      [Build] Combine_package use wretry.action to try and succeed the downloads
      [Build] Remove RTTTL from `normal_IRext_no_rx` build for size, add some libs to lib_ignore for `custom_IR` builds
      [P043] Exclude some code that won't work for PLUGIN_BUILD_MINIMAL_OTA builds
      [Release] Add ESP32-C2 and ESP32-C6 downloads
      [Build/Release] Fix some issues, apply workarounds where needed
      [Docs] Update copyright year to 2024
      [Docs] Update copyright year to 2024
      [Docs] Update copyright year to 2024
      [Docs] Update Sphinx tools and configuration
      [IR] Enable all protocols for ESP32 IR builds
      [Bugfix] Update bootstrap version for Sphinx to fix documentation menus
      [P166] Add plugin GP8403 DAC Dual channel 0-10V
      [P166] Add isI2CEnabled check on PLUGIN_INIT
      [Build/Release] Update actions/cache to v4
      [P166] Send out datat for events/controllers when changing output values
      [Build/Release] Remove Wdalen/retry.action plugin for Node 20 compatibility
      [P166] Send out data by scheduling a timer
      [P166] Update changelog
      [P166] Set default I2C address to 0x5F, as that's how is delivered
      [UI] Add alternative 'default' selection to `addFormSelectorI2C()`
      [P166] Restore I2C address selector order, fix compiler warning 're-order'
      [UI] Add alternative 'default' selection to `addFormSelectorI2C()`, select by address
      [P166] Adjust I2C address selector default
      [UI] Update plugin I2C address selectors to normal order, with matching default
      [P166] Optionally restore last output value on warm boot (setting, default enabled)
      [P166] Fix bug that Initial values where not applied after settings save
      [P166] Add documentation
      [P166] Documentation improvements
      [Build] Allow FEATURE_SERVO for Custom builds with LIMIT_BUILD_SIZE set
      [Bugfix] `%vcc%` variable isn't recognized
      [MQTT] Add PublishR command: publish with will-retain
      [Docs] Documentation and EasyColorCode updates and fixes, Feb 2024
      [MQTT] Fix debug strformat message
      [EasyColorCode] Correction and var rename commonEvents

chromoxdor (30):
      Update Networking.cpp
      Update Networking.cpp
      Update Networking.cpp
      make thinkspeak event optional
      compare also the last part of the uri to generate an event
      add check if we got an answer otherwise we get -1 as a value
      Update Networking.cpp
      Update Networking.cpp
      Update define_plugin_sets.h
      Update define_plugin_sets.h
      Update Networking.cpp
      Add ThingspeakReply to wordlist
      Update Networking.cpp
      Update Networking.cpp
      added documentation
      Update Rules.rst
      single + multifield reply combined
      Update Rules.rst
      Update Rules.rst
      a little formatting
      Update espeasy.min.js
      Update Rules.rst
      add %sysec_d% and fix typo
      remove change since ton already did it :)
      Update StringGenerator_System.cpp
      initial changes
      Update _P102_PZEM004Tv3.ino
      Update _P102_PZEM004Tv3.ino
      Update Rules.rst
      Update codemirror to 5.65.16

flashmark (9):
      Initial plugin structure
      Rough, working version
      Added recovery from communication failures
      Rework after review, added documentation
      Fixed compiler issue after rebase
      Minor cleanup
      Some fixes after review
      Added to CLimate and Collection G plugin sets. Removed some leftovers.
      Merge

uwekaditz (11):
      [P016] Add protocol RAW to UI if 'Accept DecodeType UNKNOWN' is set
      uint64ToString() changed to ll2String()
      Check the vector size when checking for commands, and check that the command is really not empty
      Reduce code for debug message
      Revert "Merge branch 'P016]-PullRequest' of https://github.com/uwekaditz/ESPEasy into P016]-PullRequest"
      Revert "Reduce code for debug message"
      Reduce code for debug message
      Use the new property addToQueue in ExecuteCommand_all()
      Uncrustify
      Uncrustify #ifdef's
      [P016] BUG: Decode type UNKNOWN was not added to the web settings


-------------------------------------------------
Changes in release mega-20231225 (since mega-20231130)
-------------------------------------------------

Release date: Mon Dec 25 10:28:22 PM CET 2023

TD-er (205):
      [Cron lib] Update code to latest version
      [Cron] Fix unintended month rollovers, ported from staticlibs#35
      [Cron] Prevent warnings in ccronexpr_test.c
      [Cron] Fix build error (define CRON_INVALID_INSTANT in header)
      Revert "[Cron lib] Update code to latest version"
      [ESP_IDF 5.1] Add support for ESP_IDF 5.1 (SP32 Arduino SDK 3.x)
      [ESP_IDF 5.x] Disable ADC calibration for now
      [ESP_IDF 5.1] Fix build on ESP32 ETH builds
      [ESP-IDF 5.1] Fix building ESP32-S3
      [ESP-IDF 5.1] Split ESP32 variant builds with LittleFS to use ESP-IDF5.1
      [ESP-IDF 5.1] Fix building ESP32-Solo & ESP32-C3
      [ESP-IDF 5.1] Fix ESP32-S3 LittleFS build
      [ESP-IDF 5.1] Fix building custom_IR_ESP32_16M8M_LittleFS_ETH
      [ESP-IDF 5.1] Fix builds on Custom IR ESP32 LittleFS ETH & MAX ESP32
      [ESP-IDF 5.1] fix lib_ignore for ESP8266 / ESP32-S3
      [ESP-IDF 5.1] Fix building ESP8266 3.0.2 builds
      [ESP-IDF 5.1] Fix ESP8266 builds demanding EspSoftwareSerial SDK3.x
      [ESP-IDF 5.1] Fix check for IDF major version >= 5
      [ESP-IDF 5.1] Fix some ESP8266 beta builds
      [ESP-IDF v5.1] Fix building ESP8266 minimal IRext
      [ESP32] Update to ESP32 platform 2.0.14 (with SPIFFS)
      [ESP-IDF 5.1] Fix some warnings on compiling with IDF 5.1
      [ESP 2.0.14] Fix ESP32-Solo1 build for ESP32 SDK 2.0.14 (SPIFFS)
      [ESP-IDF 5.1] Fix not always loading correct platform files
      [ESP-IDF 5.1] Implement ADC support for IDF 5.1
      [ESP-IDF 5.1] Fix build with ADC on IDF < 5
      [ESP-IDF 5.1] Remove Hall Effect sensor from ADC selector
      [ESP-IDF 5.1] Fix ADC calibration & crashes on ESP32-C3
      [EDP-IDF 5.1] Fix ADC build on ESP8266
      [ESP-IDF 5.1] Fix crashes on ESP32-S3 & ESP32-S2
      [ADC] Cleanup code
      [Controller Settings] Fix inverted Send LWT and Will Retain
      [Charts] Cleanup code & add option for multiple Y-axis
      [PluginStats] Add option to hide taskvars in chart
      [PluginStats] Add option to select chart axis per taskvalue
      [PluginStats] Cleanup code
      [Cleanup] Reduce build size
      [Access Control] Prevent "IP blocked: 0.0.0.0"
      [Access Controll] Fix using the same WiFiClient
      [ChartJS] Add scatter plot for GPS longitude/latitude
      [WiFi] Add proper erase WiFi calib data on ESP32 cmd 'erasesdkwifi'
      [WiFi] Add more WiFi info for ESP32 + limit bandwidth to HT20
      [HW detection] Update getChipModel() with new chip IDs
      [ESP-IDF 5.1] Fix build issues ESP8266 and ESP-IDF4.x
      [Hardware] Fix build on ESP32-S3 on hardware detection
      [ESP-IDF5.1] Add internal temperature sensor for all ESP32 variants
      [ESP-IDF5.1] Add auto range to internal temperature sensor (ESP32-S*/C*)
      [ESP-IDF5.1] Disable IP subnet check access control (remoteIP() bug)
      [ESP-IDF5.1] Update to IDF5.1 of 2023-10-10
      [ESP-IDF5.1] Add normal_ESP32_4M316k_LittleFS_ETH
      [ESP-IDF5] Add link to Setup page on tools tab (IDF5 remoteIP() issue)
      [Sysinfo] Only show TSF time on sysinfo page when connected to AP
      [ESP-IDF5.1] Fix PWM and Servo
      [Lib Update] Update Adafruit Motor Shield V2 library to v1.1.1
      [ESP-IDF5.1] Fix PWM using fade & 'tone' upto 20 MHz
      [ESP-IDF5.1] Move PWM code to separate Hardware_PWM.h/.cpp
      [ESP-IDF5.1] Move GPIO related code to Hardware_GPIO.h/.cpp
      [ESP-IDF5.1] Split Hardware device info into Hardware_device_info.h/.cpp
      [ESP-IDF5.1] Disable option "Try clear I2C bus when stuck" for IDF5.x
      [ESP-IDF5.1] Move Hardware I2C functions to Hardware_I2C.h/.cpp
      [Cleanup] Remove unneeded includes to "../Helpers/Hardware.h"
      [Neopixel] Update Adafruit NeoPixel library to 1.11.0
      [ESP-IDF5.1] Update NeoPixelBus with Tasmota's patches for ESP-IDF5.1
      [ESP-IDF5.1] Update P128 to use updated NeoPixelBus library
      [ESP-IDF5.1] Fix build issue on older IDF based builds
      [ESP-IDF5.1] Move to latest platform package build 2023-10-24
      [Cleanup] Reduce build size by compacting logs
      [Cleanup] Simplify StringConverter::parseHexTextData function
      [SysInfo] Add PSRAM to P026_sysinfo and cleanup code
      [Cleanup] Simplify function names for P026_SysInfo
      [Build] Add missing include for ESP8266 reading ADC
      [WiFi] Fix force B/G mode on ESP8266
      [WiFi] Fix ESP32 taking very long time to get (re)connected
      [ESP-IDF5.1] Fix issues in IPAddress (SDK platform build)
      [ESP8266] Fix compiler warning in order of member initialization
      [ESP8266] Extend ESP8285 module detection various built in flash sizes
      [ESP-IDF5.1] Disable WiFi power save during connect
      [ESP-IDF5.1] Fix building IR plugins for IDF 5.1 builds
      [GPS] Fix showing lat/long scatter plot
      [ESP-IDF5.1] Fix building IR plugins on ESP32-S3
      [GPS] Cleanup old code
      [ESP-IDF5.1] Enable NeoPixel plugins for IDF 5.1 builds
      [GPS] Fix minor issues Position Scatter plot
      [ESP-IDF5.1] Fix NeoPixel Matrix stability on ESP32-S3 (use DMA)
      [ESP-IDF5.1] Improve NeoPixel on ESP32 + add LittleFS ESP32-S2 Neo Build
      [ESP-IDF5.1] Tweak NeoPixel support on ESP32-C3
      [ESP-IDF5.1] Convert PVS Studio test builds to use IDF5.1
      [ESP-IDF5.1] Fix freeing RMT assigned channel + tweak ESP32-classic
      [ESP-IDF5.1] re-enable P088 Heatpump IR for IDF5.1
      [ESP-IDF5.1] Fix build issues after enabling HeatpumpIR
      [ESP-IDF5.1] Only use -mtext-section-literals on ESP32-S3 IDF5 builds
      [ESP-IDF5.1] Fix build issues with "text-section-literals" build flag
      [ChartJS] Fix GPS position scatter plot + add BME280 scatter plot
      [SenseAir] Fix reading Temperature from Sunrise (S11)
      [ESP8285] Fix check for flash interface pin allowing GPIO 9 & 10
      [Tools] Update script to generate webflasher page to show file system
      [Build] Fix compile error when using default Custom.h (#4870)
      [ESP-IDF5.1] Update Arduino ESP32
      [ESP-IDF5.1] Add hardware specific info on ESP32-C2/ESP32-C6
      [ESP-IDF5.1] Add initial Custom builds for ESP32-C2 and ESP32-C6
      [ESP-IDF5.1] Fix build for ESP32-C6
      [ESP-IDF5.1] Remove ESP32C6-beta chip ID patch for old esptool.py
      [ESP-IDF5.1] Add 2M ESP32-C2 no-OTA option
      [ESP-IDF5.1] Fix bootloop on ESP32-C2/C6 in HWRandom() code
      [ESP-IDF5.1] Enable HWCDC for USB serial console on ESP32-C6
      [Sysinfo] Fix crash on ESP32-C2/C6 when drawing meminfodetail charts
      [ESP-IDF5.1] Add WiFi6 (802.11ax) for ESP32-C6 & fix SPI issues C2/C6
      [ESP-IDF5.1] Fix SPI bus issues for ESP32-C2/C6
      [WiFi] Bugfix: AP wasn't consistently started on WiFi connection failure
      [ESP8266 Setup] Fix bootloop during initial setup Custom ESP8266  build
      [ESP-IDF5.1] Fix build issue ESP32-C3
      [ESP-IDF5.1] Move ESP32 partition definitions
      [Setup] Fix load CSS on initial WiFi setup page
      [ESP8266] Switch to using 2nd heap with Arduino SDK 3.1.2
      [ESP8266] Fix stability issues when using 2nd heap
      [ESP8266] Change default platform to not using 2nd heap
      [ESP8266] On 2nd heap do not keep event queue on 2nd heap
      [ESP8266] Optimize memory allocations + 2nd heap
      [Build] Fix building ESP8266 envs
      [Build] Reduce build size minimal OTA builds (lib_ignore)
      [Build] Make ESP8266 display build fit (lib_ignore)
      [Build] Cleanup of platformIO ini files for ESP8266
      [RAM] Move MQTT buffer and OLED frame buffer to 2nd heap
      [2nd Heap] Tweak 2nd heap stability + set as ESP8266 regular
      [ESP-IDF5.1] Update to the latest Arduino/ESP32 commits for IDF5.1.2
      [ESP-IDF5.1] Fix building ESP32-Solo1 builds
      [ESP8266] Move 'regular' platform back to ESP8266/Arduino 2.7.4
      [Cleanup] Free up 1k of RAM when not using MQTT controller
      [Build] Fix missing include WiFi commands
      [OLED Framed] Use double buffer for update only changed pixels
      [WiFi] Fix connect to Hidden SSID on Mikrotik AP (#4885)
      [Cleanup] Reduce build size for sysvars page
      [Rules] Speedup parsing system variables
      [WiFi] Only connect using BSSID when BSSID is available
      [Variables] Fix bug in parsing incomplete variables + add var nesting
      [Rules] Add variable offset calculation for shorthand var (%v=1+%v2%%)
      [ESP-IDF5.1] Change default SPI pins for ESP32-C2/C6
      [ESP32 WiFi] Fix reconnect issue after WIFI_REASON_AUTH_EXPIRE
      [ESP-IDF5.1] Update to latest IDF/Arduino code
      [ESP-IDF5.1] Revert to previous IDF build (SPI registers wrong)
      [ESP-IDF5.1] Use LTO on ESP32 IDF5.1 builds to reduce build size
      [Build] Fix building ESP8266 core 2.7.4 minimal builds
      [ESP-IDF5.1] Fix ESP32-classic and -S3 build become larger using LTO
      [Docs] Add .readthedocs.yaml to fix auto build
      [ESP-IDF5.1]  Add SafeBoot minimal image for 4M ESP32-xx nodes
      [Webserver] Fix storing static content in browser cache
      [ESP-IDF5.1] Fix crash after scan on setup page with static IP
      [ESP-IDF5.1] Fix crashes on ESP32-S3/C3/C2 WiFi scan
      [Cron] Switch ccronexpr lib to supertinycron fork.
      [Build] Comment  out main function test code supertinycron lib
      [SuperTinyCron] Fix discard 'const' qualifier warning in lib
      [Build] Put IR libs in lib_ignore for 'normal' builds to speed up builds
      [ESP-IDF5.1] Update to latest Arduino/ESP32 and IDF code
      [ESP-IDF5.1] Speed up WiFi reconnect on ESP32-xx
      [Setup] Improve Captive portal redirect on Android
      [Build] Fix build issue for new cron job library
      [ESP-IDF5.1] Clean up ESP32-C2/C6 PlatformIO ini files
      [Formula] Fix applying formula & keep raw values in RTC
      [Formula] Apply formula when updating taskvalues
      [Formula] Fix build on ESP8266
      [Formula] Fix build + cleanup UserVarStruct code
      [Formula] Fix ESP8266 1M build
      [Formula] Allow computing formula when reading the task values
      [Formula] Add detection which cached value has been computed
      [formula] Fix using %pvalue% in formula
      [Formula] Fix stack overflow parsing %pvalue%
      [Formula] Disable PlatformIO env normal_alt_wifi_ESP8266_4M1M
      [Build] Quest for smaller bin files
      [Build] Fix ESP8266 build consistency in used parameters
      [Cleanup] Reduce build size
      [Build] Reduce build size
      [Cleanup] Reduce build size by simplifying task init success check
      [Build] Reduce build size
      [Build] Reduce build size
      [Build] Reduce build size
      [Build] Reduce build size (P137)
      [Build] Reduce build size by turning get/setNbitToUL to macros
      [Build] Reduce bin size (SenseAir)
      [Commands] Simplify internal command handling & reduce build size
      [Cleanup] Simplify calling internal commands
      [USB CDC] Fix console on ESP32-C6 USB Jtag port & cleanup unused boards
      [Cleanup] Cleanup internal command parse code
      [IDF-5.1] Update to latest ESP32 sdk & fix getting remote IP
      [Build] Fix build with wrong board definition
      Fix typo in IP Access control compare IPs
      [IDF-5.1] Update to the latest ESP32 SDK code
      [ESP-IDF5.1] Add initial support for IPv6
      [ESP-IDF5.1] Make IPv6 ESP32-only (for now) & list all IPv6 addresses
      [Build] Fix copy/paste error
      [ESP-IDF5.1] Fix IPv6 build on ESP32-solo1
      [ESP-IDF5.1] Add preliminary IPv6 support for Ethernet
      [IPv6] Fix typo in function name markGotIPv6
      [ESPEasy p2p] Fix rejecting data from nodes running build < 20230505
      [ESPEasy p2p] Fix not checking for sensor type from old nodes
      [ESP-IDF5.1] Add preliminary support for IPv6 for ESPEasy p2p
      [ESP-IDF5.1] Disable IPv6 default, only for TESTING_FEATURE_USE_IPV6
      [ESP_IDF5.1] Fix stupid inverse check for testing IPv6 define
      [Dummy] Fix TaskValueSet command
      [SysVars] Fix parsing all system variables in a rules line
      [Web Formatting] Fix showing Note: HTML class
      [Web commands] Show LogEntry results + speed up  parsing web commands
      [Build] Fix minimal OTA build
      [ESP-IDF5.1] Enable IPv6 for ESP32 'custom' builds
      [Event] Fix duplicate event when sent as web command on tools page
      [Controller] Fix parsing %valname% and %value% used in some controllers

Ton Huisman (2):
      [Build] Freeze Python version on 3.11 so pygit2 will run as intended
      [WiFi] Optimization


-------------------------------------------------
Changes in release mega-20231130 (since mega-20231013)
-------------------------------------------------

Release date: Thu Nov 30 08:11:17 PM CET 2023

Fabio Ancona (3):
      Update Custom-sample.h with missing Plugins and update description
      Update Custom-sample.h after review
      Details supported hardware

TD-er (18):
      [WiFi] Fix force B/G mode on ESP8266
      [WiFi] Limit WiFi speed to HT20 for 802.11n mode on ESP32
      [Build] Fix compile error when using default Custom.h (#4870)
      [CDN URL] Add default CDN url with latest tag when no pygit2 installed
      [WiFi] Fix connect to Hidden SSID on Mikrotik AP (#4885)
      [WiFi] Only connect using BSSID when BSSID is available
      [ESP32 WiFi] Fix reconnect issue after WIFI_REASON_AUTH_EXPIRE
      [FactoryReset] Store settings to keep in ESP32 NVS storage
      [Custom CDN] Move Custom CDN URL to config.dat
      [Custom CDN] Move position of where Custom CDN URL is stored in settings
      [Factory Reset] Use NVS stored defaults on reset
      [Custom CDN] Fix storing empty CDN url.
      [Factory Reset] Store WiFi/Eth config in NVS
      [Factory Reset] Store log/console settings in NVS
      [Custom CDN] Add checkbox to store Custom CDN to NVS
      [Custom.h] Update Custom-sample.h with new CUSTOM_BUILD_CDN_URL
      [Factory Reset] Add new flag to NVS for slow connect to hidden SSID
      [ESP8266 build] Set all ESP8266 'normal' builds to use CDN for CSS/JS

Ton Huisman (68):
      [Lib] HeatpumpIR update to 1.0.23
      [Lib] HeatpumpIR Add compatibility with ESP32 Arduino 3.0/IDF 5.1.x
      [P023] Bugfix: Template parsing was overwriting the template
      [P159] Add LD2410 Radar presence detection
      [P023] Minor performance improvement
      [P159] Remove copy/paste evidence :-D
      [P159] Many improvements, add/update settings for sensitivity
      [P159] Fix compilation on LIMIT_BUILD_SIZE builds
      [P159] Small improvements
      [P159] Small improvements
      [P159] Add command for sensor factoryreset
      [Lib] LD2410: Fix bug (-1 for uint), add undocumented OutputPinState value
      [P159] Add OutputPinState option after AmbientLight option (breaking change!)
      [P159] Minor change to determine how that may influence the build
      [NEOPIXEL] Add NeoPixelBus_wrapper and implement in NeoPixel plugins
      [Lib] Adjust Adafruit_NeoMatrix to use NeoPixelBus_wrapper
      [ESP-IDF5.1] Update NeoPixelBus with Tasmota's patches for ESP-IDF5.1
      [NeoPixel] Add changelogs for applying NeoPixelBus_wrapper library
      [Build] Fix pygit2 version
      [Build] Fix pygit2 version
      [Build] Restore pygit2 version
      [Build] Try older/current version of pip
      [Build] Explicit version of libgit2
      [Build] Undo changes
      [ESP-IDF5.1] Fix build issue on older IDF based builds
      [Neopixel] Fixes and improvements
      [Build] Freeze pip dependencies
      [Build] Undo changes
      [Build] Try fix failing pygit2 install
      [Build] Try older Python version
      [Neopixel] Fix fall-through return value
      [Build] Fix some cherry-pick diffs
      [Build] Freeze Python to 3.11 to fix pygit2 build issue
      [P159] Add Gate0 energy values that where missing Add GetConfig support for fetching all available values Add ld2410,logall command for dumping all values in the log (INFO level) Code improvements
      [NeopixelWrapper] Code optimization
      [P021] Set Hysteresis value via config command
      [P021] Update documentation
      [Build] Freeze Python version to avoid build issue with pygit2
      [Build] Freeze Python version on 3.11 so pygit2 will run as intended
      [P021] Change commands SetHysteresis and GetHysteresis for consistency
      [Lib] LD2410: Read all data that can be read in 5 msec, add errorcount and data_valid checks
      [P159] Rework processing, now near-instant response Add GetConfig support for sensitivity per gate values
      [Lib] LD2410: Reformat source (nearly all is changed!) Replace yield() by delay(0)
      [P159] Fix wrong use of F(""), should be EMPTY_STRING
      [Lib] IRremoteESP8266 update to v2.8.6, with ESPEasy patches applied - Disable some (more) IR protocols to make 1M build fit - Add IDF 5.x compatibility
      [Lib] Adafruit_NeoMatrix: Fix includes
      [Lib] Remove Adafruit_NeoPixel from repo
      [P131] Fix variable initialization, call begin() to start the NeoPixels
      [P041] Uncrustify source, minor improvements
      [P042] Fix initializations to avoid crash at start, minor improvements
      [P070] Minor improvements
      [Lib] Update library.properties for local copy of Adafruit_NeoMatrix
      [Docs] Updates and corrections Nov. 2023
      [Docs] Updates and corrections Nov. 2023
      [P159] Add documentation
      [P159] Update EasyColorMirror
      [P159] Update comments to explicitly name LD2410
      [CDN] Set override url for CDN hosted files
      [CDN] Update documentation
      [CDN] Code improvements, Add to Provisioning
      [CDN] Update documentation
      [Provisioning] Split provisioning commands, add fallback for MAX builds, code cleanup
      [Provisioning] Update documentation
      [CDN] Replace system variables in url, update documentation
      [I2C] Add Device flag for 100 kHz-only devices
      [I2C] Devices that only support 100 kHz speed
      [Bugfix] [P159] Saving settings checkbox failed on ESP8266
      [Docs] Fix some typos Nov. 2023

jfmennedy (8):
      P093 Mitsubishi HeatPump Add Support for SetRemoteTemperature Resolves P093 - Mitsubishi Heat Pump Add Remote Temperature #4711
      Modify Changelog Order
      Help needed here
      - Fix float initialisaton, - Fix float comparator, - Still trying t get SetRemoteTemperature working...
      -Fix static const uint8_t RemoteTemperature
      - Implement remarks from review
      Documentation
      Documentation Review


-------------------------------------------------
Changes in release mega-20231013 (since mega-20230930)
-------------------------------------------------

Release date: Fri Oct 13 06:01:32 PM CEST 2023

Fabio Ancona (1):
      Fix SI7021/HTU21D DOC links

TD-er (2):
      [P039_Thermosensors] Fix check for valid value
      [Controller Settings] Fix inverted Send LWT and Will Retain

Ton Huisman (5):
      [Networking] Log string and formatting improvements for size
      [Networking] Fix typo in string argument for strformat
      [P047] Update address-change documentation
      [P131] Optimization for build size
      [UI] Show Controller-state on Device page

dobry kod (3):
      [GPIO] Fix taking wrong branch in GPIO_Monitor10xSec when MCP/PCF plugin is disabled
      [GPIO] Fix response to Status command
      [GPIO] Fix mode reported in response to Status command


-------------------------------------------------
Changes in release mega-20230930 (since mega-20230822)
-------------------------------------------------

Release date: za 30 sep 2023 15:46:23 CEST

Adam Groszer (1):
      added InfluxDB v2 HTTP API docs and some other minors

Fabio Ancona (3):
      Update README.md adding "Climate"
      [DOC] Update P014 to avoid to use this Plugin with SHT2x devices
      Update P014.rst

Michael Schröder (1):
      Ignore more variants of own Custom.h

TD-er (83):
      Update issue templates
      [ADS1x15] Support ADS1015 & add sample rate selector
      [ADS1x15] Add ADS1015/ADS1115 sensor type detection to task config page
      [Cleanup] Add macro NR_ELEMENTS for array counting
      [ADS1x15] Add option to select multiple task value outputs
      [ADS1x15] Simplify storage of settings
      [ADS1x15] Update documentation
      [ADS1x15] Update documentation
      [ADS1x15] Replace "ADS1115" with "ADS1x15" in docs and I2C scan result
      [ADS1x15] Fix PBC -> PCB typo in documentation
      [BMP3xx] Add support for Bosch BMP384/388/390 temp/pressure modules
      [BMP3xx] Fix saving I2C address
      [BMP3xx] Perform a few reads after init to initialize the IIR filter
      [BMP3xx] Add detected chip + altitude compensation
      [BMP3xx] Document P154 BMP388/BMP390
      [BME280] Show detected sensor model like is done for ADS1x15 and BMP3xx
      [Scheduler] Cleanup of Scheduler code
      [Scheduler] Allow to schedule task calls to specific functions
      [Scheduler] Split Various Scheduler timer types into separate .cpp files
      [Cleanup] Fix build issue in WOL plugin
      [Scheduler] Remove unneeded scheduler call type
      [Scheduler] Cleanup includes and fix decode()
      [Documentation] Document ESPEasy Functional Blocks
      [Documentation] Add ESPEasy Functional block diagram
      [Docs] Mark arrow between controller and MQTT broker as bidirectional
      [Docs] Clarify some arrows in ESPEasy block diagram
      [Task] Revert 'soft disable' task (for now...)
      [Cleanup] Make deviceIndex_t a strict class
      [Cleanup] Only allow PLUGIN_ADD to change Device[] vector
      [Cleanup] Make pluginID_t a strict class
      [Cleanup] Fix build error on ETH builds with pluginID_t
      [Cleanup] Partial conversion npluginID_T to class
      [Cleanup] Complete convert npluginID_t to strict class
      [Cleanup] Reduce build size on ESP8266 making DeviceVector less strict
      [Cleanup] Fix crashing compiler on ESP8266 builds
      [Cleanup] Reduce build size to 'undo' extra added bytes in this cleanup
      [Cleanup] Further reduction of build size
      [Cleanup] Fix build on ESP8266 Collection A
      [Cleanup] Fix build error on ESP8266 Display
      [Cleanup] Reduce build size by moving small functions to .h files
      [Cleanup] Use constexpr for static pluginID compares
      [Cleanup] Use more constexpr for static pluginID compares
      [Controller] Simplify ESPEasy core administration of CPlugins
      [Cleanup] Misc code cleanup + add comments from PVS Studio
      [Plugin] Simplify ESPEasy plugin registration + reduce build size
      [Cleanup] Simplify code for return values internal ESPEasy commands
      [Cleanup] Simplify get/set functions of VariousBits1 in SettingsStruct
      [Cleanup] Remove no longer needed globals/Protocol.h/.cpp
      [Neopixel] Fix build error signed/unsigned compare
      [Cleanup] Apply GPIO log optimizations to reduce build size (@Ton)
      [Cleanup] Fix storing new task (taskenable still doesn't work...)
      [Cleanup] Fix silly bug setting tasks disabled.
      [Cleanup] Reduce size of embedded lookup table to only included plugins
      [Cleanup] Do not use 'Number' in DeviceStruct class
      [Cleanup] Simplify DeviceIndex_sorted
      [Cleanup] Fix merge issue
      [Cleanup] Minor code tweaks to reduce build size
      [Debug] Add "minimal" special build for analysis
      [PVS Studio] Fix issues found by PVS Studio
      [Cleanup] Reduce build size by moving isInitialized() to .h files
      [Servo] Fix servo for ESP32-S2/C3
      [Cleanup] Reduce build size for bitlevel access in Controller Settings
      [Cleanup] Remove code redundancy from DevicesPage and UploadPage
      [PluginStats] Fix showing stats when using 256 samples buffer
      [Cleanup] Fix crash when adding new controller
      [Cleanup] Disable drawing partition layout for limit build size builds
      [Cleanup] Fix isNaN check in thermocouple plugin
      [Debug] Add special debug build env for Display builds
      [Cleanup] Reduce build size making Improv smaller
      [Debug] Set special debug 'display' build to BUILD_NO_DEBUG
      [Cleanup] Shorten (very) elaborate notes in P039 ThermoCouple
      [Cleanup] clarify single event note + reduce GPIO command logs
      [I2C scanner] Fix missing ++x; causing reboot during I2C scan
      [ADC] Fix handling negative ADC values from Hall Effect sensor
      [Notifications] Fix deleting notifier
      [GPIO] Fix check for valid GPIO
      [RTTTL] Fix parsing correct command argument
      [RTTTL] Fix argument index for melody + prevent crash when changing song
      [RTTTL] Fix stupid mix-up of old/new command argument parsing
      [RTTTL] Only check for old/new syntax in the 1st argument
      [RTTTL] I need some coffee....
      [Internal temp] Fix crashes on ESP32-S2/S3/C3 + filter
      [ESP32 temp] Fix specific includes for ESP32-S2

Ton Huisman (77):
      [P036] Show current display content on Devices page
      [P036] Wrap on-display output in `pre` tag to keep spaces and similar formatting
      [P036] Remove unreachable code, other optimizations
      [addHtmlDiv] Add optional `attribute` argument
      [P036] Reduce Show Display font-size to 75%, code optimizations
      [P023] Add Show Values for on-Display content, code improvements and optimizations
      [P036] Make Interval optional
      [P036] Update documentation
      [P023] Add documentation
      [P023] Updated screenshot
      [P036] Add center/right align in preview, make preview compile-optional, code optimizations
      [P036] Only disable alignment feature for 1M builds
      [P036] Add new compile-time directives to Custom-sample.h
      [Build] Make `Climate` build fit
      [P036] Code optimizations
      [P023] Minor code optimizations
      [P036] Add optional user-defined display headers
      [P036] Change compile-time defines to bool, change enums to uint8_t type, update changelog
      [P036] Fix copy/paste error for `userDef2`
      [P028] Add detection-mode setting
      [P028] Ignore humidity if Sensor model BMP280 is selected
      [Devices] Add event PLUGIN_WEBFORM_LOAD_ALWAYS that is also called for remote data-feed devices
      [P028] Fix VType matching for remote data-feed, implement new WEBFORM_LOAD_ALWAYS event
      [P028] Update documentation
      [Controllers] Show correct data (or nothing) for controllers without Host or Port settings
      [Controllers] Code improvement
      [P036] Enable Userdefined headers by default for LIMIT_BUILD_SIZE builds
      [P104] Add Dot subcommand to draw individual dots in a zone
      [P104] Update documentation
      [P104] Code improvements and a bugfix
      [P028] Fix merge conflict
      [P036] Code improvements using `constexpr`
      [Rules] Improving removal of comments
      [Rules] Separate comment removal from reading a line
      [Release] `release.yml` script improvements
      [P036] Fix merge conflicts, small source formatting improvements
      [SD-card] Bugfix: Opening a file from SD-card doesn't always work
      [SD-browser] Code improvements
      [P153] Fix incorrect Sensor_VType setting
      [SD-Card] Show SD-card CS GPIO pin in pin-selection
      [P036] Bugfix in documentation-syntax
      [P051] Fix device being automatically disabled and I2C scan issue
      [I2C Scan] Make I2C scan more robust by adding extra wakeup
      [Docs] Add I2C Scan documentation
      [Docs] Additional I2C Scan documentation (mux)
      [Docs] Rules example for PostToHTTP/PutToHTTP
      [UI] Bugfix: Don't show - None - [SD-CARD] in GPIO selector when SD-Card is not configured (improves #4780)
      [Build] Restore RTTTL feature in ESP8266 Climate build
      [RTTTL] Add Async play and other improvements
      [RTTTL] update documentation
      [GPIO] Decrease buildsize by optimizing logging
      [RTTTL] Add FEATURE_ flags to Custom-sample.h
      [GPIO] Adopt optimized logging improvements (@gijs)
      [Build] Add Collection G builds
      [Build] Move [P154] BMP3xx to Collection G
      [Build] Add checks for some external defined compiletime settings
      [P036] Code formatting and optimizations
      [P037] Build: Include all features in ESP32 builds
      [P073] Reduce logging for BUILD_NO_DEBUG builds to reduce size
      [P036] Updates for documentation
      [P026][Sysvars] Add Internal temperature sensor value for ESP32
      [P026][Sysvars] Feedback and fixes
      [P026][Sysvars] Fix typo in comment
      [P026] Add Get Config feature for all values
      [P026] Add documentation
      [Scripts] Handle 8M builds in WebFlasher
      [P026][Sysvars] Avoid temperature reading errors on ESP32 classic (2 tries only)
      [P026][Sysvars] Read temperature every second on ESP32 classic for better results
      [Build] Try to use real branch name on GH Actions builds
      [Build] Ignore Docs commits to trigger an Actions run
      [P026][Sysvars] Explicitly disable FEATURE_INTERNAL_TEMPERATURE for ESP8266
      [P026][Sysvars] Add delay() call
      [Build][P026] Update documentation (without Actions run...)
      [P037] Update documentation
      [RTTTL] Add events for RTTTL play (async only), fix intermitted/skipped async playing
      [RTTTL] Restore Cancelled event, update documentation
      [P000 Docs] Update some internal links

chromoxdor (2):
      Fixed error in section TaskValueSet
      Update GPIO.cpp

dependabot[bot] (1):
      Bump actions/checkout from 3 to 4

uwekaditz (9):
      [P036] Add ticker as scroll option
      Compiler error if P036_SendEvent was not set
      Calculation for ticker IdxStart and IdxEnd was wrong for 64x48 display, Start page updates after network has connected in PLUGIN_ONCE_A_SECOND
      Some bug fixes (only 1 line displayed)
      Removed unnecessary clear() functions
      Merged with mega from 2023-08-25
      Wrong #ifdef P036_SEND_EVENTS
      CHG: Disable scrolling or ticker if new line content received (PLUGIN_WRITE)
      CHG: Code reduced if P036_ENABLE_TICKER is not used


-------------------------------------------------
Changes in release mega-20230822 (since mega-20230623)
-------------------------------------------------

Release date: Tue Aug 22 09:40:44 PM CEST 2023

TD-er (102):
      [Eastron] Fix merge issues
      [Eastron] Uncrustify + remove 500 bytes of  duplicate strings
      [Eastron] Fix merge issues
      [Cleanup] Reduce bin size by stripping unused code
      [Cleanup] Reduce bin size by deduplicate factory reset code
      [Factory Reset] Fix keeping settings (#4263)
      [RFcal] Fix typo in command "clearwifirfcal"
      [SendToHTTP] Only include "Authorization" header  when credentials set
      [ESP32 2.0.5.x] Fix crashes calling noInterrupt() in ISR callback
      [Adafruit NeoPixel] Update lib to fix noInterrupts
      [Quad Enc] Fix ESP32 noInterrupts()
      [Build] Fix merge issues, missing #endif
      [ESP32-solo1] Add support for single-core ESP32
      [Web flasher] Split "4M collections builds" in a separate group
      [release build] Copy ESP32solo1 binaries during release
      [Crash Analysis] Show controller/plugin name on crash at system event
      [Build] Fix merge issue with duplicate PlatformIO envs
      [Build] Fix missing #ifdef check
      [Devices] Fix showing all included plugins in devices pull-down list
      [Cleanup] Move plugin function pointer array to PROGMEM
      [Cleanup] Simplify weblog buffer
      [Cleanup] Fix build error due to missing defines
      [Cleanup] Improve web serve speed + value formatting speed
      [Cleanup] Reduce resouces used on Dallas, Sysinfo and Dummy tasks
      [Build] Fix missing #ifdef check
      [Cleanup] Reduce CPU usage only calculate valuecount once
      [ESPEasy p2p] Remove delay() calls from p2p messaging
      [Cleanup] Remove unused PLUGIN_EVENT_OUT
      [Cleanup] Get timing stats for controller function calls
      [cleanup] Simplify parse controller variables
      [P2P] unit with latest build not receiving values of shared plugins (#4718)
      [P2P] Check for unset DeviceNumber in matchesSensorType
      [Cleanup] Speedup frequent calls + reduce build size
      [Cleanup] Reduce calls to saveToRTC()
      [Cleanup] Simplify mustConsiderAsJSONString()
      [Cleanup] Remove long webserver debug log
      [Cleanup] Reduce backgroundtasks() frequency
      [Cleanup] Reduce mem allocs for ADC logs
      [HLW8012] Improve stability and accuracy
      [Cleanup] Allow a task to set initial PLUGIN_READ on init
      [Cleanup] Reduce memory usage when timingstats is disabled (or read)
      [PlatformIO] Force PIO to 6.1.7
      [HLW8012] Fix instability due to IRAM
      [Build] Move "hard_" builds to ESP8266 SDK 3.1.2
      [Cleanup] Reduce items being logged in TimingStats
      [Build] Revert switching 'hard_' builds to ESP8266 SDK 2.7.x
      [HLW8012] Remove IIR filter from interrupt callback function
      [PlatformIO] Test build with PIO 6.1.9rc1
      [PlatformIO] Test build PIO 6.1.9rc1 (2nd attempt)
      [PIO] Set minimal PIO version to 6.1.9
      [Cleanup] Simplify allocation of ControllerSettings allocation, memleak?
      [PVS Studio] Fix issues found by PVS Studio
      [PVS Studio] Fix build error & unsafe macro
      [PVS Studio] Fix some issues found by PVS Studio
      [Cleanup] Attempt to fix memory leak in PluginTaskData
      [ArduinoJSON] Update to ArduinoJson 6.21.2
      [Cleanup] Simplify PluginStats::getSample
      [PVS Studio] Fix some issues reported by PVS Studio
      [MDNS] Disable MDNS for ESP8266 due to memory leak
      [CSE7766] Improve reliability + fix issue with console port selection
      [CSE7766] Fix parsing packets with lost bytes
      [CSE7766] Add output selection of units of measure
      [WiFi] Fix ESP8266 instability  compiler optimization flag -O2
      [mDNS] Call MDNS.announce() every second on ESP8266 (mem leak?)
      [Cleanup] Add strformat function to simplify log line creation
      [Build] Fix build errors incorrect use of strformat()
      [Cleanup] Move duplicate oversampling code to helper class
      [ESP32 Serial] Fix serial tasks not working after save or restart task
      [ESP32 Serial] Do not cache baud rate between end() and begin()
      [Cleanup] Replace oversampling code duplication P145
      [Cleanup] Replace oversampling code duplication P060
      [Cleanup] Replace oversampling code duplication P067
      [CSE7766] Update task value with intermediate oversampling value
      [Oversampling] Add reset + weighted keep last
      [ESP32 Serial] Fix serial tasks not working after save or restart task
      [Eastron] Update SDM library to v2.2.2
      [Eastron] Re-apply ESPEasy specific changes to SDM library
      [Eastron] Generate all SDM register strings
      [Eastron] Cleanup showing default taskvalue names + SDM72_V2add
      [Eastron] Cleanup code duplicates & uncrustify
      [Eastron] Fix compiler warnings
      [Eastron] Add support for SDM320C
      [Eastron] Split 'readVal' function to allow async reads
      [Eastron] Add "demand" in register description
      [Eastron] Implement complete async read of Eastron registers
      [Eastron] Add hardware RTS support for ESP32 (for ~RE/DE pin on RS485)
      [Eastron] Fix ESP32 hardware RTS flow control
      [Eastron] improve speed & add commands to set modbusID & baudrate
      [Eastron] Start documentation
      [Eastron] Document RS485 specific wiring
      [Eastron] Complete documentation on Eastron plugin
      [Eastron] Add support for RS485 collision detection on ESP32
      [Serial Console] Fix HW Serial0 unusable on ESP8266 limited builds
      [Eastron] Add delay on first PLUGIN_READ to allow reading registers
      [Build] Set ESP8266 Energy build to LIMIT_BUILD_SIZE
      [Build] Change LIMIT_BUILD_SIZE on ESP8266 Energy to BUILD_NO_DEBUG
      [Eastron] Improve read stability on ESP8266
      [CSE7766] Fix crash when not all stats are enabled
      [Settings] Fix setting task var names & load default names
      [Settings] Fix task value names not being updated on ESP32 (cache)
      [Settings] Fix setting custom task value name on Eastron task
      [ADS1115] Retry on error reads within timeout

Ton Huisman (68):
      [Release][Bugfix] Script should deploy an archive per CPU Architecture
      [Docs] Describe `Wrk` and `Wkd` indicators for `Clock#Time` event
      [P153] Remove unused #include
      [Build] Add support for ESP32-S3 8MB units
      [Build] Rearrange 8M2M to 8M1M configuration
      [P118] Fix compilation when suppressing only DEBUG logging
      [Build] Check all ESP32 builds correctly for factory.bin filesize
      [Docs] Fix typo on Plugin page
      [Build] Add `boards` definitions for ESP32-S3 8MB and ESP32-S3 16MB
      [ETH] Allow Ethernet Power GPIO pin unset (#4724)
      [P014] Set default output values to Temp/Hum
      [P118] Fix compilation when included in Custom builds
      [Build] Update board_name for custom_ESP32_4M2M_NO_OTA_LittleFS
      [Build] Add missing #undef FEATURE_TIMING_STATS
      [Rules] Add minHexDigits to toHex function
      [Docs] Improvements and various fixes
      [Build] Add some missing defines to MAX build to make them explicitly available
      [P128] Revert changes after library update (not working with ESP8266)
      [UI] Add option for disabling Rules auto-completion
      [P035] Add Inverted output option, as supported by the IRsend library
      [P035] Code improvements
      [P035] Add documentation
      [P009] Small documentation typo
      [P014] Fix invalid cast
      [Build] Move ESP32_4M2M settings to own board file
      [Build] Remove unused board definition files
      [P118] Allow enable/disable of ORCON feature via Custom.h
      [P141] Allow enable/disable of Cursor X/Y values feature via Custom.h
      [Console] Add newline after console command to avoid mixing in with logging
      [P046] Fix documentation, address some code issues, WiP
      [P046] Fix compilation issue and include in MAX build
      [Build] Include IR plugins in MAX builds
      [P035] Small size reductions, remove some unused commented code
      [Build] Enable I2C device scan for ESP32 builds
      [P098] Add documentation
      [EasyColorCode] Fix typo `7ddt` (was 7dtt)
      [EasyColorCode] Add some missing commands
      [P013] Move to category Distance (from position), add missing [P134] to Distance too
      [Controllers] Fix `validCPluginID` check (initialization and actual check)
      [P098] Add precaution to documentation for PWM usage
      [Build] Reduce ENERGY build size by removing DEBUG logging
      [Build] Fix compiler warnings
      [EasyColorCode] Fix some auto-complete issues and typos
      [EasyColorCode] Add few missing commands for P036
      [Lib] Update NeoPixelBus to current latest
      [P128] Use customized NeoPixelBus library, upgrading to latest features won't properly work
      [P113] Fix for shifted I2C address in library, code improvements
      [P113] Apply the fix at the original crime-scene ;-)
      [Libs] Update VL53L1X library to current latest v1.2.12 (with fix)
      [P113] Disable I2C address selection as that seems to mess up the sensor
      [P113] Update documentation
      [P122] Uncrustify and move initialization from constructor to .h file
      [P153] Remove unused variable
      [P020] Sourcecode formatting for clarification
      [Docs] Correct some layout issues, causing parts of documentation to disappear
      [P113] Add a few extra nullptr checks
      [Core] Fix some string/message inconsistencies
      [P113] Add a few extra nullptr checks
      [Converters] Add toStringNoZero() function
      [Generic] Improvements and fixes part 2, Aug 2023
      [P113] Fix typo in log statement
      [AdaGFX] Additional error information for unsupported bmp files, improve docs
      [UI] Widen `textarea` fields for easier input of larger/wider text
      [Docs] P002 / P047 Add YT link for selecting a proper (analog) Soil-moisture sensor
      [Converters] Use the correct conversion
      [Tools] Remove ESP Easy Flasher, update Espressif Download tool
      [Tools] Revert esptool to last version
      [Tools] Add `blank_8MB.bin` for erasing 8MB units, exclude from ESP8266 archive

tomcatxx (3):
      Update SDM.h
      Update _P078_Eastron.ino
      Update SDM.h


-------------------------------------------------
Changes in release mega-20230623 (since mega-20230508)
-------------------------------------------------

Release date: vr 23 jun 2023 22:56:40 CEST

Florian Binder (3):
      Enhance P098 to work without encoder and limit sensors
      remove PLUGIN_TIME_CHANGE
      use PCONFIG_LONG instead of PCONFIG

Joan Soler Galmes (2):
      Added Start and End Pixel feature for scan and dualscan modes
      Modified description of the command

Joan Soler Galmés (1):
      Replaced all occurences of hex2rrggbb("000000") for hex2rrggbb(F("000000")) and An int doesn't need to be converted to an int. (Thx  TD-er)

TD-er (146):
      [ESP32-C3 / -S3] Add support for ESP32-C3 & ESP32-S3
      [ESP32-C3] Disable P097 ESP32Touch for ESP32-C3
      [GPIO info] Define flash pins for ESP32-C3 and ESP32-S3
      [GPIO info] Add hardware/GPIO specifics for ESP32-C3/S3
      [GPIO Boot States] Fix bug storing ESP32-S2 boot states + add ESP32-S3
      [Build] Fix missing include
      [Build] Fix build for ESP8266 missing a define macro
      [NeoPixelBus] Update NeoPixelBus library to 2.7.5
      [ESP32-S3] Fix board definitions + build errors on ESP32-S3
      [ESP32-S3] Add 16M max_ESP32s3_16M8M_LittleFS build
      [ESP32-C3] Fix computing free stack on ESP32-C3
      [Docs] Document pins to use for ESP32-S2/S3/C3
      [PSRAM] Fix PSRAM detection on ESP32-S3
      [Docs] Update documentation regarding supported ESP chips
      [NeoPixelBus] Work-around to compile on older compilers (ESP8266 2.7.4)
      [docs] Fix copy/paste error in ESP32-C3 docs
      [Docs] Update specs of supported (and not yet supported) ESP modules
      [Docs] Document future ESP32 C2/C6/H2
      [Cleanup] Simplify detection of active flash mode
      [p2p] Fix task value data exchange between nodes via p2p (#4649)
      [p2p] Fix check on received data for matching plugin IDs
      [p2p] Fix collecting stats + send to controller on p2p received data
      [p2p] Fix build on LIMIT_BUILD_SIZE builds
      [p2p] Fix receiving p2p data on another node (stupid copy/paste bug)
      [ESP32-S2/S3/C3]  Update user configurable SPI bus in ESPEasy.
      [Build] Fix PlatformIO env definition.
      [Build] Fix build for ESP8266 due to misplaced #ifdef ESP32
      [ESP32-S3/C3] Generate web flasher manifest files for all ESP platforms
      [WiFi] Make Wi-Fi TX power configurable for ESP32-S2/S3/C3
      [ESP32 SDK] Update to ESP32 SDK 2.0.9 + Enable WiFi TX pwr for ESP32
      [PIO build] Update build scripts for scons 4.5.x
      [Build] Fix build error due to strange cast of double type in rules
      [Build] Work-around for new ESP8266 macro of round()
      [Build ESP8266] Replace calls to round()
      [Build] Use HWrandom to overcome build issues
      [Build] Fix missing include
      [Build] Remove extern "C" to allow for (C++) function overloading
      [Build] include ESPEasy_common.h instead of Arduino.h where possible
      [Cleanup] Moving not commonly needed code out of ESPEasy_common.h
      [Build] Remove "Helpers" folder from concat script
      [Build] Include ESPEasy_common.h instead of ESPEasy_config.h
      [Build] Add Helpers folder to concat .cpp for ESP8266
      [Build] Add ESPEasyCore to concat cpp & split global RulesCalculate obj
      [Build test] Disable lots of plugins + not concat Helpers/*.cpp
      [Build test] Disable P037 to test build failures
      [Build test] Undef round right after include <Arduino.h>
      [Build] Revert disabling plugins + concat Helpers/*.cpp
      [Build] Include cmath after Arduino.h to redefine round()
      [Build] Fix building ESPEasy in PlatformIO 6.1.7 (#4656)
      [Cleanup] Fix IP address formatting
      [Python] Create tool to generate web flasher files from build
      [Python] Generate index.html for web flasher
      [Build] Include obviously missing plugins from Climate builds
      Change jquery CDN URL for China users
      [Cleanup] Reduce build size by using float instead of double in rules
      [Cleanup] Fix build, removing double function declaration
      [Cleanup] Use float version of geometric functions to reduce bin size
      [Cleanup] Remove duplicate code for leading zeroes formatting int
      [Cleanup] Keep flags for rules floating point value type in sync
      [Cleanup] Revert some changes based on review feedback
      [Custom build] Make it easier for custom builds to force float type
      [USB CDC] Support USB serial port for ESP32-S2/S3/C3
      [ESPEasySerial] Split common code to separate .cpp file
      [ESPEasy Console] Split console to separate class
      [ESPEasy Console] Fix build error
      [Build] Fix building on ESP32-S2
      [ESPEasy Console] Enable USB CDC for ESP32-S2
      [mDNS] Disable mDNS for ESP32-S2 as it seems to affect WiFi stability
      [ESPEasySerial] Add platform specific default pins for Serial0 and 1
      [HWCDC] Add event handling to automatically switch to USB serial
      [HWCDC] Fix automatic switching to USB console port
      [USBCDC] Add using USBCDC as console for ESP32-S2
      [ESPEasySerial] Start adding USB serial to ESPEasySerial
      [ESPEasySerial] Create wrapper classes for USBCDC and HWCDC
      [ESPEasySerial] Split files into wrappers and drivers
      [ESPEasySerial] Cleanup ESPEasySerial class
      [ESPEasySerial] Fix compile errors
      [ESPEasySerial] Fix compile errors.
      [ESPEasySerial] Fix build on ESP32-S2 CDC builds
      [ESPEasySerial] Fix build errors on ESP8266
      [ESPEasySerial] Fix (another) build issue on ESP8266 with SWserial disabled
      [ESPEasySerial] Fix selecting HWCDC on ESP32-C3/S3 for console
      [ESPEasySerial] Fix Custom ESP32 build
      [ESPEasySerial] Simplify check availability nr serial ports on SoC
      [ESPEasySerial] Fix switching HWCDC + dynamically set default pins
      [ESPEasySerial] Add preliminary support for console serial port fallback
      [ESPEasySerial] Refactor file names to clarify their use
      [ESPEasySerial] Fix build issue inconsistent defines
      [ESPEasySerial] Fix USBCDC on ESP32-S2
      [ESPEasySerial] Fix fallback USBCDC to Serial0 (input not working yet)
      [ESPEasySerial] Add separate output buffers for fallback serial
      [ESPEasySerial] Add setting to enable/disable fallback to serial0
      [ESPEasySerial] Fix parsing commands via any serial console
      [ESPEasySerial] Fix crashes on ESP32-C3
      [USBCDC] Remove 2nd USB CDC port + use USB CDC on ESP32-S3
      [ESPEasy Console] Show actual serial port config on sysinfo page
      [Console] Reduce boottime when using CDC as port for console
      [USB CDC] Add max_ESP32s3_16M8M_LittleFS_CDC  (e.g. for Lilygo T-dongle)
      [ESP32-S3 CDC] Switch USB serial to HWCDC for ESP32-S3 for web flasher
      [ESPEasySerial] Fix setting correct baudrate
      [ESPEasySerial] Fix saving SW serial pins
      [ESPEasySerial] Get actual baudrate from SW Serial
      [ESPEasySerial] Add SW Serial support for ESP32
      [ESPEasySerial] Do not show default GPIO pins on SW Serial
      [ESPEasySerial] Document new USB serial ports + SWserial for ESP32-xx
      [ESPEasySerial] Update version nr to v3.0.0
      [Cleanup] Improve formatting of GPIO description on devices page
      [HWCDC] Enable HWCDC for all ESP32-C3 builds
      [USBCDC] Enable USB CDC for all ESP32-S2 builds
      [HWCDC] Enable HWCDC for all ESP32-S3 builds
      [Web Flasher] Remove separation of CDC builds in dropdown list
      [Build] Fix missing include for WiFi.h / ESP8266WiFi.h
      [Build] Remove confusing custom build env. for ESP32-S2
      [Build] Fix build not using ESPEasySerial
      [ESP32 SDK] Update SDK to fixed code for HWCDC.end()
      [DNS] Fix DNS server corruption by IPv6 global IP prefix
      [DNS] Allow DNS cache of 0.0.0.0 to be restored
      [Web flasher] Add link to list of plugins per build to flasher page
      [Web flasher] Use Tasmota's version of ESP Web Tools JS to flash USBCDC
      [ESP32-S3] Clarify OPI flash requirements in 16M PSRAM build
      [Build] Mark P065 as dependency on ESPEasySerial
      [ESP32-S3] Document SPI mode quirks for ESP32-S3
      [IMPROV] Implement Improv to ease deployment via web flasher
      [ESP32-S2] Fix esptool.py upload parameters to help autoreset flashing
      [Serial Helper] Disable updating GPIOs on switch serial port on webpage
      [IMPROV] Replace library + modify
      [IMPROV] Add WiFi scan + board/build identification for web flasher
      [IMPROV] Fix build on ESP8266
      [IMPROV] Fix ESP8266
      [IMPROV] Fix build on ESP8266
      [IMPROV] Do not include IMPROV in ESP8266 limited build size builds
      [IMPROV] Fix connect to Wifi + add logging
      [IMPROV] Clear scan result
      [IMPROV] Clean up ESPEasy console handling fallback serial
      [ETH] No DNS entries when using Ethernet (#4702)
      [IMPROV] Feed invalid IMPROV messages to console input again
      [IMPROV] Use parse state to check parse result
      [ESP32 IDF] Update to IDF 4.4.5 (2023-06-14)
      [ESP32 IDF] Update to IDF 4.4.5 (2023-06-14)
      [Cleanup] Simplify init plugins
      [Cleanup] Fix simplify init plugins
      [Cleanup] Move  Plugin_ptr[] to PROGMEM
      [Cleanup] Simplify init included controllers
      [Cleanup] Reduce memory usage on builds with low numbered plugins
      [Cleanup] Fix missing include
      [Devices] Fix showing all included plugins in devices pull-down list

Ton Huisman (62):
      [P152] Add plugin Output - ESP32 DAC
      [P152] Add plugin to ESP32 and ESP32-S2 Normal (all) builds
      [Core] Add support for ESP32 DAC GPIO selection, display and checks
      [P152] Review feedback
      [Core] ESP32 DAC GPIO review feedback
      [P152] Add documentation
      [Core] ESP32 DAC GPIO Show warning for PSRAM pin
      [P152] Update documentation for PSRAM warning
      [P153] Add plugin Environment - SHT4x (Temperature Humidity sensor)
      [P145] Fix compiler warning (unused variable)
      [P152] Update documentation removing non-existent PSRAM warning (#4624)
      [P153] Add command support, apply feedback and other improvements
      [P147] Add plugin Gases - CO2 SGP4x
      [Helpers] Add `calc_CRC8()` function
      [P147] Rename plugin Gases - SGP4x VOC(/NOx), add to I2C Scanner
      [P083] Rename plugin: Gases - SGP30 TVOC/eCO2
      [Custom] Add P147 options, format some definitions
      [Lib] Add Sensirion Arduino Gas Index Algorithm library
      [P147] Implement Sensirion Gas Index lib, finish SGP41 support
      [P147] Change term Calibration to Compensation
      [Lib] Revert unsupported sampling frequency from NOxGasIndexAlgorithm
      [P147] Adjust timing for SGP41, Fix low-power measurement, fix settings-save issue
      [P147] Include plugin in Collection F build
      [P152] Minor improvements, add to Custom-sample.h
      [P153] Minor UI improvements
      [P153] Add documentation
      [P147] Make Compensation values each optional, minor UI adjustment
      [P147] Add documentation
      [Build] ESP32 derivates available in separate archives
      [Build] Fix typo in script
      [Build] Update README.md
      [Build] Fix quotes in script
      [Build] Fix quotes in script
      [Build] Fix wildcards in find command
      [Build] Fix wildcards in find command
      [Build] Fix build issue with latest SCons (temp. fix: downgrade)
      [Build] Fix build issue with latest SCons (copied)
      [Build] Linux find doesn't like wildcards in variables
      [Build] Restore for loop and fix silly typo
      [P152] Apply new CPU defines for enabling plugin
      [P128] Adjust to latest updates of NeoPixelBuxfx library
      [P128] Definition improvements for new CPU types, add support for BGR neopixels
      [C018] Correct include paths (Arduino IDE compilation)
      [P025] Correct include path (Arduino IDE compilation)
      [C018][P025] Shorten include paths
      [P152] Fix typo
      [SD] Corrections for writing logging to sd-card
      [SD] Fix SD card filebrowser, add `uploadsd` feature
      [SD] Fix traversing subdirectories in filebrowser
      [SD] Corrections for writing logging to sd-card
      [SD] Fix SD card filebrowser, add `uploadsd` feature
      [SD] Fix traversing subdirectories in filebrowser
      [P146] Add documentation
      [P153] [Bugfix] Using Startup config with Heater enabled causes checksum errors
      [P153] Return NaN on command-, read- or checksum-error
      [P146] Clarify setting description
      [P146] Extend documentation, add example
      [P146] Extend documentation, fix some typos
      [Build] Add CONFIGURATION_CODE on System Info page
      [P037] Remove unsupported Formula fields from settings
      [C015] Blynk: Fix compile-error when enabling the SSL option
      [Build] [Bugfix] Typo in enum code for CONFIGURATION_CODE

almirus (3):
      Plugin P133 (LTR390 UV) was moved from Collection_E to Climate
      Update define_plugin_sets.h
      Update doc for P133


-------------------------------------------------
Changes in release mega-20230508 (since mega-20230507)
-------------------------------------------------

Release date: ma  8 mei 2023  8:41:45 CEST

Ton Huisman (1):
      [UserVar] Bugfix: Clear element only


-------------------------------------------------
Changes in release mega-20230507 (since mega-20230505)
-------------------------------------------------

Release date: zo  7 mei 2023 16:27:33 CEST

SirWant (4):
      Fix and Add command to PluginStats
      Replacing sampleN and sample to sample+-N
      minor fix
      Final minor fix...

TD-er (7):
      [Cleanup] Remove duplicate code & document
      [RTC TaskValues] Fix proper init of task values
      [p2p] Fix task value data exchange between nodes via p2p (#4649)
      [p2p] Fix check on received data for matching plugin IDs
      [p2p] Fix collecting stats + send to controller on p2p received data
      [p2p] Fix build on LIMIT_BUILD_SIZE builds
      [p2p] Fix receiving p2p data on another node (stupid copy/paste bug)

Ton Huisman (14):
      [P004] Rename to 1-Wire Temperature, add support for MAX31826 sensor
      [P004] Apply CRC check before testing for fixed resolution
      [P004] Variable naming consistently
      [P004] Update documentation
      [P004] Use matching sensor-resolution when reading
      [P004] Use highest required sensor-resolution when reading multiple sensors
      [P004] Remove unneeded debug log message
      [P004] Add 'unsupported' warning for Parasite Powered sensors
      [Build] Fix `Climate` build size issue
      [Build] Add `BUILD_NO_DEBUG` flag on `normal_302_ESP8266_4M1M` and `normal_beta_ESP8266_4M1M` for size
      [P093] Add support for retrieving all device values
      [P093] Updated documentation for config values
      [P093] Add suggested initialization check
      [Build] Make 1M builds fit by excluding some plugins


-------------------------------------------------
Changes in release mega-20230505 (since mega-20230409)
-------------------------------------------------

Release date: vr  5 mei 2023 22:31:21 CEST

Fabio Ancona (4):
      Rename sensor to SHT3x from SHT30/31/35
      Rename sensor to SHT3x from SHT30/31/35
      SHT3x Update docs with detailed chip list
      SHT1x Update docs with detailed chip list

TD-er (32):
      [LoRaTTN] Split up C018 source files
      [P151] Add Honeywell I2C Pressure sensor plugin
      [P151] Fix I2C scanner result not showing address selection dialog
      [I2C] Use standard functions in I2C_access.h/.cpp
      [Dummy] Add 1...4 ULong as taskvalue output type
      [Dummy] Correctly interpret task values based on sensor type
      [Cleanup] Reduce build size using arrays instead of switch cases
      [Dummy] Reduce code duplication accessing task values
      [Cleanup] Fix index issue determine task value name strings
      [SenseAir] Add ABC option
      [SenseAir] Add some more debug sensor info on settings page
      [Build] Fix merge issues
      [ESP32-S2] Fix selection of only 2 HW serial ports ( #4595)
      [Honeywell] Fix measuring temperature and pressure on real sensor
      [Honeywell] Fix accepting "stale" data when value did change
      [Honeywell] Add documentation for P151 I2C Honeywell Pressure
      [SenseAir] Revert SenseAir changes as that is split to #4550
      [TaskValueTypes] Add various data types for dummy plugin
      [CacheReader] Support new task value data types
      [TaskValueTypes] Fix build issue missing #ifdef
      [TaskValueTypes] Fix storing taskvalues to RTC
      [TaskValueTypes] Rename old "Long" type to "ULong", which it actually is
      [TaskValueTypes] Simplify ESPEasy p2p task value exchange
      [Cache Reader] Optimize JSON output
      [TaskValueTypes] Check new types when checking for valid taskvalues
      [TaskValueTypes] Simplify checks on TaskValues + speedup.
      [TaskValueTypes] Add build flag FEATURE_EXTENDED_TASK_VALUE_TYPES
      [Dummy] Update documentation for the new task value data types
      Update to esptool.py 4.5.1
      Update PlatformIO 6.1.6
      Not define esptool.py in the requirements.txt
      pygit2>=1.10.1

Ton Huisman (41):
      [P150] Add plugin Environment - TMP117 Temperature
      [Build] Correct compiler warning
      [P150] Add opt. Raw, add opt. logging, add opt. Fahrenheit, resolve feedback
      [P150] Remove opt. Fahrenheit output
      [P150] Make one-shot mode work, fix interval reading
      [P150] Correctly apply config bits, improve configuration screen
      [P150] Correctly put in `Collection F` set
      [P150] Add documentation
      [Commands] Add internal command HiddenSSID
      [Commands] Add documentation for HiddenSSID
      [Commands] Fix handling empty argument for on/off commands on ESP8266
      [Commands] Fix documentation typo
      [P106] Update BME680 library to latest
      [P106] Rename to BME68x, add Gas in Ohm option
      [P106] Add documentation
      [Commands] Add PutToHTTP command
      [Docs] Add PutToHTTP documentation
      [Commands] Fix typo in PutToHTTP log message
      [LongPulse_ms] Fix end-state for inverted repeated pulse
      [LongPulse_ms] Fix end-state for inverted repeated pulse
      [GPIO] Improve GPIO states for ESP32-S2
      [GPIO] Fixe ESP8266 compilation issue
      [GPIO] Update hardware-page documentation
      [Docs] Add moving average Rules example
      [Docs] Update moving average Rules example
      [P102] Bring plugin-name in line with other plugins
      [P031] Harmonize plugin name
      [P105] Harmonize plugin name
      [P094] Correct name in documentation
      [P112] Add documentation template
      [P112] Remove [Develoment] tag, add to Collection F
      [P036] Bugfix for overlapping page variables
      [UI] Bugfix: `/dashboard.esp` url was not working anymore
      [UI] Setup page doesn't serve css
      [I2C] `I2Cscanner` command check if I2C enabled
      [Custom] Add `FEATURE_RTTTL` define to Custom-sample.h
      [AdaGFXHelper] Fix optional fonts define error
      [Custom] Add `FEATURE_PUT_TO_HTTP` define to Custom-sample.h
      [P080] Add missing `PLUGIN_READ` function-handler, so the state is sent to controllers
      [P080] Only send state-changes to controllers
      [P080] Use UserVar setters/getters for changing and checking the value

flashmark (13):
      P145 Minor changes sensor definition struct
      P122 SHT2x temperature and humidity sensors
      P122 Reworked after review comment
      P122 review changes
      P122 fix wrong bitmask, cleanup
      P122 Small rework, added documentation
      P144 Start documentation
      P144 Rework documentation
      P122 documentation, fix ordering environment plugins
      P144 small review fix
      P122 Fixed typo in documentation
      P122 Limit build size for esp8266
      P122 fixed bug in conditional compilation when debugging switched off


-------------------------------------------------
Changes in release mega-20230409 (since mega-20230306)
-------------------------------------------------

Release date: zo  9 apr 2023 17:42:52 CEST

TD-er (28):
      [Cleanup] Reduce bin size on minimal builds.
      [ETH] Fix connect to LAN with internal clock
      [Build] Fix missing network medium options
      [WiFi] Fix slow WiFi (re)connect
      [WiFi] Fix connect from RTC
      [Eth] Fix restoring cached  DNS IPs
      [Provisioning] Fix setting allowed file types to download via rules
      [Provisioning] Fix cache and mDNS updates after provisioning
      [Provisioning] Only allow downloading firmware update from set host
      [Cache Reader] Add option to delete files after upload
      [Rules] Fix parsing "Clock#Time=All,**:00"  (#4568)
      Sonoff Soil moistrure sensor MS-01 #4503
      Disable I2C dev check HDC1080  #4571
      [ADS1115] Fix channel results mixed #4570
      Rename HDC1080 to HDC10xx #4578
      [Rules] Use variables in clock events
      [ESP32 WiFi] Enable selecting 802.11g mode on ESP32 #4572
      [ADS1115] Show analog port on Devices page
      [ADS1115] Fix build issue on ESP8266
      [ADS1115] Add option to output in Volt using set gain.
      [ADS1115] Update docs
      [Build] Fix merge issue
      Fix using wrong index from string array in sysinfo and SenseAir plugin
      [PluginStats] Fix "highest peak" for negative values
      [WiFi] Fix really slow reconnect on ESP32 (#4572)
      [WiFi] Add auto WiFi (re)Connect and delay options
      [WiFi] Force restart WiFi if auto reconnect is enabled
      [WiFi] Document new Advanced options auto reconnect and extra wait

Ton Huisman (113):
      [P137] Add AXP192 Powermanagement controller
      [P137] Include used library
      [P137] Enable code only for ESP32
      [P137] Add some missing Get Config values, small improvements
      [Build] Define ESP_LOGD(...) macro, not available on ESP8266 platform
      [P137] Available for ESP8266 too
      [P137] Remove [TESTING] tag, enable for ESP8266, minor code improvements
      [Build] Define ESP_LOGD(...) macro, not available on ESP8266 platform
      [Build] Change ESP_LOGD(...) macro, remove accidentally committed file
      [P137] Restored ESP32 limitation as the Linux build can't handle the workaround
      [P137] Activate in all Collection builds too
      [P137] Add controller to ENERGY builds and Custom-sample.h
      [P137] Add documentation
      [P137] Fix flash-string ==
      [UI] Add `disabled` feature for numeric input fields
      [Tasks] Add Priority task feature for initializing plugins early, with documentation
      [Lib] Pull AXP192 library local, and implement missing features, exclude from ESP8266 builds
      [P137] Implement Priority task feature, add more hardware options, add predefined configurations
      [P137] Update documentation
      [Boards] Add PSRAM option for 16M8M to improve stability
      [Build] Add AXP192 to lib_ignore for IR ESP8266 builds
      [Lib] AXP192 remove some unused variables
      [Build] Add AXP192 to lib_ignore for normal_beta 16M ESP8266 build
      [P137] Adjusted default device settings (turn off led and tft backlight for M5Core2)
      [P137] Revert previously added PSRAM option for 16M8M builds
      [Build] Remove suggestion that P138 will be a Priority task plugin
      [P137] Add commands to codeMirror for Rules syntax highlighting, some typos fixed
      [DOCS] Extend development guide
      [DOCS] Add Using external libraries chapter, small corrections
      [DOCS] Use %eventvalue1% in Rules examples where possible, other improvements and additions
      [P008] Add get config values, update documentation
      [P008] Handle initialization issue for unconfigured GPIO pins
      [I2C] Disable I2C GPIO pin configuration if an I2C Priority task is enabled, updated docs
      [P137] Reorder Device Configuration for output configuration change, enable PluginStats, update documentation
      [Hardware] Add warning to disconnect ETH PoE during USB Serial use
      [UI] Darker background color for disabled input fields
      [UI] Darker background color for disabled input fields, update embedded css
      [P137] Exclude some more unneeded code if FEATURE_PLUGIN_PRIORITY not set
      [P137] Add config for LilyGO T-Beam, improved disabled-port UI, update documentation
      [P013] Add setting for trigger-width
      [Libs] Update `NewPing` library, add sanity check for `triggerWidth` argument
      [P013] Reduce variable use, make State mode interval event optional
      [P013] Update documentation with added setting
      [P013] Update documentation with 'hidden' setting for Mode=State
      [Lib] NewPing limit max trigger-width to 20 usec (wide enough)
      [P013] Reduce plugin size (disable added features and log for 1M builds)
      [P013] Update documentation with adjusted 20 usec setting
      [P008] Reduce plugin size, minor optimizations
      [P137] Add I2C config blocked note to documentation
      [Docs] Correct some plugin status labels
      [P013] Add Combined mode, as started in #3157
      [PriorityTask] Fix argument validation
      [P137] Add support for PLUGIN_I2C_GET_ADDRESS
      [P137] Fix merge issue
      [P137] Fix merge issue
      [P013] Update changelog explaining why not using latest NewPing library version
      [P013] Allow Interval = 0, inhibit setting for  suppressing State-events on Interval
      [P013] Update and cleanup documentation
      [P118] Change command to `itho` from `state` (deprecated, not removed)
      [P118] Update documentation for 'itho' command
      [P145] Fix documentation processor warning
      [Docs] Add some missing includes on Commands overview page
      [Displays] Don't trim spaces from text to display
      [Docs] Correct some plugin labels to display separately
      [Parameters] add `parseStringKeepCaseNoTrim` and `parseStringToEndKeepCaseNoTrim` and implement where useful
      [P145] Fix compiler warning (nested comments)
      [Build] Add KEEP_RTTTL build-flag and apply to some builds
      [P065] Add Serial configuration to enable use on ESP32
      [P065] Update documentation
      [Serial] Show I2CSerial as last option, format sources
      [ESPEasySerial] Remote I2CSerial completely when disabled, format source
      [Serial] Hide I2CSerial completely when disabled
      [Serial] Update documentation
      [P065] Set initial config also for ESP8266, increase initial volume to 50%
      [P137] Implement GetCommandCode() for commands and getvalues to reduce bin-size
      [P021] Add Invert Output option
      [P021] Update documentation
      [P089] Change command-handling making taskname optional
      [P089] Add documentation
      [C014] [Homie MQTT] replace DummyValueSet by TaskValueSet (bugfix)
      [C014] Minor corrections
      [Build] Update Arduino framework 2.0.7 (testing)
      [P089] Show Hostname value on Devices overview page (GPIO column)
      [P014] Disable I2C check to correct HTU21D read
      [StringConverter] Add parseHexTextString()
      [P020] Add command `serialsendmix`
      [StringConverter] Improvements to parseHexTextString()
      [P087] Add command `serialproxy_writemix` using `parseHexTextString()`
      [P087] Format source suing Uncrustify
      [P144] Disable additional debug logging
      [Build] Add [C011] to `Climate` build
      [P109] Add documentation for ThermoOLED plugin
      [StringConverter] Add parseHexTextData() to handle 0x00
      [P020] Use parseHextTextData() to handle 0x00 in data
      [P087] Use parseHexTextData() instead of parseHexTextString()
      [P087] Code improvements
      [Docs] Add reference to Youtube video for Git tools and Python installation
      [Docs] Cancel/remove hardly used Github feature
      [P087] Add documentation
      [P073] Fix documenation typo
      [P073] Correct `7dbin` command for TM1637 and fix scroll feature (bugfix)
      [P073] Wrap some methods for conditional compilation
      [P073] Option to suppress leading zeros on day/hour, fix scroll enable/disable
      [P073] Fix documenation typo
      [P073] Update documentation
      [Docs] Minor correction, remove reference to non-existing paragraph.
      [P073] Fix displaying periods for `7dtext` on 6-digit TM1736
      [Build] Add [P077] to Shelly_PLUG_S build environment
      [P047] Add support for BelFlE Soil moisture sensor I2C
      [P047] Add validation on I2C address inputs
      [P047] Add documentation
      [WiFi] APmodeEnabled event not generated when logging is disabled #4593
      [P047] Correct typo BelFlE to BeFlE

chromoxdor (1):
      [P027] Change the default averaging to 128samples

flashmark (13):
      Introduce P240 Vindriktning
      Add P240_Vindriktning experimental
      P240 Vindrikning, conditional debug messages
      P240_Vindriktning small bugfixes
      renamed:    src/_P240_Vindriktning.ino -> src/_P144_Vindriktning.ino Renamed global variables to keep them unique
      P144 rework
      P144 Vindrikning rework
      P144 Vindriktning minor rework
      P144 Vindriktning Review rework
      P144 Vindriktning Optimize time critical code
      Reworked with separate P144_data_struct
      Rework after review
      Merge define_plugin_sets.h

stefan (3):
      [HTTP] Increase timeout on send
      [HTTP] Increase timeouts and smaller fixes
      Excluded debug output


-------------------------------------------------
Changes in release mega-20230306 (since mega-20230304)
-------------------------------------------------

Release date: ma  6 mrt 2023 21:12:53 CET

Ton Huisman (13):
      [I2C] Don't check device availability for remote I2C devices
      [Devices] Don't show Pin/Port/Address options for P2P remote devices
      [Release] Remove duplicated release notes
      [Release] Improved step name in release.yml
      [I2C] Fix scope error.
      [I2C] Set default response for I2C check to true
      [Plugins] Ignore `PLUGIN_INIT` return value if plugin is actually remote
      [Controllers] Add RTD Help button to Controller config page
      [Controllers] Add RTD Controller Help button only when space allows, replace `switch` by `if`
      [Controllers] RTD Controller Help button match String.reserve() size
      [Build] Update to newer Arduino platform lib (2023.01.02)
      [P037] Always return success on PLUGIN_INIT
      [Device] Show I2C options correctly for local devices


-------------------------------------------------
Changes in release mega-20230304 (since mega-20221224)
-------------------------------------------------

Release date: za  4 mrt 2023 13:54:56 CET

TD-er (135):
      [CacheReader] Play back the recorded CacheController data
      [CacheReader] Add rate limiter + command to set readpos
      [Cleanup] Speedup dumpcache page serving
      [Cache Reader] Create binary dump messages.
      [Cache Reader] Send binary blobs to MQTT
      [Cache Reader] Fix check max. message size bin upload
      [Cache Reader] Fix memory leak by indexing non existing files.
      [Cache Reader] Fix stop increasing peek file nr when last was read.
      [Cache Reader] Store/fetch Plugin ID per sample
      [Cache Reader] Fix proper handling last file upload + wait
      [ESP32 SDK] Update to ESP32 SDK 2.0.6
      [Cache Reader] Add sending task names + fix upload all files
      [JSON] Fix escaping invalid characters in JSON
      [JSON] Fix escaping invalid characters in JSON
      [Controller Queue] Reduce bin size by using inheritance
      [Controllers] Reduce bin size by no longer using template
      [Controllers] Reduce bin size by getting rid of extensive macros
      [Controllers] Move TaskIndex to base class for queue elements
      [Controller] Fix queue element vase class members being set
      [Cache Reader] Fix not converting to PluginID twice
      [PubSubClient] Speedup publish calls by direct writing to client
      [Cache Reader] Fix JSON taskinfo + speedup sending to MQTT
      [Dallas] Fix uninitialized sensor data (+crash) when sensor not found
      [Dallas] Fix uninitialized sensor data (+crash) when sensor not found
      [Cleanup] Fix proper initialization of controller queue elements
      [Cleanup] Proper member initialization on ExtraTaskSettings
      [Dallas] Show auto-detected 1Wire ID on Devices page
      [Cleanup] Proper initialization of P036 and P037 members
      [Dallas] Show auto-detected 1Wire ID on Devices page
      [DNS] Fix restoring DNS server config on DHCP renewal
      [DNS] Fix restoring DNS server config on DHCP renewal
      [Build] Disable some plugins in custom build to make it fit again
      [Build] Fix build on ESP8266
      [Build] Fix building on ESP8266
      [Build] Fix missing include
      [Build] Fix missing include
      [Build] Reduce bin size to make normal_esp8266_1M finish building
      [Build] Reduce build size by not including ESP8266mDNS lib at all
      [Build] Reduce build size by not including ESP8266mDNS lib at all
      [Cleanup] Reduce build size.
      [TM1621 Display] Plugin 148: Sonoff POWR3xxD and THR3xxD display (#4448)
      [TM1621 Display] Plugin 148: Sonoff POWR3xxD and THR3xxD display (#4448)
      [Build] Fix build error (signed/unsigned comparison)
      [TM1621] Clean-up, simplify code slightly.
      [TM1621] Add font containing letters for Sonoff Elite displays
      [TM1621] Simplify code
      [TM1621] Access to units of measure symbols
      [TM1621] Properly formatting numericals
      [TM1621] Clean-up unused function + fix comment
      [TM1621] Add option to show taskvalues from plugin
      [TM1621] Documenting commands
      [TM1621] Documentation
      [TM1621] Add selection of unit symbols per task page
      [Dallas] Fix crash when pluginstats are enabled and sensor not found
      [Dallas] Fix re-init of sensors when using 'scan on init'
      [Cleanup] Only save/load settings from storage when changed.
      [Cache] Only clear specific task caches when needed.
      [Cache] Only flush task caches when config.dat file is renamed/moved
      [Cleanup] Leave out unused code.
      [Cleanup] Reduce build size
      [Build] Fix missing includes.
      [Cache] Do not load ExtraTaskSettings from storage for empty tasks.
      [Cache] Fix saving task name and set taskvalue names
      [Cache] Reduce nr of file load/save calls to a minimum.
      [Cache Reader] Fix selecting start position when only 1 file is present.
      [Cleanup] Add ChecksumType  to reduce unneeded file access.
      [Cleanup] Use ChecksumType to limit load/save
      [Build] Add missing include
      [Cleanup] Reduce nr load/save operations (proper init structs)
      [Cleanup] Reduce build size
      [Cache] Simplify task settings checksums
      [TimingStats] Turn timing stats elements into types to check types
      [TimingStats] Fix cast issue
      [Cache Reader] Add configurable MQTT topics for upload/metadata
      [Cleanup] Group timingstats & fix delete of cache controller files
      [ADXL345] Fix setting nr. of decimals
      [Cache Reader] Stop sending 'empty' data if cache controller not enabled
      [Build] Add pre_custom_espXXX_IR.py due to size of IR libs
      [ESP8266] Speedup event handling and rules parsing by caching task name
      [Docs] Add warning about calibrating CO2 sensors
      [ESP8266] Use different constructor for IPAddress (fix crash)
      [Cache] Cache Controller Settings on ESP32 (slow read from LittleFS)
      [Controller Queue] Do not format message when controller queue is full
      [Factory Reset] Factory reset fails with valid FS, but no config.dat
      [ESP32] Export all task values CacheController
      [Cache Controller] Add command to flush all data in RTC memory to flash.
      [Cache Controller] Improve CSV dump speed via /dumpcache
      [Cache Controller] Add JoinSameTimestamp option
      [Cache Controller] Add option to exclude not enabled tasks
      [Cleanup] Reduce bin size on speed-optimized toString function
      [Cache Reader] Make selecting set tasks optional + add join count column
      [Cache Reader] Add config flags + CSV download button
      [Cache Reader] Add Python code to decode bulk upload data sent via MQTT
      [Cache Reader] Add intended nr of 'samples' per bulk message
      [Cache Reader] Cleanup Export dump to CSV & fix separator
      [Cache Reader] Allow bulk dump CSV to MQTT
      [Cache Reader] Fix serving 'last line' of stored data
      [Cache Reader] Send bulk taskinfo in either CSV or JSON, using settings
      [TaskRun] Add optional unixtime as siuggested timestamp (#4497)
      [C016] Use less includes when USES_C016 is not defined
      [Build] Reduce build size ESP8266_normal_1M to match _1M_VCC
      [BootState] Cleanup setting GPIO boot state
      [Task Commands] Fix parsing parameters on commands with only taskindex
      [Build] Fix build error on ESP32 ETH builds
      [TaskRun] Reschedule task to set Interval
      [TaskRun] Also reschedule on TaskValueSetAndRun
      [TaskRun] Cleanup code
      [TaskRun] Fix new command ScheduleTaskRun
      [Build] Cleanup code + reduce build size
      [Cleanup] Simplify generating task events
      [Cleanup] Reduce build size by omitting some conversions
      [Cleanup] Reduce bin size for (flash)string compares
      [Cleanup] Reduce build size using own equals function for flash strings
      [Cleanup] Reduce build size by using own equals() function
      [Cleanup] Replace single char flash strings with char
      [Cleanup] Fix copy/paste error handling stringcommands
      [Cleanup] Small tweaks suggested to reduce bin size
      [ADC] Add config commands to set calibration
      [ADC] Document new ADC set calibration commands
      [SenseAir] Fix reading error state from sensor
      [Controller] Fix crash debug label for delay queue
      [ESP32 ETH] Fix setting DNS on latest ESP32 SDK
      [ESP32 Ethernet] Make sure any ETH power pin is pulled up at boot
      [Build] Fix build error
      [ESP32] Enable LTO to reduce bin size
      [Build] Fix build ESP32 IR ext. using LTO
      [Build] Fix extra_scripts path
      [Build] Set Python 3.10 in build script
      [I2C] Fix crash I2C device is set as first task, with I2C check enabled
      [Build] Disable LTO for ESP32 and ESP32-S2 due to linker errors
      [P025] Uncrustify code
      [ADS1115] Cleanup I2C code + add read timeout
      [ADS1115] Further clean-up of the code
      automatically updated release notes for mega-20230304
      [Build] Replace all Python 3.8 to 3.10

Ton Huisman (161):
      [P138] Add Power mgt - IP5306 plugin
      [P138] Add IP5306 library to lib folder
      [P138] Fix some typos, clean up some obsolete comments
      [P143] Add plugin I2C Rotary encoders
      [Core I2C] Add I2C_writeBytes_reg function, format source
      [P143] Add support for M5Stack I2C Rotary encoder
      [P143] Add support for DFRobot I2C Rotary encoder
      [P143] Add Led(s) off on exit option
      [P143] Add Button longpress support
      [P143] Add command handling, some refactoring
      [P143] Remove [Testing] tag from plugin name
      [P143] Add documentation
      [P143] Add i2cencoder,set,<position> command
      [P138] Remove [Testing] tag
      [P138] Add to I2C scanner
      [P138] Reorder Device configuration, enable PluginStats option
      [P138] Add documentation
      [P138] Use same term for PowerMgt as in P137 docs
      [P143] Move to Collection C (from A) because of build size
      [P143] Update documentation
      [P143] Add nullptr checks, fix byte-swap issue (M5Stack)
      [Misc] Add `byteSwap16()` function
      [P143] Replace macro by `byteSwap16()` function
      [P038] Bugfix: Set default for Initial brightness > 0
      [Misc] Revert/remove `byteSwap16()` function
      [P143] Disable all code related to M5Stack encoder firmware V1.1 (no device available)
      [P001] Get duty-cycle for [Plugin#GPIO#Pinstate#N] on PWM or SERVO pins
      [P001] Get pinstate/duty-cycle for any plugin that registers its pins, exclude code from 1M devices
      [Plugin] Update documentation for `[Plugin#<plugin>#Pinstate#<Pin>]` use
      [Build] Add ESP32 IRExt with Ethernet build environments
      [Eth] Mark used Ethernet Clock pin as unusable if Ethernet is set as Preferred network medium
      [Eth] Refactor EthClockMode vs gpio check into separate function
      [P067] Refactoring and other improvements
      [N001] Add Date in nail header
      [SysVars] Add `%month_s%` on System variables page
      [DateTime] Allow manual `datetime` command repeatedly (skip delay)
      [SysVars] Add variable `systzoffset` with the timezone-offset string, like +0100
      [N001] Add timezone offset in Date header
      [Docs] Extend copyright year to 2023
      [Docs] Add %sysmonth_s% and %systzoffset% variables
      [N001] Update comments
      [P067] Fixes and improvements in refactoring
      [Plugin] Improved documentation for `[Plugin#<plugin>#Pinstate#<Pin>]` use
      [P067] Fix a typo that broke the Tare value of channel A
      [P067] Minor string reductions
      [Build] Reduce bin size by string reductions and other optimizations
      [Build] Fix ESP8266 Custom IR build failure
      [Build] Reduce bin size by string reductions and other optimizations, next batch
      [Build] Reduce bin size by string reductions and other optimizations, next batch
      [P129] Use DIRECT_pin GPIO functions
      [Build] Adjust Custom ESP8266 as already planned to fix build failure
      [Build] Reduce bin size by string reductions and other optimizations, next batch
      [Build] Reduce bin size by string reductions and other optimizations, next batch
      [Build] Reduce bin size by string reductions and other optimizations, P103 Atlas EZO
      [P103] Uncrustify and more optimizations
      [P129] Suppress PVS Studio false positive warning
      [P103] Refactoring, move some code into PluginStructs folder
      [P039] Add Temperature Threshold option (#4451), update documentation
      [Build] Fix warning: comparison between signed and unsigned integer expressions
      [Build] Include P019 PCF8574 in Climate build, as documented (#4444)
      [Build] Reduce bin size by string reductions and other optimizations, next batch
      [Build] Reduce bin size by string reductions and other optimizations, final batch
      [INIT] Validate all plugins to return success = true when successful
      [Devices] Check Task settings on save except MINIMAL builds (#4455)
      [Github build] Switch job-runner to Ubuntu 22.04 to possibly resolve runner failures
      [Github build] Revert job-runner to Ubuntu 20.04 because of python2 missing
      [Github build] Switch job-runner to Ubuntu 22.04 (without python-dev)
      [Github] Replace deprecated set-output command by environment file
      [Github build] Switch release.yml job-runners also to Ubuntu 22.04 (in line with build.yml)
      [CDN] Update link for Chart.js
      [CDN] Enable overriding CDN urls in Custom.h
      [Adagfx plugins] Improve PLUGIN_READ performance
      [Config] Add option to zerofill Unitnr when appended to Hostname
      [Config] Add missing conditional compile check, minor String improvements
      [Config] Add missing conditional compile check, minor String improvements
      [Commands] Add PostToHTTP command
      [Commands] Add missing documentation for `NTPHost` command
      [WiFi] Workaround Arduino ESP8266 issue, correct TaskExit event generation
      [WiFi] Code optimization
      [WiFi] Correct TaskExit event generation, revert unneeded previous change
      [P042] Reduce size by minifying js scripts, implement jscolor latest updates
      [Markup] Add `id` attribute to input elements for easing javascript support
      [P042] Reformat source using uncrustify
      [Misc] Add RGB2HSV, migrated from P042 (float version)
      [P042] Add Led Count option, more improvements and optimizations
      [P042] Move to PluginStruct for multi-instance use
      [Config] Zero fill unitnr option also disabled in 1M builds
      [Build] Reduce build size by minifying some inlined javascript code
      [Build] Reduce size of embedded css by gzipping it
      [ColorCode] Add PostToHTTP command
      [Config] Revert zerofill option, add %unit_0%, parse sysvars in hostname
      [Docs] Fix typo in PostToHTTP documentation
      [Config] Replace Settings.Name by Settings.getUnitname()
      [Config] Rename getUnitname() to getName() to avoid confusion, fix error that was introduced
      [Config] Update documentation
      [Rules] Accept `if` and `elseif` statements only at the start of a line
      [MQTT] Publish command allow empty payload
      [P067] Add documentation
      [Build] Fix some compiler warnings
      [I2C] Check if I2C device is connected in `PLUGIN_INIT` and `PLUGIN_READ`
      [I2C] Add `I2C_deviceCheck()` to all I2C plugins `PLUGIN_INIT` and `PLUGIN_READ` (if applicable)
      [I2C] Conditionally compile `I2C_deviceCheck()` and exclude from Minimal and ESP8266 Display builds
      [I2C] Conditionally compile `I2C_deviceCheck()` and exclude from Minimal and ESP8266 Display builds
      [I2C] Fix buildsize issues for 1M builds
      [I2C] Rework implementation, separate I2C_GET_ADDRESS from the device check, add setting for Device check
      [I2C] Device check: Update documentation
      [I2C] Add FEATURE flags to Custom-sample.h
      [I2C] Device check: Fix issues and some code improvement
      [I2C] Refactor `getTaskI2CAddress()`
      [I2C] Show task I2C address on Devices page
      [I2C] Fix copy/paste error [P019]
      [P072] Correct typo in calculation, code improvement
      [P030] Remove plugin (BMP280) from repository
      [P077] CSE7766 Add serial GPIO pin configuration
      [P077] Cleanup unused code from source
      [P077] Fix support for ports other than HWSerial0, add calibration commands
      [P077] Add documentation
      [P077] Add safety warning, correct few documentation errors
      [P077] Separate serial0 SERIAL_IN/TEN_PER_SECOND handling, other fixes
      [Build] Simplify the content of the Binaries.zip file
      [Build] Exclude unused `debug` folder from Binaries.zip
      [Build] Replace Espressif flash download tool 3.8.5 by 3.9.3
      [Build] Testing `release` steps in pr build
      [Build] Temporariy reducing the number of envs to improve testing turnaround time
      [Build] Testing `release` steps in pr build, fix typo
      [Build] Temporariy reducing the number of envs to improve testing turnaround time
      [Build] Temporariy reducing the number of envs to improve testing turnaround time
      [Build] Testing `release` steps in pr build, fix script
      [Build] Testing `release` steps in pr build, fix quotes
      [Build] Remove outdated ESP8266-only Flash tools from disrtibution
      [Build] Testing `release` steps in pr build, fix script, add date/time
      [Build] Testing `release` steps in pr build, fix script
      [Build] Testing `release` steps in pr build, fix script, add date & run_id
      [Build] Testing `release` steps in pr build, fix script
      [Build] Testing `release` steps in pr build, improved file filtering, date format
      [Build] Testing `release` steps in pr build, include mega_<date> in zip filenames
      [Build] Testing `release` steps in pr build,  filename tweaks
      [Build] Improve `release` build by creating separate ESP82xx and ESP32 dated archives
      [Build] Restore ESP.Easy.Flasher.exe (ESP8266 usable only)
      [Build] remove undesirable files from ESP32 archive
      [Build] For PR/Push builds repackage Binaries.zip into separate ESP82xx/ESP32 artifacts
      [Build] For PR/Push builds repackage Binaries.zip into separate ESP82xx/ESP32 artifacts, fix typo
      [Build] For PR/Push builds repackage Binaries.zip into separate ESP82xx/ESP32 artifacts, fix typo
      [Build] For PR/Push builds repackage Binaries.zip into separate ESP82xx/ESP32 artifacts, fix typo
      [Build] Remove Binaries artifact after repackaging
      [Build] Restore all build environments to original state
      [Build] Schedule repackage after build step (avoid scheduling delays)
      [Build] Switch actions plugin, add concurrency check for same PR
      [Build] Actions plugin used only checks jobs with a `name` attribute
      [Build] Rename `build-matrix` to `build-all`, test concurrency check
      [Build] Fix typo, test concurrency check
      [Build] Revert waiting for job to complete action, keep concurrency check
      [Scheduled Tasks] Parse correct argument for scheduling
      [P067] Ignore first `PLUGIN_READ` as no data is available yet
      [P067] Update documentation
      [AdaGFX_helper] Parse commands and colors using `GetCommandCode()`
      [P116][P131] Add get_config_value support (from AdafruitGFX_helper)
      [P116][P131] Update documentation
      [P028] Align INFO logging with other plugins
      [I2C] Log error if unresponsive device gets disabled
      [Release] Upload correct files in Binaries artifact

christian-gosse (2):
      Add some log about current conversion channel number
      Correct Handling of end of conversion

flashmark (20):
      Introduce P145 Gasses MQ-xxx
      P145 cleanup, added sensors, start ESP32 support
      P145 Cleanup, update calibrated value
      P145 add [TESTING]
      Rework during review
      Removed P085 & P100 from test setup to free some space P145 Tidy up some comments
      Rollback removal of P085 and P100 exclusion in prwe_custom_esp32.py
      P145 start documentation
      Rework during review rework
      P145 fixes during review P145 updated documentation
      P145 code cleanup,small  GUI changes, documentation updates
      P145 implement lowVcc feature, reduce memory usage, cleanup
      P145 Save some memory
      P145 save some memory
      Removed strings from sensor definition table Added optional heater control for MQ-7 Added new sensor definitions Rework on algorithms
      P145 updated documentation
      P145 small documentation updates
      P145 testing autocalibration
      P145 plugin updates & refactoring
      P145 restructuring and some updates.


-------------------------------------------------
Changes in release mega-20221224 (since mega-20221105)
-------------------------------------------------

Release date: za 24 dec 2022 21:35:00 CET

C.Lee Taylor (1):
      Add comment to P001 for split up

TD-er (39):
      [PIO Build] Remove concat work-around for ESP32 builds
      [PIO] Add all used libraries in lib folder
      [PSRAM] Do not check UsePSRAM but FoundPSRAM
      [Docs] Fix "Validate a RFID tag" example
      [P002] Fix using nr. decimals in calibration
      [Favicon] Fix serving favicon.ico
      [Build] Exclude all ext. RTC code when not enabled in build
      [WiFi] Switch default and alt.WiFi builds for ESP8266
      [LCtech switch] Fix longpulse (#3385)
      [NTP] Fix calling NTP when current time source is ext. RTC
      [Build] Include the 'boards' folder in the source ZIP file (#4274)
      [SendToHTTP] Only include "Authorization" header  when credentials set
      [ESP32 2.0.5.x] Fix crashes calling noInterrupt() in ISR callback
      [Adafruit NeoPixel] Update lib to fix noInterrupts
      [Quad Enc] Fix ESP32 noInterrupts()
      [Docs] Update rules docs not using %eventvalue1%
      [HTTP] Restore Authorization headers used in C011 (#4364)
      [HTTP] Remove check for "Authorization" header
      [ADXL345] Add pitch and roll as derived task values
      [ADXL345] Update min/max values per raw sample reading.
      [Cache Controller] Speedup ESP32 + LittleFS use.
      [Cache Controller] Allow for larger files on large ESP8266 FileSystems
      [Build] Make normal_ESP8266_1M fit max. size again
      [ADXL345] Add output of values in g with self calibration
      [ADXL345] Document new features of plugin
      [LongPulse] Fix recurring longPulse
      [Speedup] Make less calls to LoadTaskSettings as it is slow on ESP32
      [Cache] Fix updating ExtraTaskSettings Cache after it has been modified.
      [Cleanup] Do not call own class functions from constructor/destructor
      [Build] Fix missing #ifdef check.
      [Taskvalue Select] Fix showing taskvalue config for some plugins
      [Taskvalue Select] Fix showing taskvalue config for some plugins
      [PVS Studio] Fix issues reported by PVS Studio
      [Lib] Update to ArduinoJson 6.19.4
      [WiFi] Fix WiFi (re)connect not starting AP immediately
      [WiFi] Fix loop WIFI_STA and WIFI_OFF preventing boot/wificonnect
      [Controller] Allow system variables in controller username
      [ESP32] Fix ECO mode on ESP32
      Fix max. frequencies for various ESP32 SoC's

Ton Huisman (47):
      [Build] Revert Espressif32 framework to 2.0.4.1 to fix NeoPixel/RMT related issues
      [P121] Bugfix for unconnected sensor, correct name-typo, code cleanup
      [P121] Remove obsolete Arduino 1.0 check, use `f` suffix for float values
      [P038] Add initial and max brightness settings and command, update docs, optimizations
      [P121] Add HMC5883L to I2C scanner
      [Build] Update platform to 2.0.5.2, enable PSRAM for 16M8M envs, prepare PSRAM fix config
      [CodeMirror] Add NeoPixelBright command
      [P037] Add JSON sub-attribute support
      [P037] String and memory optimizations
      [P037] Small source cleanup
      [Docs] Add quotes in rules examples for SendTo and SendToHTTP
      Revert "[Docs] Add quotes in rules examples for SendTo and SendToHTTP"
      [Docs] Add quotes in rules examples for SendTo and SendToHTTP
      [P037] Small source improvement
      [P037] Remove unneeded LoadTaskSettings call
      [AdafruitGFX] Fix potential initialization issues
      [Libs] Fix initialization issues
      [PVS] Code improvements and corrections
      [P037] Correct table layout on Configuration page
      [P129] Correct table layout on Configuration page
      [P099] Correct table layout on Configuration page
      [P099] Format sources using Uncrustify
      [P099] Code improvements, small string reductions
      [Command parsing] Non-numeric arguments could return uninitialized data
      [AdaGFX] Fix typo in constructor
      [Build] Deduplicate libs and un-space lib foldernames
      [Build] Add readme.md to lib folder
      [P037] Move device configuration subheader, small uncrustify changes
      [P109] Add Inverted relay-state and Setpoint-delay settings
      [Build] Enable I2C Multiplexer in most ESP8266 4M builds
      [I2CMux] Fix Multiple Channels I2C Multiplexer selection table column widths
      [Metrics] Use default devicename `taskN` when Name is empty
      [Metrics] Show default task number as displayed in the device overview
      [Metrics] Format source using Uncrustify
      [Build] Enable Zabbix controller for Collection builds
      [Rules] Get task settings for use in rules
      [Rules] `settings.controllerN` also check Controller enabled/disabled
      [Rules] Update documentation for task settings variables, fix a few typos
      [Rules] Update ESPEasy ColorCode configuration
      [Rules] Adjust fetching task-controller settings, update documentation
      [Rules] Add String functions `indexOf` and `equals`, with documentation
      [Rules] Improved `indexOf(_ci)` and `equals(_ci)` string function handling, update documentation
      [Rules] Introduce commands `Inc` and `Dec`, update documentation
      [Rules] Update ESPEasy ColorCode config for `dec` and `inc` commands
      [ColorCode] Add missing command for P141
      [Build] Add `COLLECTION F` builds
      [P118] Bugfix for crash during startup

Zafrir Ron (5):
      LCD Rules example
      spelling correction
      Impoved version
      Fix set speed comment
      Fix to asyncevent & speed comment

chromoxdor (23):
      modulo+number is now categorized as number
      [style][layout] css optimizations, values table improvement
      the zero is not necessary i guess
      turns out there is more to remove in the css...
      forgot to minify and embed the css
      removed one sys var wrap and re added  pre tag
      and i forgot to change p021....
      and xmp is out
      Update DevicesPage.cpp
      made the number inputfield better fit (except firefox)
      forgot to change width to max-width
      back to input type=search
      Update Rules.rst
      Update JSON.cpp
      Update JSON.cpp
      Update JSON.cpp
      Update JSON.cpp
      Update JSON.cpp
      Update JSON.cpp
      Update Custom-sample.h
      corrected typo
      update for #4421
      update

jimmys01 (1):
      Move Custom IR related defines in the appropriate file


-------------------------------------------------
Changes in release mega-20221105 (since mega-20220809)
-------------------------------------------------

Release date: za  5 nov 2022 16:15:44 CET

Alex (1):
      Update release.yml

Jason2866 (2):
      Fix boot flash mode
      `opi` flash needs to be flashed in mode `dout`

Max Prokhorov (1):
      Fix github-script v5 breaking change

TD-er (167):
      [Framed OLED] Load/save settings in smaller memory chunks
      [Framed OLED] Reduce memory usage, especially during load/save
      [OLED Framed] Prevent copy of strings when calling some write functions
      [PlatformIO] Do not extend multiple PIO envs
      [PlatformIO] Change src_filter into build_src_filter for PIO 6.0.0
      [PlatformIO] Revert to PlatformIO 5.2.5
      [Cleanup] Reduce build size ESPEasySerial inline functions to .cpp
      Reduce blocking delays in Blynk command
      [Framed OLED] Simplify code to send P036 events
      [GPS] Make a bit more clear the GPS has a fix.
      [LoRaWAN] Reduce build size + more sensible default settings.
      [LoRaWAN] Make RX2 frequency configurable + allow write RN2483 commands
      [LoRaWAN] describe how to reduce nr of OTAA joins
      [ESP32 PN532] Fix reading PN532 on ESP32
      [PN532] Make reading tags non-blocking
      [PN532] Disable Debug code + remove last global variable
      [PN532] Fix switching I2C clock frequency on ESP32
      [I2C] Fix build for ESP8266 (no Wire.end() )
      [Cleanup] Renamed other enums related to PLUGIN_TASKTIMER_IN
      [ESP32 flash mode] Change flash mode board defs to use QIO for ESP32
      [Build] Fix include path + add CircularBuffer to libs folder (#4201)
      [ESP32] Include SPI memory_type in board defs
      [Build scripts] Only show memory_type on ESP32 builds
      [Rules] Fix matching events with first eventvalue being zero (#4198)
      [Rules] Simplify & fix stripping leading zeroes
      [ESP32 flash] Move back to DOUT and DOUT_QSPI
      [SendToHttp] Do not set HTTP authentication when no user/pass set
      [ESP32] Use patched 2.0.4 framework-arduinoespressif32 to fix SPI modes
      [PMSx003] Fix buffer overflow when reading sensor data
      [Build] Include ESPEasy_config.h everywhere
      [Build] Add missing include of Wire.h in ESPEasy_common.h
      [Build] Fix ESPEasySerial build with DISABLE_SOFTWARE_SERIAL defined
      [Build] Explicit ignore SD libraries on "minimal" builds
      [Cleanup] Reduce build size for minimal builds
      [Cleanup] Disable MCP/PCF commands when P009 and P019 not included.
      [Cleanup] Remove MCP/PCF related code when plugins not included
      [Build] Reduce build size reducing ArduinoJSON instances
      [Build] Fix compile time defines strings with spaces
      [Build Version] Generate build version based on date
      [Build] Fix build error due to missed function renames
      [Build] Fix warning when P009 or P019 is not included in build
      [Custom build] Remove #include <Arduino.h> from Custom_sample.h
      [Sysinfo] Add functions to compute runtime ABP and flash frequency
      [Sysinfo] Code cleanup & add Xtal frequency
      [Sysinfo] Fix some code/logic duplication
      [Sysinfo] Fix determining flash mode on ESP32-S2
      [Build] Move include/ESPEasy_config.h to src/include (#4216)
      [Sysinfo] Use FSPI define addressing the SPI bus to the flash
      [SendToHttp] Fix HTTP 401 and 404 error
      [Network Timeout] Apply workaround to set timeout in msec on ESP32
      [Cleanup] Uncrustify _N001_Email.cpp
      [HTTP] Change read timeout into HTTP code 200 when "Ignore Ack" is set
      [SendToHttp] Set timeout to 1000 msec when set to ignore ack
      [Controller] Make timeout dynamic, depending on actual results
      [Controller] Don't make timeout dynamic if ignore acknowledgement is set
      [Git] Add _*Custom.h to .gitignore
      [String] Use .equals for flash strings instead of ==
      [Build] Set ESP8266/Arduino to use actual 'staging' code
      [ESP8266] Change resetmethod to "nodemcu" to fix reset during flash
      [Build] Switch ESP32 board definitions to use DIO mode
      [RN2483] Forward declaration of  functions
      [ESP32 MAX] Fix not defining LIMIT_BUILD_SIZE on MAX builds
      [Build_CDN] Generate CDN prefix URL based on Git tag
      [Build_CDN] Generate CDN prefix URL based on Git tag
      [Build CDN] CDN URL prefix matches checkout tag or  latest tag
      [Build CDN] Serve ESPEasy auto css by default
      [Build] Remove all debug logs when BUILD_NO_DEBUG is set
      [Debug Log] Fix reduces log level combo box with BUILD_NO_DEBUG set
      [ESP ETH] Reset GPIO states before calling ETH.begin()
      [Build] Reduce bin size & merge NodeStruct from ESPEasy-NOW PR
      [Build] Add missing dependency check C013 needs FEATURE_ESPEASY_P2P
      [Cleanup] Minor tweaks to include less code during compile
      [Cleanup] Uncrustify WebServer/RootPage.cpp
      [Cleanup] Remove code duplication + concat function to reduce bin size
      [CSE7766] Fix wrong debug check wrapper P077 (#4248)
      [MH-Z19] Fix executing command for MH-Z19
      [PZEM004T] Fix nullptr dereference (#4251)
      [Build] Reduce build size by doing less flash string conversions
      [Build] Fix missing controllers to ESP32 "Collection" builds
      [Build] Do not (yet)  define USES_ESPEASY_NOW for MAX builds
      [Build] Add FEATURE_RULES_EASY_COLOR_CODE build option
      [ESPEasy p2p] Fix crashes (#4261)
      [GPIO] Fix bug in GPIO command parsing (#4271)
      [Build] Reduce build size for energy and display builds CDN JS/CSS
      [CodeMirror] Fix loading code mirror CSS from filesystem
      [CDN] Serve static files with cache-control from file system
      [build] Disable normal_alt_wifi_ESP8266_1M due to bin size
      [CDN] Cleanup the CDN code
      [CDN] Browser cache  embedded Favicon and CSS
      [Build] Fix build on ESP32
      [CDN] Only load codeMirror files on Rules/Custom page + add Expires
      [CDN] Add Last-Modified header when serving built-in static files
      [CodeMirror] Link JS in the HEAD & don't use defer on those.
      [WiFi] Prevent setting same WiFi mode multiple times
      [SysVars] Fix sunrise/sunset offset (%sunrise-1h%)
      [Build] Reduce build size to make minimal OTA_FHEM_HA fit again
      [String parse] Cleanup formatting transformation function
      [Cleanup] Use roundf or lround where appropriate
      [Build] Reduce build size by removing unneeded pow function calls
      [WiFi] Change Espressif SDK to SDK221
      [WiFi] Prevent reconnect loop
      [WiFi] Check scan results for known candidates
      [WiFi] Make WiFi reconnect more predictable
      [WiFi] Fix WiFi connect timeout handling
      [ADC] Internal ADC plugin reading Vcc on _VCC builds
      [WiFi] Limit WiFi logs on size challenged builds
      [Cleanup] Reduce bin size when using timing stats
      [Commands] Fix accepting invalid commands
      [Factory Default] Fix default settings for SSID2
      [Factory Default] Fix default settings for SSID2
      [WiFi] Reduce time needed to connect to WiFi
      [WiFi Setup] Fix serving CSS on initial WiFi setup
      [Time] Fix check whether real time is set
      [p2p NTP] Update time via p2p node when NTP not set or unreachable
      [p2p NTP] Fix build includes
      [p2p NTP]  Fix applying NTP received from peers
      [p2p NTP] Prevent receiving random data from old ESPEasy nodes
      [p2p NTP] Fix log entry showing correct time source
      [Webserver] Fix strange crashes when serving flash strings
      [GPIO] Add option for longpulse repeat
      [LongPulse] Stop scheduled pulse when setting GPIO + add waveform call
      [Longpulse] Cleanup and document
      [Longpulse] Fix missing includes
      [Dallas] Add option to auto select first sensor found
      [Dallas] Document the new Auto Select Sensor feature
      [Build] Make ESP8266 Collection D VCC fit again
      [Build] Make using ESP8266 Waveform a build feature
      [Build] Disable ext. RTC on limited build size builds
      [Build] Reduce bin size by excluding libs from 1M builds
      [PVS Studio] Fix some uninitialized members found by PVS Studio
      Fix build error
      [Cleanup] Change time wander unit to ppm
      [Dallas] Add DS28EA00 chip (#4292)
      [WiFi] Retry to connect to WiFi when set AP is not reachable
      [Cleanup] Reduce bin size by assigning smaller types to enums
      [Cleanup] Reduce bin size by assigning smaller types to enums
      [Sonoff POW] Do not use volatile ints to check for divide by zero
      [GPS] Fix set system time via GPS
      [GPS] Use custom GPS view of plugin stats data
      [PMSx003] Support I2C UART bridge on ESP32
      [Ext RTC] Fix updating ext. RTC from other sources like p2p nodes
      [Time] Clean up code + show UTC time stored in RTC
      [sunset/sunrise] Fix parsing multiple instances of %sunrise...%
      [Cleanup] Uncrustify ESPEasy_time
      [time] Limit settime update frequency from p2p nodes
      [NTP] Fix prefer NTP over p2p time sync
      [NTP] Make "p2p time sync" only preferred after at least 2 hours.
      [Ext RTC] Round time set to ext. RTC to reduce error to +/- 500 msec
      [time] Reduce time update frequency from the same time source
      [p2p time] Show ESPEasy unit nr used as time source
      [p2p time] Do not use own node as p2p source.
      [Build] Update pygit2 lib to fix GitHub Actions builds
      [Build] Fix missing include
      [SI70xx] Set default I2C address when upgrading using old settings
      [HLW8012] Improve stability and resolution Voltage/Current measurement
      [HLW8012] Don't use double when float will suffice
      [Setup] Fix CSS on setup page + WiFi/Eth event handling
      [Settings] Reintroduce MD5 checksum to prevent saving unchanged settings
      [PlatformIO] Add missing ESP32 ETH envs (energy/display/climate/neopixel)
      [WiFi/Eth] Split handling of WiFi and Ethernet events
      [Eth] Split WiFi and Eth event data + fix static Ethernet IP
      [WiFi] Increase time between WiFi reconnects
      [Ethernet] Restore DNS records for Eth when WiFi turned off
      [Ethernet] Fix restore Eth DNS static IP config
      [Ethernet] Split handling WiFi/Eth event processing
      Reserve ESPEasy-NOW member in SettingsStruct
      [Build] Fix missing include + some define checks

Ton Huisman (332):
      [P118] Make CS pin configurable, resolve some compiler warnings
      [P118] Restructure using Plugin_data_struct, allow 3 simultaneous instances, code reformatted
      [P118] Add library.properties and reference it
      [P118] Use more descriptive names for a few variables/constants
      [P118] Fix missing #define
      [Build] Fix compiler warnings
      [P118] Refactor interrupt handling
      [P118] Attempt to avoid startup crash
      [P118] Attempt to avoid startup crash
      [P118] Add entry to Custom-sample.h
      [P118] Reformat CC1101 library using Uncrustify
      [P095] Add support for extra TFT displays (ILI934x/ILI948x)
      [P095] Reformat sources using Uncrustify
      [P095] String allocation improvements
      [P118] Log optimization
      [P095] Restore accidently lost addLogMove
      [P095] Fix merge issue
      [P095] Make enum values explicit
      [P129] Add 74HC165 input shiftregisters plugin
      [P129] Rename command to ShiftIn, and promote rest of command to second argument
      [P129] Rename plugin, some minor corrections
      [P129] Add documentation
      [P129] Always show formatted output, even when plugin is not active. Rename some arguments
      [P064] Unblock while reading gestures when object is very close
      [P064] Format source using uncrustify
      [P092] DL-Bus: Add support for UVR42
      [P092] Add second digital value for UVR42
      [P092] Add documentation for UVR42, some minor corrections
      [P092] Documentation typo
      [P131] Add plugin Display - NeoPixel Matrix
      [Build] Add ESP32 4M2M NO_OTA configuration
      [P131] Fix IR build issue, initialization of class variables
      [P095] Rename local copy of Adafruit ILI9341 library, initializations
      [P131] Correct invalid initialization in struct
      [P131] Add documentation
      [P095] Updated documentation
      [P045] Add option for detect movement on all/any axis
      [P045] Minor improvements
      [P045] Add plugin documentation, remove invalid documentation file
      [P045] Move descriptions from Device configuration to documentation
      [AdaGFX] Add optional Roboto fonts
      [AdaGFX] Fix typos in #ifdef
      [AdaGFX] Small documentation updates
      [P095] Make Splash at start configurable, docs updated
      [P095] Fix for displaying text on previous location was not overwriting old content Add Text print mode for centered text Extend txtfull subcommand to enable centered text
      [P095] Update documentation
      [Build] Update custom ESP32 NO_OTA_LittleFS build configuration
      [AdaGFX] Add support for `btn` subcommand to draw button-like objects
      [AdaGFX] Improve btn subcommand, slim down bin size, other minor improvements
      [AdaGFX] Add support for confined windows to print/draw in [AdaGFX] Add support for getting config values
      [AdaGFX] Process like template for length and textheight values
      [AdaGFX] Add/update documentation for window commands and config values
      [AdaGFX] Code improvements, initialization, const, move window offset into printText()
      [AdaGFX] Code improvements as suggested by feedback
      [AdaGFX] Correct font include paths, add #ifndef filename checks to fonts
      [AdaGFX] Regression: Background-fill for text should fill entire line height
      [AdaGFX] Re-add some previously missed changes
      [P131] Code optimizations, make splash configurable
      [P095] Implement getconfig feature, code optimization, update documenation
      [Settings] Add PCONFIG_ULONG(n), union with PCONFIG_LONG(n)
      [P131] Fix loading content, implement PCONFIG_ULONG(n)
      [Build] Restore TEST_E builds for ESP and ESP32s2
      [Fix] Complete implementation for changed addFormSelector() definition
      [P129] Optimizations and small fixes
      [Settings] Add PCONFIG_ULONG(n), union with PCONFIG_LONG(n)
      [P129] Implement use of PCONFIG_ULONG()
      [Settings] Replace long by int32_t for PCONFIG_LONG(n)
      [P129] Remove undesirable const declarations
      [Settings] Replace long by int32_t for PCONFIG_LONG(n)
      [P131] Corrections for nullptr, resize and 0 checks
      [P131] Restore delete of matrix object to properly free memory
      [P131] Implement splash without delay()
      [P095] Implement splash without delay()
      [P095] Implement splash without delay()
      [P095] Use ESPEasy-specific ILI9341 extended library
      [P118] Code optimizations
      [P131] Add to NeoPixel builds, make it fit in ESP8266 4M NeoPixel build
      [P064] Code optimizations, remove unused I2C Address selector, adjust documentation
      [P109] Improve binary size and memory use
      [P109] More optimizations, use #defines where appropriate
      [OLedHelper] Add helper with some OLed functions
      [P109] Make plugin multi-instance capable, implement OLed_helper functions
      [P036] Implement OLed_helper to reduce code size
      [P023] Implement OLed_helper to reduce code size, reformat source (Uncrustify)
      [P023] Optimizations, source formatting (Uncrustify)
      [P109] Move deconstruction code to class deconstructor
      [P023] Improved comments to clarify unclear code
      [OLedHelper] Add changeable values argument to OLedFormController function
      [P023] Avoid awkward code construct by using changed OLedFormController
      [P036] Apply changed OLedFormController function
      [P109] Apply changed OLedFormController function
      [P118] Minor code optimizations
      [P110] Replace delay() call, format source, code improvements
      [P110] Disable development logging
      [P111] Format source (uncrustify)
      [P111] Replace delay() calls, format source, code improvements
      [P111] Move reset handling mostly away from 50/sec handler for timing reasons
      [P127] Replace delay() calls, code improvements
      [Build] Enable SD-card support for Display and NeoPixel sets
      [NeoPixel] Add generic power calculation to documentation
      [AdaGFX] Add getTextSize and get/setValidation methods
      [P131] Add horizontal scroll feature, fix clear on exit bug
      [P131] Code optimization
      [P131] Scrolling fixes
      [P131] Documentation updates
      [ILI9341 lib] Extend supported ILI9481 sub-types (CMI7 and CMI8, borrowed from TFT_eSPI)
      [P095] Extend supported ILI9481 display models
      [P095] Update documentation
      [P129] Fix build error, apply code suggestions
      [P128] Fix compiler warning
      [SDcard] Remove unused variable in handle_SDfilelist()
      [P128] Fix compiler warning
      [SDcard] Remove unused variable in handle_SDfilelist()
      [Build] Leave SD-card support out for any NEOPIXEL ESP8266 build to make it fit again
      [P095] Disable unavailable displays (ILI9486/ILI9488)
      [P131] Remove plugin from DISPLAY builds, enable SD-card support for NEOPIXEL ESP32 builds
      [P131] Enable SD-card support for NEOPIXEL ESP32s2 build
      [P131] Add commands for scroll options, update documentation, remove Testing tag, improvements
      [P129] Remove testing tag, update ENABLE_TOOLTIPS to FEATURE_TOOLTIPS
      [P131] Update ENABLE_TOOLTIPS to FEATURE_TOOLTIPS
      [P129] Update ENABLE_TOOLTIPS to FEATURE_TOOLTIPS
      [P131] Update ENABLE_TOOLTIPS to FEATURE_TOOLTIPS
      [P134] Add Distance - A02YYUW sensor
      [P134] Use serialHelper functions where possible
      [P134] Add documentation
      [P008] Reduce iRam usage in ISR
      [P008] Enable Multi-instance use, rename variables, use named setting defines
      [P008] Update documentation
      [P134] Code correction
      [P135] Add SCD4x CO2, Humidity and Temperature sensor
      [Build] Add flag to exclude (unused) debug logging from SparkFun SCD4x library
      [P135] Add documentation
      [P134] Add plugin to Custom-sample.h
      [Docs] Move Serial Helper configuration to separate page and add links where appropriate
      [P135] Rename feature flag, enable selftest and factoryreset for all builds
      [P135] Minor documentation updates
      [I2C] Set default GPIO pins for ESP32 SDA=21, SCL=22
      [P135] Add check for too many mis-readings to stop the plugin
      [P135] Minor documentation updates
      [P135] Add FRC feature, get serial number, update docs, code optimization and improvements
      [P064] Improved handling of errors, remove [TESTING] tag
      [I2C] Set default GPIO pins for ESP32 SDA=-1 SCL=-1
      [I2C] Set default GPIO pins for ESP32 SDA=-1 SCL=-1
      [P129] Fix a bug, improve code and documentation
      [P129] Fix documentation
      [IR] [Build] Enable IR device selection
      [LIB] IRremoteESP8266 updated to v2.8.2
      [IR] Correct some defines for SEND-ONLY protocols
      [Build] Fix extra_scripts environment chaining
      [LIB] IRremoteESP8266 proposed solution for limiting combobox list
      [P016] Limit list of supported protocols to what is actually included in build (proposal), update CustomIR-sample.h
      [P016] Make buffersize configurable, we usually don't need max buffer size
      [P035] Fix list of supported protocols, comment unreachable code
      [P016] Increase default buffersize to 150 to avoid log message for nearly every received code
      [P016] Add feature flag P016_FEATURE_COMMAND_HANDLING to optionally disable command processing
      [SysVars] Add conversion for minutes to hh:mm notation (%c_m2hcm%)
      [P016] Change display/entry of buffer size to bytes instead of unnamed 'units' (2 bytes)
      [P016] Update documentation
      [Rules] Process conversions during rules-matching
      [SysVars] Add string functions timeToMin/timeToSec with docs
      [SysVars] Reduce build size for LIMIT_BUILD_SIZE by disabling timeToMin/timeToSec
      [JSON] Add variables to /json output
      [Build] Upgrade SparkFun MAX1704x to latest
      [P095] Optimize code and reduce string use to make build fit
      [I2C] Improve visibility of I2C Configuration errors, few minor code enhancements
      [I2C] invert bool argument name and value for readability
      [P118] Itho library limit formerly endless loops to max. 3 seconds
      [P118] Fix bugs found during testing, rename variables, clean up source
      [P118] Update documentation
      [P118] Fix bugs found during testing, rename variables, clean up source
      [P118] Fix ESP32 support, shorten lib time-out, improve Devices overview display
      [Devices] Fine-tune display of custom GPIO configuration
      [P116] Add Devices list GPIO overview
      [P118] [Build] Restore Itho communication in ESP32 builds
      [Build] Remove NeoPixel plugins from DISPLAY builds
      [Build] Remove NeoPixel plugins from DISPLAY builds
      [Build] Update documentation
      [Build] Explicitly remove NeoPixel plugins from DISPLAY builds (still in Normal and Collection)
      [IRremoteESP8266] Fix a few wrong-mapped defines
      [P037] Introduce plugin-specific P037_LIMIT_BUILD_SIZE feature flag
      [Build] Have Energy build apply some plugin-specific size-reduction feature flags (P036, P037)
      [Boot] Show binary filename in startup log messages
      [Plugin] Remove obsolete [DEVELOPMENT] tags
      [IRremoteESP8266] Add comments requested by lib maintainers
      [P111] Fix small typo
      [Itho Lib] Merge Orcon functions from #4099
      [P118] Merge Orcon functions from #4099
      [P118] Update documentation with Orcon commands
      [P118] Move plugin to `Collection E` to make the build fit in again
      [P059] Add documentation, migrated from the Wiki
      [Itho Lib] Code improvements as suggested (mostly)
      [P141] Add plugin Display - PCD8544 Nokia 5110 ('migrated' from PluginPlayground)
      [P141] Include in Display builds, add library
      [AdaGFX] Add `txl` subcommand to send multiple lines of text to display
      [AdaGFX] Add documentation for `txl` subcommand
      [P021] Add Auto-save interval option
      [P021] Add Auto-save interval option
      [P021] Update documentation
      [P021] Improved checks to really avoid auto-saving if not needed
      [P021] Fix compilation issue
      [P021] Fix typo
      [P021] Don't restart Auto-save timer after saving settings
      [P021] Extra check to avoid decrementing the timer when not started
      [AdaGFX] Some small improvements and corrections
      [P141] Add Invert display option and matching 'inv' subcommand, several improvements and fixes
      [JSON] Add ESP_CHIP_MODEL and REVISION (ESP32 only) to /json output
      [P135] Remove [TESTING] tag, minor code improvements
      [Lib] Remove unused variable from SparkFun AS7265X library (avoid compiler warning)
      [P111] Small code improvements for size reduction
      [P021] Fix possible issue for GetLevel config value
      [Docs] Split long lines in AdaGFX commands documentation
      [Docs] Update the Commands reference
      [AdaGFX] Implement invertDisplay() used by monochrome displays
      [P141] Improve Inverted display support, code improvements
      [P141] Add documentation
      [P141] Include in Custom-sample.h
      [Hardware] Fix compiler warning about FM_UNKNOWN
      [P135] Fix flash-string ==
      [Bugfix] DevicesPage: ExtraTaskSettings are not always saved
      [P135] Add missing code-comment
      [P135] Change plugin name to include 'CO2', in line with other CO2 plugins, update and corrections for documentation
      [SysVars] Suggested improvement and `timetosec`/`timetomin` code size reduction
      [P109] Optimize code, some deduplication/refactoring
      [UI] Make auto-dark mode optional
      [UI] Make auto-dark mode optional
      [UI] Improved code-semantics
      [UI] Enable Web dark-mode documentation
      [UI] Restore static attribute for css data arrays
      [Tools] embed_files.sh: Use `static` attribute on generated char arrays, force LF line ends for script
      [UI] Device page shows Controller names
      [CSS] Remove no longer needed `esp_auto.css`
      [CSS] Re-add `esp_auto[.min].css`, combining `espeasy_default.css` and `esp_auto_dark.css`
      [UI] Restored `Send to Controller` display, with fixed number display, and Controller name included
      [UI] Make theme selectable: Auto, Light, Dark
      [UI] Rearrange Controller name, checkbox and optional IDX on Devices page
      [UI] Update documentation
      [UI] Change `multi2row` to `multirow tworow` (@chromoxdor), improved `tworow`
      [UI] Apply classes `multirow odd` where previously only `multirow` was needed
      [UI] Replace 'odd' by 'even' class, restoring pre-dark mode multirow style
      [UI] /setup now uses auto-dark mode, Dashboard gets the auto/dark mode from settings
      [UI] Improve template processing, fix partition table in dark mode
      [UI] Fix dark mode display for Chart JS graphs
      [P037] Enable all features for NORMAL builds not using LIMIT_BUILD_SIZE (2M/4M/16M)
      [P037] Disable extra features for ENERGY build for size reasons
      [P037] Update documentation, and some minor corrections
      [Code] Apply PVS-Studio bugfixes and suggestions, 2022-09
      [Code] Use correct Vnnn error codes
      [UI] Correct WiFi bars color (now blue) in /setup
      [UI] Add transparency to WiFi bars not-active color
      [P134] Remove TESTING tag, code improvements
      [AdaGFX] Fix printing partial characters near the right edge of the screen (no linewrap, Window 0 only)
      [P141] Add configurable line-spacing, fix some bugs, code improvements
      [P141] Update documentation
      [Libs] Partially upgrade HeatpumpIR lib to fix PVS reported issue and save space
      [Build] Allow HeatpumpIR in ESP32 Custom_IR builds
      [P131] Fix lines display to start on next tile
      [P141] Reduce build size
      [Build] Minimal OTA Domoticz without HTTP (#4246)
      [Build] Add Minimal OTA Domoticz MQTT builds to restore the HTTP features in previous environments
      [Build] Fix typo in conditional include
      [AdaGFX] Add line-spacing setting, default is backward compatible
      [P141] Remove unneeded color selection options
      [P141] Update documentation
      [Build] Rename feature flag to disable HTTP client
      [P109] Disable in ESP8266 build, some size optimizations
      [P141] Disable SD card support in ESP8266 Display build for size
      [P118] Fix LOG_LEVEL_DEBUG compilation
      [P141] Adjust default plugin settings, update documentation
      [AdaGFX] Fix issue with top pixel when using Col/Row mode
      [AdaGFX] Remove unneeded logging
      [P141] Less preprocessing of commands
      [P045] Minor code size reduction
      [P021] Minor code reduction
      [P110] Rename LOG flags, fix logic for disabling debug log
      [P118] Hide Debug log option from UI when not available, small improvements
      [P127] Use correct build flag
      [P141] Correct line offset, skip empty lines on taskrun
      [P141] Documentation updates
      [P109] Add commands for emulating left, right and mode buttons
      [P141] Enable contrast setting from 1..100% and add 'contrast' subcommand
      [P141] Update and extend documentation
      [P109] Rename commands Left and Right to LeftBtn and RightBtn, some code moved
      [Build] Add CLIMATE configuration and move P118 there with all climate sensors
      [Docs] Update documentation for CLIMATE builds, fix some errors in documentation
      [Build] Fix compiler warnings for signed/unsigned int compare
      [AdaGFX] Allow backlight percentage setting from 0% (instead of 1%)
      [P141] Allow backlight and contrast settings from 0% instead of 1%, updated documentation
      [P141] Also store 'inv' setting when changed via command (not saved)
      [P092] Code optimizations, reduce logging for LIMIT_BUILD_SIZE
      [P075] Increase nr. of lines for commands to send to Nextion
      [P109] Code improvements
      [P109] Fix merge conflict
      [P109] Rename button commands, add title options
      [AdaGFX] Don't trim off spaces from command arguments
      [AdaGFX] Small log improvement
      [Build] Restore Notifiers and other features in normal_ESP8266_4M1M_VCC
      [Build] Fix preprocessor issue
      [Build] Add preprocessor flag NO_LIMIT_BUILD_SIZE
      [P141] Add GET_CONFIG_VALUE support, update documentation
      [OLedHelper] Add OLedI2CAddressCheck() for some de-duplication of OLed plugins
      [P023] Implement OLedI2CAddressCheck()
      [P036] Implement OLedI2CAddressCheck()
      [P109] Change behavior for minimizing saving to thermo<tasknr>.dat, delay relay activation after setpoint change
      [P109] Correct a few bugs, save pending settings, adjust timeout display
      [P109] Correctly un-initialize relay state after enabling/switching task
      [Bugfix] Taskenable,<taskname> wasn't working anymore
      [P109] Add temporary heater delay timing logging
      [Bugfix] P141 PCD8544 Library issue resolutions
      [P109] Solve setpoint update without short interval
      [Formatting] Formatting values doesn't work as intended
      [Checks] Correctly check for obsolete USES_NOTIFIER define
      [Checks] Adjusted comment
      [MAX] Increase plugin list to 140
      [OTA] Initialize Arduino OTA only when enabled
      [Log] Minor logging improvements
      [MAX] Enable I2C Device scan
      [I2C] Some missing I2C devices added
      [P039] Allow GPIO-0 (D3) to be used for CS (Bugfix)
      [Boards] Set additional IDF flag for ESP32s2 (and yet unsupported ESP32c3) boards
      [SPI] 3rd SPI GPIO pin should be output only
      [Boards] Fix IDF version and order of ESP32/s2/c3 checks to get correct GPIO definitions
      [Boards] Move IDF version to platform_core-defs.ini
      [Build] Conditional compilation improvement for CONFIG_IDF_TARGET_ESP32
      [SPI] Corrected pin selection for User-defined SPI (input/output)
      [ESP32] Use patched 2.0.5 framework-arduinoespressif32
      [P095] Add Invert display option for  foreground / background color swap
      [Docs] Add rules example for a b-tree search on a list of Tags
      [P095] Log selected display type during init
      [Docs] Emphasize the use of `%eventvalue%` variables in event-handling rules
      [P037] Bugfix: Enable event generation when adding task
      [Build] Add PSRAM environments for 16M8M
      [Build] Switch to platform-espressif32 2.0.5.2

Zafrir Ron (1):
      Fix CPLIGIN-WRITE to allow controller commands

chromoxdor (56):
      initial codemirror support
      back to local testing
      minor change
      Update espeasy.js
      added minified files
      update
      fixed typo & removed an unintentional easteregg
      each plugin one line
      Forgot to rename variable in anyword
      typo: commonPlugins
      added missing plugin commands + code cleanup
      added all display specific commands
      added , for hinting
      removing duplicates in hints
      nobody except me needs the log
      bit more "root" keywords for faster typing
      maybe better hint listing
      Update anyword-hint.min.js
      changes
      sevenseg fix
      changed css +round buttons
      css update+ round helper buttons
      removed unnecessary css
      changed highlightcolor  + wider column
      fixed to wide input fields
      no rounded corners and green is back
      Update Markup.cpp
      accommodate to windows users
      put back some stuff
      ubbs..i edited the wrong line
      modernized the css
      render table-border on ios devices
      table-border ios fix the 2nd
      added files
      minor changes+ adding automode css files
      resolves minor issue in /setup
      update CM files
      remove unnecessary types
      Update HTML_wrappers.cpp
      added xwide to css, reverted p016 column change
      Update HTML_wrappers.cpp
      Added the tworow class to P016
      no need for two colons
      Add the "ESPeasy Code Editor" to the docs
      Update _P016_IR.ino
      update codemirror files
      Update codemirror.min.js
      better minification
      Css variables update + add P023
      firefox was left out for "normal" rules, removed unnecessary folder
      reposition of codemirror js files + minor css additions
      css fix for textviewer
      it should be height not width :)
      removing height for textarea completely
      re adding max-height
      [P109][Colorcode] added plugin specific commands

fmuntean (9):
      [P014] added support for SI7013 ADC
      [P014] added Datasheet link
      [FIX] updated based on the feedback
      [FIX] reduced the last_measurement_time from 2 places to one; commented all the break; lines
      [FIX] multiple fixes and updates: Init had to be split as delay is required after reset
      [P014] Added documentation
      [Fix] Spelling
      [P014_SI70xx] guardrail all the logging
      [P014] Fixing support for HTU21D with chip_id=50

stefan (2):
      [ArduinoIDE] Make it compile again
      [ArduinoIDE] make it build agian - Fix typo

uwekaditz (37):
      [P036] improvments (line alignment separatly)
      Changes requested by @tonhuisman
      Uncrustify code
      FIX: wrong alignment (only centered) for long, non-scrolling lines
      FIX: wrong pixel calculation for alignment for non-scrolling lines on 64x48 display
      [P036] NEW: individual font settings for each line
      code reduced by 530 bytes to fit the build size for 'esp8266, normal_ESP8266_1M'
      ADD: Setting and support for user defined contrast: oledframedcmd,display,user,contrast,precharge,comdetect
      Copy&paste error
      CHG: Setting for user defined contrast simplified
      NEW: use the split token <|> to split lines into left and right part
      FIX: last frame was not shown
      [NEW] css style xwide
      Documentation updated
      FIX: empty page was shown if just one frame has text
      FIX: empty page was shown if just one frame has text
      CHG: font Dialog_plain_18 is optional (not using LIMIT_BUILD_SIZE)
      CHG: font Dialog_plain_18 is optional (not used with LIMIT_BUILD_SIZE)
      CHG: Logging in [P092] reduced for LIMIT_BUILD_SIZE
      CHG: font Dialog_plain_12 is optional (not used with LIMIT_BUILD_SIZE)
      [P037] Using xWide and html_TD(const String& style)
      P36_MaxFontCount reduced for LIMIT_BUILD_SIZE
      FIX: left alignment again with leading spaces
      NEW: right alignment with trailing spaces
      Update P036.rst
      Update P037_data_struct.cpp
      Reset P037_data_struct.cpp to mega
      [P037] Using xWide and html_TD(const String& style)
      Changes proposed and requested by tonhuisman
      History updated
      Added new sub-table from PR #4239
      CHG: use P036_LIMIT_BUILD_SIZE if PLUGIN_BUILD_IR is defined
      Obsolete code with #ifdef INPUT_PULLDOWN removed
      BugFix for addSelector()
      Conflict resolved
      Conflicts resolved
      CHG: Display timeout is now a uint16_t value (max 65535s for display off)


-------------------------------------------------
Changes in release mega-20220809 (since mega-20220616)
-------------------------------------------------

Release date: di  9 aug 2022  8:58:50 CEST

DMoosh (1):
      Update README.md

Florin (1):
      Notification Page to Display GPIO pins when in use.

TD-er (145):
      [ESP8285] Remove ESP8285 specific builds, detect at runtime (#3848)
      [Provisioning] Add command to download firmware OTA
      [Provisioning] Fix missing includes
      [Build] Fix missing line in .ini file due to merge issues
      [PlatformIO] Update to PIO 6.0.1
      [PlatformIO] Clean requirements.txt files to only the essentials
      [Provisioning] Fix missing include
      [P002 ADC] Move PluginTaskData to separate file
      [ADC] Add binning and multi-point processing of values
      [ADC] Improve binning stability
      [ADC] Speed up formula parsing
      [ADC] Add caching for binning range
      [ADC] Add fields to load/save multipoint values.
      [ADC] Add option to paste many variables at once
      [Cleanup] Small optimizations to reduce bin size
      [Cleanup] Reduce loading controller settings when not ready to process
      [Cleanup] Add function addFormSelector_YesNo to remove code duplication
      [Cleanup] Reduce build size by combining controller queue types
      [Controller Queue] Add missing includes
      [PVS Studio] Fix some hints provided by PVS Studio
      [P073, PVS Studio] Fix bug in font handling for Siekoo display
      [ADC] Fix compiler warnings + remove binning for LIMIT_BUILD_SIZE builds
      [Firmware Download] Fix downloading with no content length set
      [Download] Fix warning signed/unsigned
      [BME280] Allow to take samples using taskRun (#3879)
      [BME280] Clean-up code
      [BME280] Proper handling error states, send error event.
      [BME280] Make TaskError event more useful by adding error string
      [BME280] Update comment to reflect actual behaviour
      [Cleanup] Reduce build size web form functions
      [Cleanup] Reduce bin size deduplicate webform switch plugins (001/009/019)
      [Cleanup] Uncrustify
      [Cleanup] Minor optimizations to reduce build size
      [Static Files] Fix option to local store dev page JS file (#4102)
      [Build] Show proper ESP board name on ESP8266 sysinfo
      [Build] Do not use commas in ESP board name
      [PIO] Update to esp8266/Arduino @ 4.0.1
      [Rules] Disable rules reorder optimization (#4062)
      [MCP/PCF] Small optimization in code to set MCP/PCF pin range
      [2nd Heap] No longer use "2nd heap" on all "beta" builds (unstable)
      [Build] Disable ESP8266 custom beta debug build due to size
      [Cleanup] Apply minor suggestions from PVS Studio
      [PlatformIO] Fix upload size for 16M boards, causing bootloops
      [ADC] Add support for ESP32 ADC factory calibration
      [PlatformIO] Fix boot loop issues on 16M ESP32 boards
      [ADC] Fix building on ESP32-S2
      [Cleanup] Uncrustify Helpers/Hardware.cpp
      [ADC] Fix build on ESP8266
      [ADC] Fix crash when importing older ADC task settings enabling binning
      [ADC] Add charts to show the factory calibration
      [ADC] Hide Factory calibration data + fix build on ESP8266
      [ADC] Add chart axis options (e.g. label)
      [ADC] Add chart to show simulated ADC to output
      [ADC] Add attenuation option for ESP32
      [Cleanup] Remove some unneeded HTML code
      [ADC] Fix building on builds with LIMIT_BUILD_SIZE
      [ADC] Add pseudo task values via PLUGIN_GET_CONFIG
      [ADC] Fix reading + cleanup UI
      [ADC] Add PluginStats to keep history of values
      [ADC] Fix build issue on LIMIT_BUILD_SIZE
      [PluginStats] Add generic statistics for tasks
      [Plugin Stats] Add option for average over last N samples.
      [Plugin Stats] Use task specific error value
      [Plugin Stats] Make Plugin Stats optional per task value
      [Plugin Stats] Add version transitions to ExtraTaskSettings
      [Plugin Stats] Enable Plugin Stats for all plugins with task data
      [Plugin Stats] Show statistics + historic samples on all supported tasks
      [Plugin Stats] Add missing plugins to use the plugin stats too
      [PluginStats] Add build flags USES_PLUGIN_STATS and USES_CHART_JS
      [PluginStats] Exclude PluginStats and ChartJS from NeopixelESP8266 build
      [ADC] Change order of items shown in statistics
      [ADC] Use set nr of decimals for stats
      [Cleanup] Move PluginTaskData_base structs to Pxxx_data_struct.h/.cpp
      [SVG] Revert changes to draw SVG since we're now using ChartJS
      [ADC] Add computed output values for peaks + fix typo
      [ADC] Document new options
      [Plugin Stats] Add stats to plugins to support stats.
      [Docs] Document accessing Plugin Stats
      [Docs] Document typical task setup page and task value stats
      [Plugin Stats] Enable Stats for Sysinfo tasks
      [Plugin Stats] Reduce memory usage when no stats are used.
      [Build] Do not limit build size for custom builds with VCC. (#4129)
      [Plugin Stats] Make labels more clear.
      [Plugin Stats] Fix strange issues PLUGIN_INIT
      [Plugin Stats] Fix editing disabled tasks
      [Plugin Stats] Fix memory leak / low loop count
      [ESP32] Add cache for ExtraTaskSettings due to load speed on ESP32
      [Build] Add apt-get update to build.yml
      [Rules] Fix matching rules with system variables in on...do
      [SendToHttp] Add option to add credentials in the URL
      [Rules] Strip leading zeroes (#4134)
      [Rules] Move logs regarding rules caching to debug
      [Build] Disable ESPEasy p2p for minimal OTA builds
      [sendToHTTP] Use same send_via_http as used in Adv. HTTP controller
      [Cleanup] Reduce build size ESPEasySerial inline functions to .cpp
      [ESP32] Move to Espressif32 SDK 2.0.4
      [ESPEasySerial] Fix case sensitive include
      [ESPEasySerial] Fix incorrect use of `static` for ESP8266
      [SendToHTTP] Add Digest Auth
      [SendToHttp] Clear Basic Auth before using Digest Auth
      [HTTP] Use the same function for all HTTP controllers + fix timeout
      [SendToHttp] Generate event with HTTP return code
      [Web tools] Fix command via Tools page lower case
      [ESP8285] Clearly state absence of separate ESP8285 builds in README.md
      [Download] Update using new HTTP Digest Auth implementation
      [Download] Fix missing include
      [SendToHTTP] Allow to use http:// formatted URL
      [HTTP] Document changes to handling HTTP calls + add follow redirects
      [ADC] Improve factory calibration resolution (ESP32)
      [ADC] Fix Binning
      [ADC] Make multipoint charts more intuitive.
      [ADC] Improve settings UI for Binning + adjust 2-point calibration
      [ADC] Update docs
      [ADC] Update documentation
      [Build] Fix missing #include "ESPEasy_common.h"
      [Build] Remove Notification code when notifiers disabled
      [Build] Move some USES_xxx checks and add missing ESPEasy_common.h
      [Dallas] Fix Dallas 1Wire plugins on ESP32
      [Dallas] Reduce iRAM usage on ESP8266
      [NewPing] Rename library from NewPingESP8266 to NewPing
      [NewPing] Update Library to 1.9.4
      [NewPing] Re-apply ESPEasy specific additions to NewPing library
      [NewPing] Use Direct GPIO access to reduce jitter on ultrasonic sensors
      [DHT] Use Direct GPIO access for DHTxx sensors
      [DHT] Remove timing critical aspects from reading DHT sensors
      [DHT] Remove short calls to delayMicroseconds
      [DHT] Add delay right after waking sensor
      [DHT] Add missing initialization
      [DHT] Fix using correct index when recording timings + comments update
      [DHT] Fix GPIO not yet set to input when DHT wake up.
      [DHT] Fix switching pinMode(INPUT_PULLUP) way too slow
      [Direct GPIO] Reduce iRAM usage
      [DHT] Set the GPIO pull-up resistor explicitly
      [DHT] Forgot to disable logic analyzer debug pin
      Revert accidental commit of pre_custom_esp82xx.py
      [Dallas] Fine tune timings for Dallas sensors
      [Direct GPIO] Fix using GPIO-16 on ESP8266 (#4175)
      [Dallas] Add retry to init read or collect data from temp sensor
      Allow to use leading zeroes on HEX formatted strings
      [ESP32] Move to framework core 2.0.4.1
      [PulseCounter] Make ISR function smaller
      [PulseCounter] Use direct GPIO access to read pin state
      [PulseCount] Enable PluginStats for pulse counter
      [Cleanup] Fix some signed/unsigned warnings
      [Task Settings Cache] Fix save taskValueNames on ESP32

Ton (1):
      libraries/ITG3205: Missing 'paragraph' from library\nITG3205: Missing 'url' from library

Ton Huisman (72):
      [Docs] Add missing Tools/Advanced (Rules) screenshot
      [Docs] Update extensions list for VSCode, remove Atom reference, update some text
      [Docs] Fix some heading level warnings
      [Docs] Update styling contrast, add gray and changed options, Retired plugin category, apply changed where appropriate
      [Docs] Add improved reference to open PIO Terminal
      [Docs] Updates on writing documentation, remove unused Linux pdf generation setup
      [P128] Add Max brightness setting
      [P128] Update documentation
      [P128] Improvements: Rename variable
      [Docs] Procedure for configuring a RTC chip
      [Docs] Add alternatives for RTC configuration, update Rules options after recent change
      [P116] Add support for ST7735 80x160px with inverted color
      [P087] Add 'Serial Config' options
      [P087] Lower minimum baudrate to 300 from 2400
      [Helpers] enable parseString() family of functions optionally to not trim off white-space
      [P087] Don't trim white-space from serialproxy_write command argument so f.e. CR/LF can be used to terminate a message
      [TaskCache] Fix for TaskName not always loaded in cache
      [TaskCache] Simplify code
      [P128] [Build] Make FakeTV effect compile-time optional
      [P128] Update documentation
      [P128] Fix compiler warning
      [P128] Fix typo (it's been a hot day)
      [Build] Rename TEST builds to COLLECTION to reduce confusion about build-names
      [Build] Remove TESTING tag from Stable plugins
      [Build] Remove TESTING tag from Stable plugins, fix some plugin names
      [Build] Update documentation to use COLLECTION instead of TESTING
      [Build] Some documentation improvements
      [Build] Update README.md and fix a documentation typo
      [Build] Change FEATURE_SD to use 0/1 state
      [Build] Change FEATURE_ARDUINO_OTA to use 0/1 state
      [Build] Rename USE_DOWNLOAD to FEATURE_DOWNLOAD and use 0/1 state
      [Build] Rename USE_CUSTOM_PROVISIONING to FEATURE_CUSTOM_PROVISIONING and use 0/1 state
      [Build] Rename USE_SETTINGS_ARCHIVE to FEATURE_SETTINGS_ARCHIVE and use 0/1 state
      [Build] Rename USE_TRIGONOMETRIC_FUNCTIONS_RULES to FEATURE_TRIGONOMETRIC_FUNCTIONS_RULES and use 0/1 state
      [Build] Change FEATURE_I2CMULTIPLEXER to use 0/1 state
      [Build] Rename USES_SSDP to FEATURE_SSDP and use 0/1 state
      [Build] Rename USES_TIMING_STATS to FEATURE_TIMING_STATS and use 0/1 state
      [Build] Rename USE_EXT_RTC to FEATURE_EXT_RTC and use 0/1 state
      [Build] Rename ENABLE_TOOLTIPS to FEATURE_TOOLTIPS and use 0/1 state
      [Build] Fix typo in FEATURE_I2CMULTIPLEXER check
      [Sysinfo json] Fix compilation error
      [Build] Add check for renamed #define variables
      [Build] Rename HAS_ETHERNET to FEATURE_ETHERNET and use 0/1 state
      [Build] Move checks file to CustomBuild folder, move include to ESPEasy.ino to show warnings only once
      [Build] Rename USES_DOMOTICZ to FEATURE_DOMOTICZ and use 0/1 state
      [Build] Rename USES_FHEM to FEATURE_FHEM and use 0/1 state
      [Build] Rename USES_FHEM to FEATURE_FHEM and use 0/1 state
      [Build] Rename USES_HOMEASSISTANT_OPENHAB to FEATURE_HOMEASSISTANT_OPENHAB and use 0/1 state
      [Build] Rename USES_PLUGIN_STATS to FEATURE_PLUGIN_STATS and use 0/1 state
      [Build] Rename USES_CHART_JS to FEATURE_CHART_JS and use 0/1 state
      [Build] Rename USE_SERVO to FEATURE_SERVO and use 0/1 state
      [Build] Rename USE_SERVO to FEATURE_SERVO and use 0/1 state
      [Build] Rename USE_RTTTL to FEATURE_RTTTL and use 0/1 state
      [Build] Rename USE_RTTTL to FEATURE_RTTTL and use 0/1 state
      [Build] Rename USE_I2C_DEVICE_SCAN to FEATURE_I2C_DEVICE_SCAN and use 0/1 state
      [Build] Move checks file to CustomBuild folder, warnings will probably show multiple times
      [Build] Remove unused #define
      [Build] Change FEATURE_MDNS to use 0/1 state
      [Build] Add some missing #define featureflag 0
      [Build] Rename USES_NOTIFIER to FEATURE_NOTIFIER and use 0/1 state
      [Build] Add check for FEATURE_MDNS and USES_NOTIFIER
      [Build] Rename USES_MODBUS to FEATURE_MODBUS and use 0/1 state
      [Build] Rename USE_NON_STANDARD_24_TASKS to FEATURE_NON_STANDARD_24_TASKS and use 0/1 state
      [Build] Rename USES_PACKED_RAW_DATA to FEATURE_PACKED_RAW_DATA and use 0/1 state
      [Build] Rename USES_BLYNK to FEATURE_BLYNK and use 0/1 state
      [Build] Fix typo in USES_BLYNK to FEATURE_BLYNK
      [Build] Change FEATURE_ADC_VCC to use 1/0 instead of true/false, fix issues with test for FEATURE_ADC_VCC active
      [P037] Fix build errors on more/less limited builds, apply uncrustify improvements
      [P037] Fix typo
      [Build] Change FEATURE_REPORTING to use 1/0
      [Build] Change FEATURE_DNS_SERVER to use 1/0 state
      [Build] Correct a few FEATURE_flag checks

dependabot[bot] (6):
      Bump actions/github-script from 4 to 6
      Bump actions/setup-python from 2 to 4
      Bump actions/upload-artifact from 2 to 3
      Bump actions/cache from 2 to 3
      Bump actions/download-artifact from 2 to 3
      Bump actions/checkout from 2 to 3

fmuntean (9):
      Allow sysinfo_json page to be enabled separately from the new Web UI
      add support for: DEFAULT_MQTT_DELETE_OLDEST, DEFAULT_CONTROLLER_MUST_CHECK_REPLY flags
      renamed DEFAULT_MQTT_DELETE_OLDEST to DEFAULT_CONTROLLER_DELETE_OLDEST
      used addGpioHtml
      Feature Flagging FEATURE_ESPEASY_P2P the ESP EASY P2P custom protocol
      [Fix] rename to FEATURE_ESPEASY_P2P
      enabled when PLUGIN_BUILD_CUSTOM  is not set
      [FEATURE_ESPEASY_P2P] enable it by default if not defined
      [Fix] Notification Page to display GPIO

naveen (2):
      chore: Set permissions for GitHub actions
      chore: Included githubactions in the dependabot config


-------------------------------------------------
Changes in release mega-20220616 (since mega-20220427)
-------------------------------------------------

Release date: do 16 jun 2022 21:56:25 CEST

Bartłomiej Zimoń (8):
      [P2P] set default port to 8266, plus warn about port, partly fix for #3982
      [p2p] more defaults
      [p2p] warn about int number equals 0
      [p2p] update text plus check for port on rootpage
      [p2p] update text info
      [p2p] typo
      Update AdvancedConfigPage.cpp
      [p2p] typo of typo of typo

Boris Krivonog (2):
      Should resolve #3531 and #3158.
      Removed invalid (no longer working) url ...

Gijs Noorlander (2):
      [MQTT commands] Support commands with arbitrary argument position
      [MQTT commands] Fix parsing full command

Mateusz Skowroński (1):
      P031 - fix timing for SHT1X

TD-er (198):
      [Provisioning] Allow to fetch config via commands from HTTP server
      [Provisioning] Add factory default defines to ease deployment of nodes
      [Provisioning] Add documentation
      [Cleanup] Missing include in C013
      [Cleanup] Fix return value of gpio_mode_range_helper (real bug)
      [Cleanup] Uncrustify Commands/GPIO.cpp
      [ESP32] Update to IDF 4.4 Arduino-ESP32 2.0.1
      [ESP32] Allow building LittleFS builds on ESP32
      [Build] Fix case sensitive include
      [Windows Build] Convert IRremoteESP8266 to single cpp file
      [IR build] Fix build issue on IR plugins
      [WiFi ESP32] Disable WiFi TX power settings for ESP32 (IDF4.4)
      [ESP32 IDF4.4] Update to the latest Arduino ESP32 2.0.1.1
      [Webserver] Change chunked buffer size to 1360 bytes
      [Web UI] Small tweaks improving speed serving pages
      [Cleanup] Use .clear() on strings instead of assigning empty string
      [Webserver] Fix serving CSS
      [Web] Allow to stream from file system (e.g. CSS inline)
      [ESP32-S2] Add PlatformIO envs for ESP32-s2
      [IR] Cleanup check for redefine IR plugin USES
      Revert "[Windows Build] Convert IRremoteESP8266 to single cpp file"
      [Build] Fix build of ESP32 max LittleFS build on Windows
      [PIO] Simplify ESP32 env definitions.
      [PIO] Simplify WROVER kit envs and remove WROVER kit ETH builds
      [PIO] Add missing ESP32-S2 build envs
      [IDF4.4] Use Tasmota's IDF 4.4 platform-tasmota-espressif32
      [IDF4.4-v2.0.2] Now actually using the latest espressif/Arduino-esp32
      [LittleFS] Make sure to always define USE_LITTLEFS on LittleFS envs
      [PIO build ESP32] Attempt to fix boot loop on ESP32 with IDF4.4
      [Cleanup] Misc optimisations to reduce build size
      [LittleFS] Some cleanup to fix boot loops ESP32 IDF4.4 for 16M flash
      [IDF4.4 + 16M] Make normal builds with IDF4.4 work on 16M flash
      [IDF4.4 + 16M] Restore missing ESP32 builds
      [Cleanup] Make ESP32 PIO envs a bit more readable
      [Cleanup] Split ESP32S2 envs to separate ini file.
      [PIO build] Do not use commas in build_flags (Linux build fail)
      [PIO] fix incorrect esp32 IRExt envs
      [PIO] add labels to envs which wil later adjusted in extends
      [PIO] Use shorter extends chain for ESP32 max builds
      [PIO] Apparently when referring an env, the 'env:' prefix is needed
      [P096 eink] Fix  failing build
      [ESP32 LittleFS] Add old LittleFS library to lib_ignore
      [P118] Disable P118 ITHO for now as it crashes on IDF4.4
      [ESP32 Factory] Fix boot loop on 16M flash nodes using factory image
      [ESP32 factory] Use esptool.py to generate and patch combined binary
      [Build] Add missing esptool==3.2 in requirements.txt
      [ESP32 factory] Revert factory image script to not use esptool.py
      [ESP32 factory] Final fix using esptool.py by Jason2866
      [ESP32 factory] Change -factory.bin to .factory.bin
      [ESP32 factory] using the pio env to find esptool
      [ESP32 build] Restore ESP32 build for 16M1M (using SPIFFS) with Ethernet
      [Libs] Update adafruit/Adafruit BusIO @ ^1.10.0
      [ESP32 IDF4.4] Set CPU frequency to 240 MHz
      [ESP32 Max] Do not use "LIMIT_BUILD_SIZE" on Max builds
      [ESP32 PSRAM] Rename define ESP32_ENABLE_PSRAM to BOARD_HAS_PSRAM
      [Ethernet] Add selector for newer supported Ethernet chips
      [PSRAM] Fix 40 MHz signal on GPIO-17 using Tasmota PSRAM functions
      [Build] Fix build on ESP8266
      [Ethernet] Work-around for bug in IDF4.4 in ETH.linkUp()
      [Cleanup] Fix parameter mismatch floating point formatting String
      [ESP32 IDF4.4] Update to include latest merges
      [PSRAM] Fix incorrect log of found PSRAM
      [Eth] Show state of actual active network device in logs
      [Eth] Power cycle Ethernet device if power pin is defined
      [PWM] Fix PWM and status LED on ESP32 IDF4.4
      [Eth] Add option to autodetect Eth PHY address + documentation
      [ESP32-S2] Disable -flto on ESP32-S2
      Disable -flto on ESP32 due to linker errors.
      [Cleanup] Move defines from Commands/GPIO to DataStructs/PinMode.h
      [ESP32 IDF4.4] Move  to platform-espressif32 v2.0.2.1
      [Bugfix] Fix possible crash when printing floating point values
      [Cleanup] Fix define paths on .h files
      [Cleanup] Fix missing paths on #include statements + update I2Cdev lib
      [I2Cdev lib] Change `byte` to `uint8_t`
      [ESP32] Update to IDF 4.4 Arduino-ESP32 2.0.1
      [ESP32] Allow building LittleFS builds on ESP32
      [Build] Fix case sensitive include
      [Windows Build] Convert IRremoteESP8266 to single cpp file
      [IR build] Fix build issue on IR plugins
      [WiFi ESP32] Disable WiFi TX power settings for ESP32 (IDF4.4)
      [ESP32 IDF4.4] Update to the latest Arduino ESP32 2.0.1.1
      [Cleanup] Use .clear() on strings instead of assigning empty string
      [Web] Allow to stream from file system (e.g. CSS inline)
      [ESP32-S2] Add PlatformIO envs for ESP32-s2
      [IR] Cleanup check for redefine IR plugin USES
      Revert "[Windows Build] Convert IRremoteESP8266 to single cpp file"
      [Build] Fix build of ESP32 max LittleFS build on Windows
      [PIO] Simplify ESP32 env definitions.
      [PIO] Simplify WROVER kit envs and remove WROVER kit ETH builds
      [PIO] Add missing ESP32-S2 build envs
      [IDF4.4] Use Tasmota's IDF 4.4 platform-tasmota-espressif32
      [IDF4.4-v2.0.2] Now actually using the latest espressif/Arduino-esp32
      [LittleFS] Make sure to always define USE_LITTLEFS on LittleFS envs
      [PIO build ESP32] Attempt to fix boot loop on ESP32 with IDF4.4
      [Cleanup] Misc optimisations to reduce build size
      [LittleFS] Some cleanup to fix boot loops ESP32 IDF4.4 for 16M flash
      [IDF4.4 + 16M] Make normal builds with IDF4.4 work on 16M flash
      [IDF4.4 + 16M] Restore missing ESP32 builds
      [Cleanup] Make ESP32 PIO envs a bit more readable
      [Cleanup] Split ESP32S2 envs to separate ini file.
      [PIO build] Do not use commas in build_flags (Linux build fail)
      [PIO] fix incorrect esp32 IRExt envs
      [PIO] add labels to envs which wil later adjusted in extends
      [PIO] Use shorter extends chain for ESP32 max builds
      [PIO] Apparently when referring an env, the 'env:' prefix is needed
      [P096 eink] Fix  failing build
      [ESP32 LittleFS] Add old LittleFS library to lib_ignore
      [P118] Disable P118 ITHO for now as it crashes on IDF4.4
      [ESP32 Factory] Fix boot loop on 16M flash nodes using factory image
      [ESP32 factory] Use esptool.py to generate and patch combined binary
      [Build] Add missing esptool==3.2 in requirements.txt
      [ESP32 factory] Revert factory image script to not use esptool.py
      [ESP32 factory] Final fix using esptool.py by Jason2866
      [ESP32 factory] Change -factory.bin to .factory.bin
      [ESP32 factory] using the pio env to find esptool
      [ESP32 build] Restore ESP32 build for 16M1M (using SPIFFS) with Ethernet
      [Libs] Update adafruit/Adafruit BusIO @ ^1.10.0
      [ESP32 IDF4.4] Set CPU frequency to 240 MHz
      [ESP32 Max] Do not use "LIMIT_BUILD_SIZE" on Max builds
      [ESP32 PSRAM] Rename define ESP32_ENABLE_PSRAM to BOARD_HAS_PSRAM
      [Ethernet] Add selector for newer supported Ethernet chips
      [PSRAM] Fix 40 MHz signal on GPIO-17 using Tasmota PSRAM functions
      [Build] Fix build on ESP8266
      [Ethernet] Work-around for bug in IDF4.4 in ETH.linkUp()
      [Cleanup] Fix parameter mismatch floating point formatting String
      [ESP32 IDF4.4] Update to include latest merges
      [PSRAM] Fix incorrect log of found PSRAM
      [Eth] Show state of actual active network device in logs
      [Eth] Power cycle Ethernet device if power pin is defined
      [PWM] Fix PWM and status LED on ESP32 IDF4.4
      [Eth] Add option to autodetect Eth PHY address + documentation
      [ESP32-S2] Disable -flto on ESP32-S2
      Disable -flto on ESP32 due to linker errors.
      [Cleanup] Move defines from Commands/GPIO to DataStructs/PinMode.h
      [ESP32 IDF4.4] Move  to platform-espressif32 v2.0.2.1
      [Cleanup] Fix missing paths on #include statements + update I2Cdev lib
      [I2Cdev lib] Change `byte` to `uint8_t`
      [EDP32 IDF4.4] Fix merge issues
      [IDF 4.4] Update to platform-espressif32 v2.0.2.2
      Temporary revert move operator on RamTracker
      [MQTT commands] Add command via MQTT with variable parameters
      [IDF 4.4] Update to espressif/arduino-esp32 tag 2.0.3
      [WiFi] Prevent stack overflow when WiFi connection isn't successful
      [WiFi] Properly clear duplicates from WiFi scans
      [WiFi] Fix connecting to the strongest WiFi AP
      [Build] Add missing include in Servo.cpp
      [IDF 4.4] Update to platform-espressif32-2.0.3rc1
      Revert "[IDF 4.4] Update to platform-espressif32-2.0.3rc1"
      [Build] Fix build on display plugins using NodeMCU pin labels
      [MQTT] Reduce rate of MQTT reconnects when failing to reconnect
      [IDF 4.4] Update to latest platform espressif32 zip file
      [Web flash] Let user choose to erase flash or not upon flashing
      [Eth] Fix loosing DNS info when disabling WiFi after ETH got IP
      [ETH] Cleanup unused variable
      [Rules] Fix issues with rules one-liners (#4025)
      [ESP32] Fix PWM on IDF4.4
      [Docs] Fix formatting of C005 OpenHab MQTT documentation
      [MQTT Events] Allow receiving events + eventvalues via MQTT (C005)
      [Provisioning] Cleanup code to manage internal file names
      [Provisioning] Cleanup of no longer needed strings + use RULESETS_MAX
      [Misc] pre-merge small fixes from pending ESPEasy-NOW PR
      [Web] Cleanup code to show MAC address input field
      [MQTT events] Do not add '=' when no eventvalues present + dedup
      [WiFi] Revert accidentally reject SSID < 8 chars
      Access extra GPS values + document setLevel command
      [Tools page] Fix to keep original command instead of showing parsed one
      [ESP32] Update to platform-espressif32-v.2.0.3
      [PlatformIO] Revert to PlatformIO 5.2.5
      [PIO lib_deps] Set Adafruit ILI9341 library version
      [PIO] Make lib_deps multi-line definitions
      [PlatformIO] Change to multi-line lib_ignore
      [PlatformIO] Remove normal_ESP32_16M8M_LittleFS env.
      [PlatformIO] Clean up ini files.
      [PlatformIO] Update to PIO 6.0.1
      [PlatformIO] Clean requirements.txt files to only the essentials
      [PVS Studio] Fix a number of issues reported by PVS Studio (#4066)
      [Sysvars] Add various system variables to hardware info
      [System Variables] Clean-up parsing system variables
      [System Variables] Clean-up to reduce build size for sysvars parsing
      [Build] Fix warnings on unused enums in switch statements
      [Cleanup] Small optimizations to reduce bin size
      [Cleanup] Reduce loading controller settings when not ready to process
      [Cleanup] Add function addFormSelector_YesNo to remove code duplication
      [Cleanup] Reduce build size by combining controller queue types
      [Controller Queue] Add missing includes
      [PVS Studio] Fix some hints provided by PVS Studio
      [P073, PVS Studio] Fix bug in font handling for Siekoo display
      [Cleanup] Various PVS-Studio hints
      [Build] switch case does not (yet) exist in the 'mega' branch
      [PIO] Add build_flags to every intermediate PIO env.
      [PIO] Add lib_ignore to all 1M non-Custom builds
      [Build] Set lib_ignore for all ESP8266 Testing builds
      [Build] Remove test_X_alt_wifi_ESP8266_4M1M_VCC envs
      [MQTT command[ Fix unintended change of MQTT command syntax (#4093)
      [Build] Warnings when building with -Wswitch enabled on ESP32 (#4085)
      [Build] Fix warning of 0x99 not in 'esp_partition_subtype_t'
      [LoRaWAN TTN] Fix serial port selector on LoRaWAN TTN controller
      [ESPEasySerial] Update to 2.0.10

Ton Huisman (56):
      [P128] Migrate NeoPixelBuxFX from playground / djcysmic/NeopixelBusFX
      [P128] Fix ESP32 issues, add config for GPIO pin (only ESP32)
      [P128] Move all code & variables to Plugin_data_struct
      [P128] Initialization improvements, code optimizations
      [P128] Forgot some code-debug
      [P128] Code optimizations, review feedback
      [P128] Small UI fixes while writing documentation
      [P128] Add plugin documentation
      [P128] Add compile-time pixel-type selection #defines
      [Build] Add NeoPixel builds for ESP8266 4M and 1M, ESP32 and ESP32s2 with all NeoPixel plugins
      [Docs] Update documentation to reflect NeoPixel builds, and improved Display and Energy build labels
      [P128] Fix JSON assembly, some bugfixes and code improvements
      [P128] Log optimization
      [P133] Add plugin for LTR390 UV Sensor
      [P133] Add to TEST_E build configuration
      [P128] Doc: Bring command syntax in line with other commands by using commas
      [P128] Fix define clash with library method
      [P133] Add documentation
      [P132] New plugin INA3221 3 channel DC Voltage/Current
      [P132] Add separate Conversion rate setting for Voltage and Current
      [P132] Add documentation
      [P073] Correct endless loop in max7219_ShowTime
      [Build] Move ESP32s2 neopixel build to ESP32s2 pio config file
      [P022] Fix [taskname].gpio,all,n command
      [C002] Handle P029 and P088 as if enabled for this controller
      [Sysvars] Add %systm_hm_0%, %systm_hm_sp%, %systm_hm_am_0%, %systm_hm_am_sp%, %systime_am_0% and %systime_am_sp%
      [Sysvars] Update documentation
      [Build] Include Display plugin-set in ESP32 Display build
      [P007] Add Input mode selection, Enable Analog output, analogout command, updated documentation
      [P007] Fix typo
      [P128] Fix NEOPIXEL_ESP32[s2] build configurations
      [GPIO] Remove unwanted colon from GPIO log
      [P028] Add Error State Value option (BMx280)
      [P028] Minor UI correction
      [P028] Update/overhaul of documentation
      [P028] Set error value -1 for Humidity and Pressure
      [Core] Add support for Error State Values
      [Core UI] Add support for Error State Values
      [P028] Use core Error State Value support
      [P028] Update documentation for Error State Values
      [P028] Minor documentation corrections
      [P028] Reduce codesize
      [P020] Add option to process events without network client connected
      [P020] Fix and simplify saving settings on ESP8266 (was working on ESP32)
      [P020] Add option for processing multi-line messages
      [P020] Scrape off a few bytes from buildsize by disabling some debug messages
      [P020] Improvements for processing multi-line messages, optimize String handling
      [P020] Add some extra checks to avoid crashes because of optimized String handling
      [P020] Improved string parsing for multi-line support
      [Settings] Add PCONFIG_ULONG(n), union with PCONFIG_LONG(n)
      [Build] Restore TEST_E builds for ESP and ESP32s2
      [Fix] Complete implementation for changed addFormSelector() definition
      [P128] [Build] Fix pio config issue, revert NeoPixelBus library to previous version (C++17 compatibility errors)
      [P128] Optimizations
      [Settings] Replace long by int32_t for PCONFIG_LONG(n)
      [P128] [Build] Fix pio config issue missed earlier


-------------------------------------------------
Changes in release mega-20220427 (since mega-20220328)
-------------------------------------------------

Release date: wo 27 apr 2022 16:40:07 CEST

Blazej222 (1):
      Allow OTA attempt even when not enough space

Gijs Noorlander (2):
      [MQTT commands] Support commands with arbitrary argument position
      [MQTT commands] Fix parsing full command

Leonardo Rizzi (1):
      Update _controller_substitutions.repl

Peter Kretz (1):
      Check of x and y against height and width has to be done before

TD-er (49):
      [MQTT commands] Add command via MQTT with variable parameters
      [Build] Make sure to add fs:: namespace to  fs::File
      [Pip] Remove conflicting version limit on semantic-version
      [WiFi] Prevent stack overflow when WiFi connection isn't successful
      [WiFi] Properly clear duplicates from WiFi scans
      [WiFi] Fix connecting to the strongest WiFi AP
      [MQTT] Reduce rate of MQTT reconnects when failing to reconnect
      [Build] Disable test_X_beta_ESP8266 builds due to build size
      [Rules cache] Add handler for speeding up rules parsing
      [Rules] Let the RulesHelper parse line by line
      [Rules] Cache rules per line on ESP32
      [Rules] Only parse lines that need to be parsed
      [Rules] Nesting level does not matter to stop parsing rules file
      [WiFi] Rate limit checking WiFi.isConnected()
      [Rules] Small tweaks to speed up processing rules
      [Rules] Rate limit calls to background tasks
      [Rules] Minor tweaks to improve rules execution speed
      [Rules] Cache which rules lines start with "on " for ESP32
      [Rules] Fix missing include
      [Rules] Add caching to speed up rules processing
      [Rules] Fix build issue on ESP32
      [Rules] Fix build on ESP32
      [Rules] Fix missing include on ESP32
      [Rules] Improve speed processing rules + option to disable rules cache
      [PlatformIO] Update ESP32 PIO platform to 3.5.0
      [Rules] fix parsing events starting with " do"
      [Rules] Add %eventname% and %eventpar% to allow for simpler rules
      Rate limit the number of background task calls to improve speed
      [Timing Stats] Add process_system_event_queue() to the timing stats
      [Rules] Add setting to disable cached event reorder
      [Rules] Allow for more than 4 %eventvalueN%
      [Rules] Document using > 4 eventvalues + using string type eventvalues
      [Rules] Add %eventvalue0% to get all arguments at once.
      [Rules] Fix compiler warning compare signed/unsigned
      [Rules] Check for invalid %eventvalueN% occurences
      [Rules] Add documentation on %eventvalue0%
      [Rules] Allow for empty event values
      [Rules] Add option for default values on non-existing eventvalues
      [Rules] Add 'restrict' keyword to safely allow executing %eventvalueN%
      [Rules] Fix issue when processing eventvalue without default value
      [Rules] Update documentation regarding event values.
      Wrap eventvalues in quotes when needed for generated events
      [Fonts] Only include font data once in built bin file.
      Add Fixme for later reducing IRAM usage on font size struct
      [Cleanup] Remove duplicate code to wrap text in quotes
      [MQT import] Reduce memory usage, especially during load/save
      [Cleanup] Fix tricky PLUGIN_EXIT calls
      [MQTT Import] Unsubscribe from MQTT topics on exit
      [MQTT import] Add log when task cannot unsubscribe as others use it

Ton Huisman (247):
      [P037] Add mapping, filtering and json support - Mapping string to numeric/other string - Filtering to limit processed data - json support to process complex messages
      [P037] Fix build issues (missing include, testing size)
      [P037] Fix some bugs, add filtering with list, some code optimization
      [P037] Bugfixes, improvements, filter per Topic, re-org Device setup
      [P037] Some minor corrections
      [P037] Add documentation
      [P037] MQTT Topic match multi-level standards compliant
      [P037] MQTT Wildcard handling improvement
      [P037] Proceed with invalid numeric value as NaN
      [P037] Code cleanup and improvements, documentation improvements
      [P037] Actually store the NaN value if applicable
      [P037] Adjust for changed compare function
      [P037] Use proper double variables for comparisons
      [P037] Reduce String re-allocations and memory use
      [P037] Additional merge fixes
      [P037] Optimize string handling/passing
      [P037] Source formatting (uncrustify)
      [P037] Disable development logging
      [P037] Add conditional flag to force all features
      [P037] Merge changes for byte to uint8_t change
      [P037] Optimizations and some source reformatting
      [P116] ST7735/ST7789 TFT Plugin and AdafruitGFX helper
      [Build] Add ST7735 library to libdeps for ESP32
      [Build] Fix ST7735 library libdeps for ESP32
      [Build] Fix ST7735 library libdeps for ESP8266
      [Build] Fix ST7735 library libdeps for ESP8266
      [Build] Fix ST7735 library libdeps
      [Build] Fix ST7735 library libdeps
      [Build] Fix Adafruit_ST77xx library libdeps
      [AdaGFX helper] Only compile when used/needed
      [AdaGFX helper] Treat like an optional 'plugin'
      [AdaGFX helper] Fix for custom_ir build
      [AdaGFX helper] Add validation check (optional, if build size permits)
      [P116] Small code improvements
      [AdaGFX helper] Add debug logging to validation check
      [AdaGFX helper] Small improvements
      [P116] Textual changes, only generic type names shown
      [AdaGFX helper] Add color conversions, improved validation and compile-time defines
      [AdaGFX helper] Missed a file for compile-time defines
      [AdaGFX helper] Implement TextPrintMode, get cursor coordinates, fixes
      [P116] Use new features of AdafruitGFX_helper
      [P116] Reorder some device settings
      [P116] Add triggerCmd 'backlight,<percentage>' command
      [P116] Reorder more device settings
      [AdaGFX helper] Corrections and improvements
      [P116] Add default color settings
      [AdaGFX helper] Argument validation corrections
      [Docs] Fix small typo in tools.rst
      [P116] Add documentation, including AdafruitGFX_helper commands
      [AdaGFX helper] Fix a missing conditional compilation check
      [AdaGFX helper] Improve 'clear' command, add 'rot' command
      [P116] Refactor some generic functions to AdaGFX helper
      [AdaGFX helper] [P116] Fix: Restore intended transparent background feature
      [AdaGFX helper] Improvements for compatibility with P095 ILI9341
      [P095] Initial implementation of AdaGFX Helper, work in progress
      [AdaGFX helper] Moved more generic code here, improvements
      [P116] Less conditional compilation, improvements
      [P095] Complete overhaul w. AdaGFX Helper, settings like P116, Use PluginStructs for multi-instance, some work in progress
      [AdaGFX helper] Add/update unicode-char conversions
      [AdaGFX helper] Add/update unicode-char conv, add txz and asciitable commands
      [P116] [P095] Minor update for AdaGFX helper update
      [P116] Documentation corrections
      [AdaGFX helper] Bugfix,apply txp/txz compatibility correction
      [P095] Remove duplicate clear handler
      [P096] Initial implementation of AdaGFX Helper, work in progress
      [AdaGFX helper] Fix typos in unicode character conversions
      [AdaGFX helper] Enable subcmd proc. from template
      [AdaGFX helper] Change subcmd trigger, bugfixes [P095][P116] Allow longer template lines, always process subcmds
      [P095][P116] Improvements in template processing
      [AdaGFX helper] Improvements and corrections
      [P095] Re-order settings, minor improvements
      [P116] Re-order settings, minor improvements
      [P096] Complete overhaul w. AdaGFX Helper, settings like P116, Use PluginStructs for multi-instance, some work in progress [LOLIN_EPD] Update library to support extra devices
      [P037] Reformatted using Uncrustify, string & logging optimizations
      [P037] Fix filter input validation, use string.isEmpty() where possible
      [P037] Small source reformsatting
      [P037] Small improvements
      [P037] Restore required include
      [P037] Reduce info-logging somewhat
      [P037] Fix JSON filtering & resizing bugs
      [AdaGFX helper] Fix color parsing bug
      [P116] Explicitly initialize all ST7789 resolutions
      [P116] Add support for ST7789 240x135 resolution
      [AdaGFX helper] Rename color(depth) enum values
      [P096] Fix compiler warning on 'delete eInkScreen'
      [AdaGFX helper] Add setting for Fill text background
      [P116] Update documentation
      [P116] Simplify initialization
      [P095] Simplify initialization
      [P096] Simplify initialization
      [P095/P096/P116] No 'read' action if all Line fields empty, log Exit, optional splash text
      [P116] Swap resolution for 135x240 display
      [P096] Fixes to Lolin EPD library, fix bg color conversion
      [Lolin EPD lib] Fix class destructor issues
      [Lolin EPD lib] Fix class destructor issues
      [AdaGFX helper][P095][P096][P116] Fix many bugs (init, rotation, destructors)
      [AdaGFX helper] Don't remove trailing spaces
      [P116] Fix displaybutton handling (based on P036)
      [P095] Fix displaybutton handling (based on P036)
      [AdaGFX helper] Move settings to generic functions
      [AdaGFX helper] Fix row/col recalculation on rotation change
      [AdaGFX helper] Restore text-end trimming
      [AdaGFX helper] Add vert. font offset where needed, add 16pt font, include all fonts in MAX builds
      [AdaGFX helper] Fix font issues, add some fonts, remove 1 font
      [AdaGFX helper] Handle proportional font widths correctly
      [AdaGFX helper] Disable fonts used during debugging
      [AdaGFX helper] Bugfix monospaced fonts
      [AdaGFX helper] Fix for fonts with 0-width space
      [P037] Documentation improvements
      [P116] ifdef error fixed
      [Storage] Add optional offset argument to Load/SaveCustomTaskSettings functions
      [P037] Redesigned settings storage req. much less RAM, add topic prefix, bugfixes and improvements
      [P037] Reduce buildsize for DISPLAY builds
      [P037] Update documentation
      pP116] Add support for ST7796, change plugin description
      [P116] Updated documentation
      [P116] Fix typo in include name
      [P116] Fix a typo and removed unneeded comments
      [P037] Disable new features by default, enable all in Custom builds
      [P116] Move from DEVELOPMENT to TESTING, implement PLUGIN_GET_DISPLAY_PARAMETERS function
      [P095] Implement PLUGIN_GET_DISPLAY_PARAMETERS function, cleanup source
      [AdafruitGFX_Helper] Refactorings and minor extensions
      [P096] Implement PLUGIN_GET_DISPLAY_PARAMETERS function and AdafruitGFX_Helper refactoring
      [P095][P096][P116] Definition PLUGIN_GET_DISPLAY_PARAMETERS function
      [AdafruitGFX] Reduce buildsize a bit [P1116] Temporary disable P109 to fit ESP32 Display build
      [AdafruitGFX_helper] Add multi-line subcommand 'lm' for drawing a multi-segment line, incl. docs
      [AdafruitGFX] Add multi-line, relative, subcommand 'lmr' for drawing a multi-segment line, incl. docs
      [AdaGFX] Bugfix with Background fill for text option
      [AdaGFX] Add Color depth selector and generic command-trigger
      [P116] Fix documentation typo
      [P116] Add support for generic command-trigger
      [P095] Add support for generic command-trigger
      [P096] Add support for generic command-trigger
      [AdaGFX] Fix white color recognition for non-full-color colordepths
      [P096] Remove splash compile-time option, some source cleanup
      [AdaGFX] Correct bool argument definition
      [P096] Minor correction missing comma
      [AdaGFX] Correct DisplayTimeout setting not allow negative, and > 255 seconds
      [P116] Refactor displayOnOff
      [P095] Refactor displayOnOff
      [P037] Minor corrections, fix a typo
      [P127] CDM7160 I2C Co2 sensor plugin
      [P127] Add entry to Custom-sample.h
      [P038] Enable multi-instance use
      [P038] Fix initialization order
      [P127] Don't send data during initialization, change status to Testing
      [P127] Fix typo
      [P126] Add 74HC595 Shiftregisters plugin
      [P126] Move plugin to TEST_E set
      [P126] Apply feedback, fix bugs, add SHOW_VALUES and some commands, improve 74hcSetAll for setting multiple output pins
      [P126] Bugfixes, code optimization, hex values display in uppercase
      [P126] Bugfix for display range
      [Lib] ShiftRegister74HC595_NT: Add setSize() method, cleanup constructor
      [P126] Optionally restore State on warm boot, code improvements
      [P126] Add command 74hcSetChipCount for changing the number of active chips at runtime
      [P126] Correct Values display and event generation, disable Formula and Decimals, update Device parameters
      [P061] Enable multi-instance use
      [P061] Add support for PCF8575 16 bit IO expander (and in I2C scanner) [P061] Add support for MCP23017 Direct mode (16 buttons with common gnd) [P061] Add optional dev. logging during read, max. 1x /sec
      [P061] Disable PCF8575 support on LIMIT_BUILD_SIZE builds
      [P038] Resolve code duplications, other optimizations
      [P038] Also support RGBW for NeoPixelLine command (in addition to RGB)
      [P038] Initialize to 0
      [P076] Build: Restore plugin in POW builds
      [P126] Move log before next, unprocessed, argument
      [Docs] Update copyright year in documentation  footer
      [P126] Minor updates and corrections while writing documentation
      [P126] Add documentation
      [P127] Add documentation
      [Docs] Update copyright year in documentation footer
      [P127] Remove build info from screenshot
      [P126] Remove build info from screenshot
      [P038] Add documentation
      [P038] Resolve pin selection FIXME, adjust comments about RGBW support for NeoPixelLine command
      [P061] Add documentation
      [P061] Fix some comment typos
      [P126] Documentation improvements
      [P036] Bugfix: Enable the use of 4-line frames again
      [Build] Disable P109 from DISPLAY build because of build size issue
      [P036] Add linecount subcommand for changing lines per frame
